0.112
-----

Happy 10th Anniversary! Today's release marks 10 years since the
original release of 0.1. After 10 years, hundreds of developers,
thousands of games, and tens of thousands (if not more) of hours of
hard work, MAME development is still going strong. Thanks to everyone
who has supported this project over the years!

To recognize all the work that has gone into the project, this
version's whatsnew includes all the whatsnew reports dating back to
the 3rd release of MAME. Take a good look at the full history of MAME!

Also a big thanks goes out to everyone who has contributed. Although
I am certain there are some people left out of this list, it should
give an indication of just how many people truly care about preserving
arcade history:

Aaron Giles             Acho A. Tang            Adam Bousley
Al Kossow               Alan J McCormick        Alan Kamrowski II
Alessio Manuele         Alex Eddy               Alex Jackson
Alex Judd               Alex Pasadyn            Aley Keprt
Allard van der Bas      Andre Hufschmidt        Andrea Mazzoleni
Andrea Turci            Andreas Naive           Andreas Thorsen
Andrew Caldwell         Andrew Church           Andrew Gardner
Andrew Prime            Andrew Scott            Andrew Seed
Andrew Zaferakis        Andy Conroy             Andy Jones
Andy Welburn            Andy White              Ange Albertini
Angelo Salese           Anssi                   Antoine Mine
ANY                     Arthur Peale            Arzeno Fabrice
Asure                   Atari Ace               Avedis Boyajian

B.S.Ruggeri             Barry Harris            Barry Rodewald
Bart Tobalske           Bart Trzynadlowski      Battlepriest
Ben Bruscella           Ben Rudiak-Gould        Bernd Wiebelt           
BET                     Bladerunner             Blip
bmoto                   bnathan                 Bob Seidel
Bobby Conover           BouKiCHi                Brad Oliver
Brandon Kirkpatrick     Bret Wallace            Brian Crowe
Brian Deuel             Brian Levine            Brian Lewis
Brian Oberholtzer       Brian Stern             Brian Troha
Brian Verre             Bryan McPhail           Bud Crittenden
Buddabing               BUT

CAB                     Cananas                 Canim
Cap                     Carl-Henrik Skarstedt   Carlos A. Lozano
Carlos Santillan        Chack'n                 Chad Hendrickson
Chad Hurwitz            Chaneman                Charles MacDonald
Charlie Miltenberger    Chris Hardy             Chris Kirmse
Chris Law               Chris Moore             Christoff Feldtmann
Christophe Verre        Christopher Stone       ClawGrip
Clay Cowgill            Col Turner              Colin Douglas Howell
Corrado Tomaselli       Costa Sgantzos          Craig Walker
Curt Coder              cutebutwrong            cync

Dan Boris               DangSpot                Dani Portillo
darkcoder               Darren Hatton           Darren Olafson
Darrin Redick           Dave France             Dave Spicer
Dave W.                 David Calandra          David Graves
David Haywood           David Rolfe             David Silva
David Widel             David Winter            deadscreem
Derrick Renaud          Dick Millikan           Dirk Best
Don Maeby               Duddie

Ed Mueller              Eddie Edwards           Edgardo E. Contini Salvan
Edward Massey           EGCG                    ehrhard@csd.de
Eisuke Watanabe         Elestir                 ENGCameraman
Eric Anschuetz          Eric Hustvedt           Erik Ruud
Ernesto Corvi           Eugene Sandulenko       Eugenio De Renzi

F.J. McCloud            f205v                   Fabio R. Schmidlin
Fabrice Arzeno          Fabrice Frances         Fabrice Martinez
Fabrizio Pedrazzini     Farfetch'd              Flatliner
Francesco Caporali      Frank Palazzolo         Fredrik Sjostedt
Fujix

Gamester                Gareth Hall             Gary Walton
gbluma                  Gerald Coy              Gerardo Oporto
Gerrit Van Goethem      Giuseppe Gorgoglione    GMB
Gondos                  Gonzalo Casas           gregf
GreyRogue               Guru

Hans Andersson          Hans de Goede           Hedley Rainnie
Highwayman              Hiromitsu Shioya        HobbesAtPlay
hoot development team   Howard Casto            Howie Cohen
HPMAN                   Hugh McLenaghan

Ian Patterson           Inigo Luja              inkling
insideoutboy            iq_132                  Ivan Mackintosh

J. Rodman               Jake Stookey            James R. Twine
James Rowan             James Wallace           Jarek Burczynski
Jarek Parchanski        Jason Lo                Jason Nelson
JC Alexander            JCK                     Jeff Johnson
Jeff Mitchell           Jeoff Krontz            Jess Askey
Jim Hernandez           Jim Thevenot            Jimmy Hamm
Joachim Bassmann        Joe Magiera             Johan Samuelsson
John Butler             John Clegg              John Dickson
John Dondzila           John IV                 John Wil
Jonathan Lunman         Jose Miguel Morales Farreras
Jose Tejada Gomez       Joseba Epalza           Juan Carlos Lorente
Juddy                   Judge                   Juergen Buchmueller
Julian Eggebrecht       Julien Frelat           Justin Lee Turner
Justin Szczap

Karl Stenerud           Kawaks                  Keith Gerdes
Keith Wilkins           Ken Reneris             Kenneth Lin
Kenneth Miller          Kevin Bales             Kevin Brisley
Kevin Eshbach           Kevin Estep             Kevin Jonas
Kevin Klopp             Kevtris                 Kobat
Kopromaster             Kurt Mahan               

Larry Bank              laugh                   Lawrence Gold
Leandro Dardini         Lee Mitchell            Lee Taylor
Leon van Rooij          Li Jih Hwa              Lodewijk
Logiqx                  Lord Nightmare          Luca Elia
Luigi30                 Luis Faria

M.A.S.H.                M.C. Silvius            Machone
MadSkunk                Malcolm Lear            Malice
MAME Italia Forum       MAME32Plus              MamePlus!
Mamesick                MAN                     Manbow-J
Manfred Schneider       Manuel Abadia           Manuel Assoni
Marc Lafontaine         Marc Vergoossen         Marcelo de G. Malheiros
Marco Cassili           Mariusz Wojcieszek      Mark McDougall
Martin Adrian           Martin Binder           Martin Buchholz
Martin Pugh             Martin Sandiford        Martin Scragg
Martin Searle           Martin White            Massimo Morra
Mathis Rosenhauer       Matthew Conte           Maurizio Clementini
Maurizio Zanello        mbeighau@iies.es        Michael Appolo
Michael Cunanan         Michael Soderstrom      Micheal Schumacher
Miguel Angel Horna      Miguel Figueiredo       Mike Balfour
Mike Coates             Mike Cuddy              Mike Ellery
Mike Haaland            Mike Herrin             Mike O'Malley
MikeJ                   Minuous                 Mirko Buffoni
Mitsutaka Okazaki       Mr. Do!                 Murray Melvin

NAmag                   Nao                     nathan
Nathan Barber           Nathan Sturm            Nathan Woods
Neil Bradley            Nicola Salmoria         Nomax
nono                    Norbert Kehrer          Norix

Ohsaki Masayuki         Oliver Achten           Oliver Bergmann
Oliver Stabel           Oliver Stoneberg        Olivier Galibert
OpenMSX Team            Oshah                   Owen Rubin

Paolo Fiorani           Paolo Venturi           Parodier
Patrick Lawrence        Patrik Styrnell         Paul Forgey
Paul Hampson            Paul Leaman             Paul Priest
Paul Sommers            Paul Swan               Paul Winkler
Peale                   Peo                     Pete Ashdown
Pete Ground             Peter Clare             Peter Hirschberg
Peter Rittwage          Peter Sealy             Peter Storey
Peter Townson           Peter Trauner           Petter Sjolund
Phil Hopely             Phil Stroffolino        Philip Bennett
Pierpaolo Prazzoli      PokeMAME                PongKang

Quench                  quzz                    QWERTY

R. Belmont              Rainer Keuchel          Ralf Willenbacher
Ramsoft                 Randolph                Randy Hoffman
Randy Mongenel          Raney Eden              RansAckeR
Raphael Nabet           Razoola                 ReAnimator
Rene Single             Reznor007               Richard Bush
Richard Davies          Richard Mitton          Rob Bohms
Rob Rosenbrock          Robert Alan Byer        Robert Anschuetz
Robert Flory            Robert Gallagher        Roberto Fresca
Roberto Gandola         Roberto Ventura         Robin Merrill
robiza                  Rodimus Prime           Roger Sanders
Roman Scherzer          Ron Fries               Ruben Panossian
Runik                   Russell Nash            Ryan Ahn
Ryan Holtz              RYO

Sal Bugliarisi          Samuele Zannoli         Santeri Saarimaa
Satoshi Suzuki          Sawat Pontree           Scott Brasington
Scott Kelley            Sean Gugler             Sean Riddle
Sean Young              Sebasten Hegon          Sebastian Ojeda
Sebastien Chevalier     Sebastien Monassa       Sebastien Volpe
sedn                    Shane Monroe            Shaun Stephenson
The Sheep               Shica                   ShimaPong
Shin Emu Keikaku team   ShiRiRu                 siftware                
SilverFox               Simon Walls             Simon White             
smf                     Smitdogg                Sonikos
Special LIU             Stefan Jokisch          Stefan Lindberg
Stefano Mozzi           Stefano Teso            Stephan Cecchinel
Stephen Behling         stephh                  Steve Ellenoff
Steve Rice              Steve S.                Steven Frew
Steven Hugg             sthief                  Stuart Campbell
Suppi-Chan              Svante Gerhard          Sylvain Glaize

Taiwan                  Takahiro Nogi           Tatsuyuki Satoh
Taucher                 Team Japump             Thierry Lescot
Thomasz Slanina         Thorwak                 Tim Cottrill
Tim Lindner             Tim Lindquist           Tim Schuerewegen
Tirino73                Toby Broyad             Tom Girardot
Tom McClintock          Tomas Karlsson          Tomasz Slanina
Ton Brouwer             Toninho                 Tormod Tjaberg
Torsten                 Toshiaki Nijiura        Trinity
Twisty

Uki                     Uncle Tom               unzu
uRebelScum              

Valerio Verrando        Vas Crabb               vernimark
Vernon C. Brooks        VGR                     Victor Trucco
Ville Laitinen          Ville Linde             Vince Mayo
Virtu-Al

Weisse Eins             Wiebo de Wit            Wilbert Pol
William Krick           wolf676                 Wolfi
wpcmame                 wwtk@mail.com

XingXing                xvi

Yasuhiro Ogawa          Yochizo                 yong
Yves Colombani

Zerza                   Zonn Moore              Zsolt Vasvari



MAMETesters Bugs Fixed
----------------------
debug_assertions0111u6ora [Aaron Giles]
z80update0111u6red [David Haywood]
memory_leak0111u6ora (partial) [Oliver Stoneberg]
crosshair0111u5gra [Canim, Aaron Giles]
renegade0111u4red [Aaron Giles]
subs0111u6yel [Aaron Giles]
ddraweffect0111yel [Aaron Giles]



Source Changes
--------------
Fixed popping in Berzerk speech. [Lord Nightmare]

Added osd_rmfile to the osdcore, replacing calls to remove().
[Nathan Woods]

Cleaned up a number of drivers that were using malloc from within
DRIVER_INIT to use malloc_or_die instead. [Atari Ace]

Fixed memory leak with -wavwrite switch. [Oliver Stoneberg]

Updated Tempest to support second player controls. [stephh]

Updated the dooyong driver to use the new-style banking system. Also
added some preliminary save state support. [Vas Crabb]

Some improvements to pmpoker.c: [Roberto Fresca]
 - Crystal documented via #define.
 - CPU clock derived from #defined crystal value.
 - Replaced simulated colors with proper color prom decode.
 - Cleaned up the driver a bit.
 - Updated color PROMs

Some improvements to funworld.c: [Roberto Fresca]
 - All crystals documented via #defines.
 - All CPU and sound clocks derived from #defined crystal values.
 - Added DIPLOCATIONS to all games.
 - Added proper tsc87c52 MCU dumps to monglfir and soccernew.
 - Modified the refresh rate to 60 fps.
 
Fixed SCSP DSP RAM initialization. [R. Belmont]

Improved decryption of MC8123-0054 based on a new dump.
[Nicola Salmoria]

Fixed Moon Patrol scrolling so that it matches the schematics.
[Chris Hardy]

Proper implementation of noise generator in the Exidy/Berzerk sound
circuit. [Lord Nightmare]

Fixed toaplan2.c driver to add controls for player 3 in 'fixeigh*' 
(of course, main set - 'fixeight' - still remains unplayable).
[stephh]

Added DIP locations to the arabian driver. [Roberto Fresca]

Fixed random dots in Columns '97 graphics. [Mariusz Wojcieszek]

Added DIP locations to wwffest, ninjaw, and itech32 drivers.
[Brian Troha]

Rewrote faux x86 assembly in the Irem GA20 sound core. [R. Belmont]

Improvements to the Cidelsa driver. [Curt Coder, David Haywood]

Minor cleanup to the 8039 disassembler. [Nathan Woods]

Improvements to the sslam driver: [Quench]
 * corrected the music sequencing simulation of the sound controller 
    in SSLAM based on poking a real board Guru kindly provided.
 * added save state support
 * added DIP locations
 
Fixed crash in cybrcomm due to missing ROM. [R. Belmont]

Changed alpha blending code to use multiplies instead of table
lookups to simplify it. [Aaron Giles]

Cleaned up some poorly written code in konamiic.c; there is still
much work to be done here, but it fixes the GX sprites. [Aaron Giles]

Removed linear interpolation from the BSMT2000 by default since the
original chip did not do interpolation. [Aaron Giles]



New games added or promoted from NOT_WORKING status
---------------------------------------------------
Teeter Torture [Aaron Giles]
Hyper Street Fighter 2: The Anniversary Edition [Nicola Salmoria]
Lady Master of Kungfu [Juddy]
Destroyer (Cidelsa) [Curt Coder]
Witch [Tomasz Slanina]



New clones added
----------------
Double Dragon (US Set 2) [Corrado Tomaselli]
Golden Poker Double Up (Mini Boy) [Roberto Fresca]
Pool 10 (Italia, set 2) [Roberto Fresca]
Mighty! Pang (USA 001010) [David Haywood, Charles MacDonald]



New games marked as GAME_NOT_WORKING
------------------------------------
Wyvern Wings [Pierpaolo Prazzoli]
Alpha One (Vision Electronics / Kyle Hodgetts) [Gareth Hall]
Cash Quiz (Type B, Version 5) [Chris Hardy]



==========================================================================

0.111u6

Source Changes
--------------

Fixed the data fetch and scrolling calculation for almost all video 
modes in the Amiga driver. [Ernesto Corvi]

Emulated the trench circuit in Space Encounters. [Adam Bousley]

Added win_output_debug_string_utf8(); a UTF-8 wrapper for
OutputDebugString(). Changed code to use it. [Nathan Woods]

Fixed the disassembly, operation, and cycle timing of many Thumb 
instructions in the ARM7 core. [MooglyGuy]

Defined new osd core function osd_is_absolute_path(). Changed behavior
of core fileio so that absolute paths are identified and search paths
ignored in that case. [Nathan Woods]

Improved validity check for coinage order so that it prints out the
correct order if an error is detected. [Ernesto Corvi]

Fixed clocks and other details in Dream World based on new
measurements. [David Haywood, Guru]

Implemented video circuits in the Midway 8080 driver based on
schematics. Note that this affected the visible area, so overlays will
need to be adjusted. Standardized the visible area across all games.
Implemented Phantom II cloud generator. [Zsolt Vasvari]

Changed the contract of the tilemap_create() call so that it is
guaranteed to succeed or die trying. Cleaned up code paths that 
checked the result of this operation to be simpler as a result.
[Atari Ace, Aaron Giles]

Added preliminary support for the built-in effects DSP in the SCSP, 
which lots of games use for reverb, QSound, and other effects. 
[ElSemi]

Removed archaic i8080_EXACT flag from the 8085 core. [Zsolt Vasvari]

Updated Midway 8080 driver to use properly computed video timings and
scanline interrupts. [Zsolt Vasvari]

Fixed assertion in MPU4 driver. Fixed the mechanical meter operation,
enabling coin entry in Connect 4. [James Wallace]

Added mappings for break and pause keys. [Dirk Best]

Incorporated changes to MESS CPU cores to fix asserts and improve
Z80GB emulation. [Nathan Woods, Wilbert Pol]

Correctly connected sound IRQ in GX400/Nemesis driver. [R. Belmont]

Rewrote the SN76477 emulator from scratch. The main difference between 
the old one and the new one is that it is based on measurements from a
real chip. Also the emulator is fully analog, meaning that 
timings/frequencies, etc. are based on voltage levels. This gives a 
much more true-to-life emulation where the weird behavior of the real 
chip comes emulated for free. The code itself is also a lot simpler 
and more understandable. [Zsolt Vasvari, Derrick Renaud]

Cleaned up stray variables from the crosshair drawing removal. Also
removed some orphaned function declarations. [Oliver Stoneberg]

Added the missing volume and frequency controls to the Berzerk driver
and s14001a core. Fixed the issue with random words being spoken 
instead of the proper ones. Word is now latched at the proper time.
[Lord Nightmare]

Implemented flickering of the strobe light in Space Encounters, to be
eventually connected with artwork. [Zsolt Vasvari]

Changed driver_add/find/remove functions to fatalerror if they cannot
find their targets. [Aaron Giles]

Added support for screenless drivers. [Aaron Giles, Nathan Woods]

Fixed a couple of errors introduced in the OKI6295 pin shuffling.
[David Haywood]

Cleaned up DIP switches and added documentation to the Outrun driver.
[Brian Troha]

Fixed sound clock frequency in the NMG5 driver. [Brian Troha]

Fixed sound clock frequency in Night Slasher. [Sonikos]

Updated Sega System 16/18 drivers to be mono, and swapped button 1/2
to match instruction card. [Corrado Tomaselli]

Moved some of the tool sources to a new subdirectory tools.
[Aaron Giles]

Tweaked the main makefile to better support parallel builds.
[Aaron Giles]

Removed line array from mame_bitmap. Converted dozens of drivers over
to using BITMAP_ADDR macros instead. [Aaron Giles]

Changed automatic crosshairs so they are not quite so automatic.
They now need to be explicitly specified by the driver in the input
ports. Also changed the PORT_CROSSHAIR macro to take a shorter form
of the axis name. Updated all lightgun drivers to have this macro in
its default state. [Aaron Giles]

Added sliders for debugging crosshair positioning (debug build only).
[Aaron Giles]

Changed xevious to use irq0_assert_line instead of irq0_pulse_line
to prevent it from dropping interrupts. [Aaron Giles]

Changed Gorf to use HOLD_LINE instead of PULSE_LINE for scanline
interrupts. The timing is still off, but the game runs now.
[Aaron Giles]

Fixed time H/V position reporting during the first frame of execution
using the new video routines. [Aaron Giles]



New games added or promoted from NOT_WORKING status
---------------------------------------------------
Magical Tetris Challenge [Ville Linde]
Star Soldier: Vanishing Earth [Ville Linde, Guru]
Vivid Dolls [Ville Linde, Guru]
Connect 4 [James Wallace]
Martial Masters [MooglyGuy]
Knights of Valour 2 [MooglyGuy]



New games marked as GAME_NOT_WORKING
------------------------------------
Super Real Mahjong VS [Ville Linde, Guru]
Tower & Shaft [Ville Linde, Guru]


==========================================================================

0.111u5

MAMETesters bugs fixed (there are probably more)
-----------------------
bitmapalloccore0111u4red [Aaron Giles]
8080bw0111u4red [Zsolt Vasvari]
sidvoice0111u4ora [Nathan Woods]
pyramid0111u4red [James Wallace]
dragngun0111u3gra [Canim]
mitchelc0111u3gra [Luigi30]
lockload0111u3gra [Canim]
cobracom0111u3ora [Canim]


Source Changes
--------------

Fixed a 6502 register naming bug, and fixed a size bug in the
SC61860 disassembler. [Nathan Woods]

Added built-in overlay layout for Crash. [Mr. Do]

Added save state support to Gyruss. [Buddabing]

Fixed missing sound interfaces from the MESS sound core merge.
[Nathan Woods]

Fixed several duplicated global variable names, removed unreferenced
items from header files, and added header files for several drivers.
[Atari Ace]

Changed debug console code to use auto_malloc and to detect attempts
at registering callbacks after initialization time. [Nathan Woods]

Fixed kof2003 bootleg code to work on big-endian systems. [R. Belmont]

Centralized some common Windows utility routines in new module
winutil.c. [Nathan Woods]

Cleaned up a few drivers to use input_port_dword_*_r. [smf]

Cleaned up memory maps in the MPU4 and BFM drivers. Redesigned the 
MPU4 code so that the DRIVER_INIT only needs to take an address in 
the ROM for the lookup table for CHR generation to be done.
[James Wallace]

Updated built-in expat code to version 2.0. [Atari Ace]

Fixed sound samples in Indian Battle. [Zsolt Vasvari]

Added state saving to mhavoc. Also fixed sparkling vectors so 
slowdowns and vector list overflows can be expected. It looks much 
nicer, though. [Mathis Rosenhauer]

Removed XORs from almost all CPS2 games in place of proper emulation
of the encryption. [Nicola Salmoria]

Added an assertion to prevent usage of pia_set_input_[a|b]() when 
input reading callbacks are specified. [Nathan Woods]

Fixed flip screen switch and changed COIN3 to SERVICE1 in the contra.c
driver. [Canim]

Cleand up and fixed DIP switches and inputs for the nmg5 driver.
[stephh]

Rewrote Z80 interrupt handling to avoid a bad bug in the post-EI
interrupt signalling. [Aaron Giles]

Added documentation to the esd16, afega, cave, unico, vamphalf, and
yunsun16 drivers. [Brian Troha]

Changed behavior in chdman so that a 0 sector size means the default.
[Aaron Giles]

Updated several video drivers (amiga, n64, ppu2c0x, psx, stvvdp2,
tia, v9938) to use the new BITMAP_ADDR* macros instead of using the
line[] array. [Nathan Woods]

Some additional Midway 8080 B&W driver fixes: [Zsolt Vasvari]
 - added PORT_CONDITION where needed
 - added PORT_CONFNAME entries to the 3 baseball games and Space 
    Invaders
 - save state support for all games
 - fixed typo and a bug with the Sea Wolf lamps

Fixed a minor problem with sound clipping in the s14001a.
[Lord Nightmare]

Fixed PRNG noise in the TMS5110/5220 code and added signal wrapping
to match the patent. [Lord Nightmare]

Cleaned up usage of auto_bitmap_alloc() now that it is guaranteed not
to fail. [Aaron Giles, Atari Ace]

Added sound effects emulation to the Berzerk driver. [Aaron Giles]

Fixed font aspect ratio on non-1:1 resolutions. [Aaron Giles]

Added mechanism to cache a binary format of BDF fonts for improved
loading speed. Also added a bit of progress when loading huge BDF
fonts so that you know what's happening. [Aaron Giles]

Removed gross TMS9928a configuration in place of more standard
techniques. Updates the Cliffhanger and sg1000a drivers accordingly.
[Aaron Giles]

Added support for the custom Badlands commands to the LD-V1000
emulation. [Aaron Giles]



New games added or promoted from NOT_WORKING status
---------------------------------------------------
Dream World [David Haywood, Guru]



New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Multi 5 / New Multi Game 5 (Earlier) [Brian Troha]
Bubble Bobble (bootleg with 68705) [David Haywood]
Super Street Fighter II (World 930911) [Nicola Salmoria]
Super Street Fighter II (Japan 930911) [Nicola Salmoria]
Dungeons & Dragons: Tower of Doom (Euro 940113) [Nicola Salmoria]
Super Street Fighter II Turbo (USA 940323) [Nicola Salmoria]
Armored Warriors (Euro 941024) [Nicola Salmoria]
Alien vs. Predator (Hispanic 940520) [Nicola Salmoria]
Cyberbots: Fullmetal Madness (Euro 950424) [Nicola Salmoria]
Marvel Super Heroes (Euro 951024) [Nicola Salmoria]
Marvel Super Heroes (Japan 951117) [Nicola Salmoria]
Marvel Super Heroes (Brazil 951117) [Nicola Salmoria]
Vampire Hunter: Darkstalkers' Revenge (Japan 950307) [Nicola Salmoria]
Street Fighter Alpha: Warriors' Dreams (Euro 950627) [Nicola Salmoria]
19XX: The War Against Destiny (Japan 951225) [Nicola Salmoria]
Dungeons & Dragons:Shadow over Mystara (Euro 960223) [Nicola Salmoria]
Dungeons & Dragons:Shadow over Mystara (Euro 960208) [Nicola Salmoria]
X-Men Vs. Street Fighter (Euro 961004) [Nicola Salmoria]
Capcom Sports Club (Hispanic 970722) [Nicola Salmoria]
Marvel Super Heroes Vs. SF (Euro 970625) [Nicola Salmoria]
Marvel Super Heroes Vs. SF (Japan 970625) [Nicola Salmoria]
Marvel Super Heroes Vs. SF (Hispanic 970625) [Nicola Salmoria]
Marvel Super Heroes Vs. SF (Brazil 970827) [Nicola Salmoria]
Marvel Super Heroes Vs. SF (Brazil 970625) [Nicola Salmoria]
Vampire Hunter 2 (Japan 970929) [Nicola Salmoria]
Vampire Savior (Hispanic 970519) [Nicola Salmoria]
Marvel Vs. Capcom (Euro 980112) [Nicola Salmoria]
Marvel Vs. Capcom (Asia 980123) [Nicola Salmoria]
Marvel Vs. Capcom (Hispanic 980123) [Nicola Salmoria]
Marvel Vs. Capcom (Brazil 980123) [Nicola Salmoria]
Street Fighter Alpha 3 (Brazil 980629) [Nicola Salmoria]
Street Fighter Zero 3 (Asia 980904) [Nicola Salmoria]
Vs. Super Mario Bros. (alt) [Lord Nightmare]



New games marked as GAME_NOT_WORKING
------------------------------------
Two Minute Drill [David Haywood]
Super Don Quix-ote [Ernesto Corvi]


==========================================================================

0.111u4

MAMETesters bugs fixed (there are probably more)
-----------------------
simpbowl0110u2yel [R. Belmont]
arcadiac0111u3yel [Ernesto Corvi]
mcatadv0111u3gre [David Haywood]
photoy2k0111u3yel [Aaron Giles]


Source Changes
--------------

Added support for the Pioneer PR-8210 laserdisc player.
[Ernesto Corvi]

Added two new convenience macros for input ports: PORT_DIPUNUSED and
PORT_DIPUNUSED_DIPLOC. [stephh]

Updated DIP switches in the cave driver and added locations. [stephh]

Improved DIP switches in sbrkout and converted "fake" DIP switches
into configuration switches. [stephh]

Improved DIP switches in Zero Hour. [Mike Ellery]

Added DIP locations to the m90 driver. [Brian Oberholtzer]

Unified the Forgotten Worlds driver with the cps1 driver and
connected the OKI6295 pin control properly. [David Haywood]

Modified the makefile to make it possible to independently specify
symbols generation and optimization levels. [Atari Ace]

Fixed system time counters in the Amiga code. [Ernesto Corvi]

Major rewrite of the Midway 8080 black & white driver, separating it
from the huge 8080bw driver and making the following changes:
[Zsolt Vasvari, Derrick Renaud]

  - 'True-to-hardware' emulation of the shifting circuits
  - Identified and stubbed sound triggers
  - Fixed DIP switches, where necessary (most games)
  - Added DIPLOCATION to all switches
  - Added watchdog
  - Added coin counter
  - Added lamp outputs to Sea Wolf, Guided Missile, Space Encounters,
     Phantom II, Bowling Alley
  - Added stereo sound to Gun Fight, Guided Missile, M-4
  - Partial sound emulation in Tornado Baseball, Boot Hill,
     Desert Gun, Double Play, Dog Patch, Blue Shark
  - Properly emulated shifter circuit in Boot Hill
  - Added gun recoil output to Desert Gun
  - Added second set of analog controls to Clowns
  - Fixed analog controls in Dog Patch
  - Added SN76477 sound effect to Space Encounters
  - Added non-memory mapped coin counters to Space Invaders,
     Blue Shark, and Space Invaders II
  - Added proper watchdog times to all the games
  - Breadboarded the noise clocks and ensured their frequencies
     were correct

Added support for the lamp matrix to the video callback in the 
Scorpion 2 driver, and updated lamps and inputs to better fit the 
new UI. VFD support has been moved to a configuration switch, as 
the output is actually always occurring - the switch mimics the 
effect of plugging in or removing the VFD from the control point.
[James Wallace]

Improved sound output in the MediaGX driver. [Ville Linde]

Preliminary emulation of the TSI S14001A speech synthesizer as found 
in Berzerk/Frenzy (and also Stern pinballs).
[Lord Nightmare, Kevtris, R. Belmont]

Added missing linescroll effect to Magical Cat Adventure and 
Nostradamus. It can be seen in action on the first levels of both 
games. [David Haywood]

Minor cleanup of mind-bending codce is the konamigx driver.
[R. Belmont]

Fixed crash in the Sega System 24 driver. [David Haywood]

Added a validity check that input port names are valid UTF-8 strings.
[Nathan Woods]

Improved DIP switches in the tumbleb.c driver. [stephh]

Added a large update to the legionna driver with much more 
documentation on the protection and other updates. [Angelo Salese]

Added cdp1869 video emulation to the Cidelsa driver. The games still 
don't work due to timing and interrupt issues. [Curt Coder]

Fixed crash in Tao Taido driver. [David Haywood]

Made suprnova RLE rendering safe from out-of-bounds accesses.
[David Haywood]

Many improvements to the Midnight Landing driver, including partial
sound, partial video emulation, and controls. Still not working,
though. [Tomasz Slanina]

Fixed TMS9928 so it recalculates the pattern mask when its 
dependancies change so we don't end up in weird half-modes.
[R. Belmont]

Added support in the user interface to render all text assuming it is
UTF-8 encoded. This means that UTF-8 encoded Unicode names can be
used in in-game descriptions, etc. But first you will need a unicode
capable BDF font. [Aaron Giles]

Removed Vista build hacks from windows.mak as they are no longer
necessary. [Aaron Giles]

Removed hacky use of the 'depth' field of mame_bitmaps. Bitmaps are
now allocated with an enumerated 'format' instead. This is internally
translated into bits-per-pixel in a normalized way. Also removed 
Machine->color_depth, which was often misused. [Aaron Giles]

Added new macro BITMAP_ADDR that can be used for addressing into
bitmaps. Removed the use of bitmap->line[] in the core code. The 
line[] array will eventually be obsoleted, so stop using it.
[Aaron Giles]

Changed operation of plot_pixel, read_pixel, and plot_box. The first
two are now inline functions and the latter just maps to fillbitmap
via another inline function. [Aaron Giles]

Added new required machine driver entry MDRV_SCREEN_FORMAT() which
specifies the bitmap format for the screen. Removed the 
VIDEO_RGB_DIRECT and VIDEO_NEEDS_6BITS_PER_GUN flags that used to
determine the bitmap format implicity. [Aaron Giles]

Deprecated the following obsolete machine driver entries:

   MDRV_FRAMES_PER_SECOND -> MDRV_SCREEN_REFRESH_RATE
   MDRV_VBLANK_DURATION   -> MDRV_SCREEN_VBLANK_TIME(TIME_IN_USEC(x))
   MDRV_VISIBLE_AREA      -> MDRV_SCREEN_VISIBLE_AREA

[Aaron Giles]

Added a new mechanism for rendering the crosshairs on lightgun games.
Crosshairs are automatically rendered if lightgun controllers are
specified; the game no longer has to render them. Any other analog
axis can be configued to use crosshairs via the new PORT_CROSSHAIR
macro. Crosshairs are also now rendered in different colors for 
different players, and done as an overlay using the new rendering 
system instead of drawing into the game bitmap, which means they no 
longer show up on screenshots. If you don't like the built-in 
crosshairs, you can make your own. Just call them cross0.png 
(player 1), cross1.png (player 2), etc. and place them in the root 
of your artwork directory. [Aaron Giles]

Changed F1 crosshair toggle. By default crosshairs are on for all
configured players. Toggling once will turn them all off. Each
sucessive toggle will enable one player at a time until all players
are again visible. [Aaron Giles]

Added support in chd.c for lossy compressors, computing CRCs and other
hashes based on the decompressed output in those cases. Also added
support for asynchronous reads/writes using the new osd work item
interfaces. [Aaron Giles]

Fixed several bugs in the Windows implementation of the osd work item
interfaces. [Aaron Giles]

Simplified the hard disk interfaces a bit. [Aaron Giles]

Fixed several bugs and improved emulation of the Z80 SIO chip.
[Aaron Giles]

Improved behavior of the laserdisc code when seeking so it doesn't
get "stuck". Added preliminary support for the 22VP932 laserdisc
player. [Aaron Giles]



New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Date Quiz Go Go (Korea) [David Haywood]
Disco Boy [David Haywood, Stefan Lindberg]



New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Gain Ground (Japan) [Team Japump, Brian Troha]
Dynamic Country Club (Japan) [Team Japump, Brian Troha]



New games marked as GAME_NOT_WORKING
------------------------------------
Cliffhanger [Ernesto Corvi]
Goal To Go [Ernesto Corvi]
Quick Jack [David Haywood, ClawGrip]
Strip Teaser [David Haywood]
Pango Fun (Italy) [David Haywood]
Ganbare Chinsan Ooshoubu (MC-8123A, 317-5012) [David Haywood]
Stelle e Cubi (Italy) [David Haywood]
Space Ace [Aaron Giles]


==========================================================================

0.111u3

OSD porters take note of the changes to the OSD core routines.


Source Changes
--------------

Added save state support to the tubep driver. [Svante Gerhard]

Added save state support to the steppers module. [James Wallace]

Added the remaining input pins to the SN76477 Interface. If these 
pins are constant, they can now be defined in the structure as 
opposed to having to call functions in an init routine. Modified all 
the drivers that use a 76477. [Zsolt Vasvari]

Removed file I/O functions from osd_tool.h in favor of the ones in
osdepend.h. Updated tools accordingly. Added new flag
OSD_FLAG_CREATE_PATHS to the open command. [Nathan Woods]

Moved OKIM6295 pin 7 state (internal divider) to internal structure. 
Updated all drivers to specify pin state when setting the interface. 
Added comments for all cases where the original frequency wasn't / 132 
or /165 as the real pin state is unknown. [David Haywood]

Updated Toki driver to display visual DIPs for the game.
[Brian Oberholtzer]

Added sprite X flip and removed unneeded hack in wheelfir driver.
[Tomasz Slanina]

Fixed several issues with the new Unicode support. [Nathan Woods]

Changed uimenu.c to allow displaying DP switch banks which have 
gaps (unused switches) in them. These switches are now grayed out.
[Zsolt Vasvari]

Another Amiga update: [Ernesto Corvi]
 - Fixed blitter in line mode
 - Modified Copper to run on odd memory bus cycles
 - Fixed screen delay offset when display data fetch is not word 
    aligned

Fixed cheat searching. [stephh]

Replaced CPS2 CHDs with preliminary decryption function.
[Andreas Naive, Nicola Salmoria]

Added code to validate that banks are only set to point to memory
that has been allocated via auto_malloc(). Currently disabled
pending further review. [Nathan Woods]

Updated input port tokenization for MESS. Added support in MAME
for "configuration" switches which are separate from DIP switches.
These can be used to configure aspects of the game that don't
correspond to DIP switches. Modified pacman.c to use configurations
to control the speedup options. [Nathan Woods, Aaron Giles]

Fixed invalid array access in the taito_l driver. [Atari Ace]

Made a fix minor compiler compatibility tweaks to the source.
[Atari Ace]

Fixed several glitches and crashes related to the input port and
unicode changes from u2. [Aaron Giles]

Separated "core" OSD function definitions to osdcore.h. Added more
extensive documentation. [Aaron Giles]

Created a new library called osdcore, which is now built and linked
to each executable. Moved all definitions of expected components of
osdcore into new header file osdcore.h, and added consistent
documentation for them all. Removed osd_tool.c, and moved the 
necessary parts of its functionality into osdcore. [Aaron Giles]

Defined a new set of interfaces for osdcore which creates an
abstract interface for queueing work items to be potentially executed
on a secondary thread. Implemented the Windows versions of these
routines, but have not done any testing yet. [Aaron Giles]

Separated Windows OSD core routines into individual files, as
folows:
  windir.c  - directory-related core OSD functions
  winfile.c - file-related core OSD functions
  winmisc.c - miscellaneous core OSD functions
  winsync.c - synchronization-related core OSD functions
  wintime.c - timing-related core OSD functions
  winwork.c - threading-related core OSD functions
[Aaron Giles]

Created new osdmini directory with minimal implementations of all the 
OSD core routines. These can be used to stub in functionality or as
a starting point for new ports. [Aaron Giles]

Cleaned up chdman, normalizing its behavior and improving error
reporting. [Aaron Giles]

More updates to the laserdisc emulation, based on more complete
understanding of how the discs are encoded and how they will 
eventually be stored. [Aaron Giles]



New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Thunder Heroes [Guru]



New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Dharma Doujou (Korea) [Guru, David Haywood]



New games marked as GAME_NOT_WORKING
------------------------------------
Cobra Command [Andrew Gardner]
Gals Panic II - Quiz Version (Japan) [Guru, David Haywood]
Gals Panic II' - Special Edition (Japan) [Guru, David Haywood]
Monster Zero [Pierpaolo Prazzoli]
Unknown SemiCom Quiz [Guru, David Haywood]


==========================================================================

0.111u2

MAMETesters bugs fixed (there are probably more)
-----------------------
tourtabl0111u1red [Nathan Woods]


Source Changes
--------------

Amiga core system updates: [Ernesto Corvi]
 - Updated 6526/8520 CIA to be able to set the value of the SP pin.  
    This is needed to emulate the Amiga keyboard.
 - Updated the custom chips emulation to delay for about 24 cycles 
    the issuing of interrupts after a write to INTENA or INTREQ. 
 - Fixed a bug where if INTREQ got cleared programatically, it would 
    'forget' about pending CIA interrupts, causing the CIA to stop 
    sending further interrupts.
 - Fixed the interrupt delay logic. Now it properly delays firing 
    the irqs, not the masking/disabling.
 - Fixed return value for unused/invalid custom registers reads.
 - Added Denise ID custom register to properly identify OCS, ECS and 
    AGA
 - Added reset to custom, autoconfig and cia when a RESET opcode is 
    found.
 - Resetting the custom chips will now clear INTENA, preventing 
    further interrupts.
 - Fixed a bug in the RBF interrupt request code check.
 - Fixed a bug on the 6526/8520 CIA that prevented chained counters 
    from working.
 - Added support for the 'blitter-nasty' bit on the blitter. Fixes 
    many games that displayed wrong graphics.

Hooked up coin counter in Gun Fight. Also connected sounds properly 
per schematics. Added proper watchdogs to invaders and invad2ct.
[Derrick Renaud]

Added missing initialization to the TMS5220 RNG. [Lord Nightmare]

Taito JC driver improvements: [Ville Linde]
 - Implemented MC68HC11 communications
 - Added analog controls via MC68HC11
 - Various bug fixes and some new opcodes to the TMS320C51 core
 - Moved video hardware emulation to vidhrdw/taitojc.c
 - Implemented 3D hardware emulation

Cleaned up the 8080bw sound changes included with u1. [Robert]

Changed 6532riot and tia code to only allow initialization at init 
time. [Nathan Woods]

Fixed several bugs in the old System 16 bootleg code. [Mamesick]

Fixed SIM opcode in i8085 emulator. [Tomasz Slanina]

Initial support for Unicode in the core and Windows OSD: [Nathan Woods]
 - text file reading/writing now automatically handle UTF-8 conversion
 - a number of Windows functions internally manage TCHARs
 - new Windows compile-time option UNICODE can be used to build MAME
    as a Unicode application (see windows.mak)

Added new visible representation of physical DIP switches for drivers
that have them defined. To see this, just pull up the DIP switch
menu on drivers that have been documented. [Brian Oberholtzer]

Corrected some incorrect DIP switch information in the 1942, toaplan2,
and segag80r drivers. [Brian Oberholtzer]

Added the remaining MESS CPU cores to MAME. They are disabled in the
build, but will be maintained along with the MAME CPU cores as future
changes are made. [Nathan Woods]

Added support for multiple instances of the samples sound system.
[Zsolt Vasvari]

Converted input port definitions from code-based constructors to
data-driven tokenized values. This reduces the overall MAME code size
by a significant amount. Note that the tokenization is a bit
different for 32-bit versus 64-bit builds, so hopefully somebody
with a 64-bit system can verify that it works (mame -listxml should
produce identical results to the 32-bit version). 
[Atari Ace, Aaron Giles]

Properly implemented sound interrupts in Night Slashers. [Aaron Giles]

Improved cycle timings in the ARM CPU core. Altered the deco32 CPU
clocks to be more realistic. [Aaron Giles]

Updated copyright dates in header files and docs. [Aaron Giles]



New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Dwarfs Den [Tomasz Slanina]



New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
JuJu Densetsu (Japan, bootleg) [David Haywood]
New Tropical Angel [Stefan Lindberg]
Circus (Sub-Electro bootleg) [David Haywood]



New games marked as GAME_NOT_WORKING
------------------------------------
Backgammon [Tomasz Slanina]
Skat TV [Tomasz Slanina]
Fashion Gambler [Tomasz Slanina]
Pit Boss II [David Haywood]
Super Bitboss [David Haywood]
Pitboss Megastar [David Haywood]
Megatouch 3 [David Haywood]
Megatouch 5 [David Haywood]
Touchmaster [David Haywood]
Touchmaster 3000 [David Haywood]
Touchmaster 4000 [David Haywood]
Mahjong Shiyou [David Haywood]


==========================================================================

0.111u1

MAMETesters bugs fixed (there are probably more)
-----------------------
jspecter074gra [Robert]
spcenctr36b16gre [Robert]
spcewars0108u3red [Robert]
invad2ct0110u4gre [Robert]
mngrecording0110u1ora [Buddabing]
ninjaw0104u2gre [robiza]
orunners0105u4gre [robiza]
twinbee0105yel [Mamesick]
gwarrior0108u1yel [Mamesick]
tst_galx0101u3 [Atari Ace]
m660_0108yel [Atari Ace]
shootouj0102red [Mamesick]


Source Changes
--------------

Added more documentation for the 8080bw driver. It describes the ports 
and bits for those games with no sound. In most cases, sample sounds 
have been attached, in order to assist with further development. The 
games modified are: invrvnge/invrvnga, rollingc, spcenctr, gunfight, 
m4, gmissile, schasrcv, 280zzzap, lagunar, lupin3, phantom2, blueshrk, 
desertgu, ballbomb, yosakdon/yosakdoa, and shuttlei. Two games were 
marked NO_SOUND although they actually do have sound: these are cosmo 
and dogpatch. [Robert]

Moved a chunk of platform specific code out of chdcd.c and romcmp.c 
into the osd_tool code. [Nathan Woods]

Widespread cleanup of disassemblers and CPU interfaces across the 
project: [Giuseppe Gorgoglione]
 - removed from many disassemblers the dependency on eainfo.h. The 
    output produced by those disassemblers has been checked to be the 
    same as before.
 - extensively rewrote the 6309dasm.c and 6809dasm.c disassemblers.
 - fixed minor bugs in the v810 and hd6309 interfaces.
 - removed m68000\cpudefs.h. This was used by the old assembly m68000 
    core. Removed from m68kmame.c and m68kmame.h as well many 
    references to the old core (e.g A68K0, A68K2, etc.)
 - properly typedeffed the cpuinfo union, this affects cpuintrf.h and 
    many, many, other files
 - converted 8051dasm.c, m65ce02.c and t11dasm.c to use 
    cpuintrf_temp_str() instead of local string pools
 - moved the info.s = cpuintrf_temp_str() initialization to:
    activecpu_get_info_string(), cpunum_get_info_string() and 
    cputype_get_info_string(). This allows us to remove tons of 
    info->s = cpuintrf_temp_str() statements from the xxx_get_info() 
    accessors of every CPU core, making them more readable
 
Fixed a problem with the chirp tables of both the tms5220 and the 
tms5110. Also backported Jarek's PRNG implementation from tms5110.c 
to tms5220.c so it no longer relies on rand(). [Lord Nightmare]

Fixed two bugs in the m68000 core: [Alex Jackson]
 - fixed a miscompilation issue with GCC4 that was first noticed in 
    Altered Beast but also affected Moonwalker, Galaxy Force 2, and 
    probably many other games.  
 - fixed the core's compile-time self-configuration so that it uses 
    the same code paths on LP64 platforms (64-bit Linux, etc.) as on
    LLP64 (64-bit Windows) and 32-bit platforms.

Added save state support to the magmax driver. [Svante Gerhard]

Fixed music speed in perfrman. [Mamesick]

Fixed implementation of da_a instruction in i8051 core. [Special LIU]

Third round of numerous improvements to the cheat engine: [ShimaPong]
NOTE : delete old command code and save it newly in Options menu.
 * operation:
   - Added preliminary direct Program Space accessor.
     You can hack custom handling ROM code (eg encrypted segas16b.c
     games). But it has several problems.
     And added watchpoint display for Program Space.
   - Added new operation, "Write if Match".
     The cheat engine writes value only when read value matched
     reserved value which is stored in extend data field.
 * search menu:
   - Added 3rd search mode, "Minimum Search Mode". It's more simple
     than Classic Mode. Also added search memory initialize with
     ui_clear key and extended value edit with arrow key in this mode.
   - Added "View Last Results", "Restore Result", "Region Selection"
     items to the advanced search menu.
 * result viewer:
   - Don't open this menu to avoid MAME crash in case of
     no search region like sms.c in HazeMD.
   - Added quick page switch by left/right arrow key.
     Also changed functions for several keys in this menu.
   - Improved no result page skip. But incomplete because
     doesn't skip first or last page even if no result.
 * code loading:
   - Ignored to load old format code by default. If you need to
     load, choose "Load Old Format" item in Options menu.
 * input:
   - Fixed activation key save on Enable/Disable menu.
   - Fixed key handling for watch code addition from watch list
     menu to cheat list. Now it works with ctrl + save cheat
     key on the watch list menu.
   - Enabled ui_clear key in editing a value (clear data)
     and on watch list menu (reset all watchpoints).
 * option:
   - Added preliminary Debug option to check internal data.
   - Added command code save. You can save command code with
     save cheat key in Options menu.
 * others:
   - Added quick menu switch. It is assigned to ui_zoom in/out keys.
     This function works in Enable/Disable, Add/Edit, Search and
     Watchpoint menus.
   - Rearranged several items on the menus.

Converted some isolated parts of the Win32 OSD code to use 'TCHAR' 
strings rather than simple 'char' strings. [Nathan Woods]

Removed rom patches in the airbustr driver; hooked up watchdog 
instead. [David Haywood]

Reimplemented one-shot timer modes in the 6526 CIA (Amiga) emulation.
[Ernesto Corvi]

Added validity check for zero refresh rates. [Nathan Woods]

Fixed DIPswitch defaults for Quartet and Quartet 2. [Alex Jackson]

Fixed incorrectly drawn graphics in troangel. [Robiza]

Fixed a few more assertions lurking with the new stricter disassembler
checks. [Aaron Giles]

Patched some protection checks in Funny Strip and Rebus. Neither game
works yet. [Tomasz Slanina]

Changed -createconfig to output the INI file using mame_file rather 
than FILE. [Nathan Woods]

Improved graphics emulation in the tetriunk driver. [Tomasz Slanina]

Fixed copy/paste bug in the Irem sound hardware dealing with MSM5235
chips. [Mamesick]

Fixed visible area in Toki. [Mamesick]

Added new Toshiba TMP90840/TMP91640 CPU core. [Luca Elia]

Moved msm6242 real time clock to its own file. [Luca Elia]

Implemented blitter rom banking in dynax driver. [Luca Elia]

Added sound in Rapid Hero (samples banking is incorrect). [Luca Elia]

Fixed reset problem in the tia emulation. [Nathan Woods]

Adding remaining MESS sound cores to the core MAME sources.
[Nathan Woods]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Ms. Pac-Man/Galaga - 20 Year Reunion [Nicola Salmoria]
Mahjong If...? [Luca Elia]
Mahjong Reach (bootleg) [Luca Elia]
Mahjong Tenkaigen (bootleg) [Luca Elia]
Live Quiz Show [Luca Elia]
Pool 10 (Italia) [Roberto Fresca]
Tortuga Family (Italia) [Roberto Fresca]



New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Booby Kids (Italian manufactured graphic hack) [David Haywood]
Air Buster: Trouble Specialty Raid Unit (bootleg) [David Haywood]
Battle Balls (US) [Arzeno Fabrice]
Darth Vader [Tomasz Slanina]
R-Type (World) [Stefan Lindberg]
Puzz Loop 2 (Euro 010302) [Razoola, David Haywood]



New games marked as GAME_NOT_WORKING
------------------------------------
Moonwar (prototype on Frenzy hardware) [Lord Nightmare]
BanBam [David Haywood, Brian Troha]
Double Dealer [Tomasz Slanina]
Sky Lancer [Luca Elia]
Mahjong Tensinhai [Luca Elia]
Mahjong Raijinhai DX [Luca Elia]
Mahjong Tenkaigen Part 2 [Luca Elia]
Mahjong Tenkaigen [Luca Elia]
Cow Race [Luca Elia]
Mongolfier New (Italia) [Roberto Fresca]
Soccer New (Italia) [Roberto Fresca]


==========================================================================

0.111

MAMETesters bugs fixed (there are probably more)
-----------------------
perfrman0110u5gre [Pierpaolo Prazzoli]


Source Changes
--------------

Properly removes the "Autocenter Speed" from the UI when not used.
[Derrick Renaud]

Fixed decryption of some NeoGeo bootleg sets (specifically, kf2k2mp 
and kf2k3upl) on platforms/compilers that don't implement memcpy as
memmove. [Alex Jackson]


==========================================================================

0.110u5

MAMETesters bugs fixed (there are probably more)
-----------------------
circusc0110u2gre [Derrick Renaud]
circusc37b16ora [Derrick Renaud]
64street057gre [Mamesick]
cannonb0104u8Yel [Mamesick]
gratia099u4red [Atari Ace]


Source Changes
--------------

Improvements to the Polygonet Commanders driver: [Andrew Gardner]
 * Implemented various dsp56k opcodes
 * Polygonet Commanders now gets past the memory tests

Fixed the background color in perfrman. [Pierpaolo Prazzoli]

Merged in some MESS-specific PC support code. [Nathan Woods]

Added mosaic effect to valtric. Yes, it looks as bad on real hardware
as in MAME :) [Tomasz Slanina]

Fixed colors in Honey Dolls. [David Haywood]

Added the final filtering stages to the sound, proper watchdog and 
memory mirroring to the circusc driver. Also added PORT_DIPLOCATION 
info and save state support. [Derrick Renaud]

Updated vconv.c to support preprocessor and assembly file output in
MSVC builds. [Nathan Woods]

Improved DIP switches for Honey Dolls and Twin Adventure. 
[Brian Troha]

Removed the "Autocenter Speed" menu entry for Analog Controls that do 
not use it. [Derrick Renaud]

Added a "Digital Speed" of 0 in the "Analog Controls" menu. This will 
cause the control to only inc/decrement once per button press no 
matter how long the button is pressed. Remember this is still scaled 
by the "Sensitivity" setting. [Derrick Renaud]

Scaled Windows mouse Z axis by 30 to make it usable. Most mice 
inc/decrement by 120 for each wheel click. Some rare ones are 30. So 
this means for most mice, using a Sensitivity setting of 25%, you 
will get 1 inc/decrement for each wheel click. [Derrick Renaud]

Cleaned up the cclimber driver, replacing hacks for cannonb with a
separate video update callback. [Mamesick]

Moved the ST-V protection related code into stvprot.c and added some 
notes about the decathlete protection and renamed stvhacks to 
stvinit, because it contains most of the inits as well as the 
speedhacks. [David Haywood]

Major funworld driver rewrite: [Roberto Fresca]
 - Merged/splitted some machine drivers, memory maps and inputs.
 - Unified get_bg_tile_info for all games.
 - Mapped the input buttons in a better format (all games).
 - Added proper color PROM decode routines.
 - Splitted the driver to driver/vidhrdw.
 - Corrected the screen size and visible area to magiccrd.
 - Added the remaining 2 GFX planes to magiccrd; GFX are imperfect.
 - Royalcrd: Added all inputs and DIP switches.
 - Fixed jolycdcr gfx to 4bpp.
 - Other fixes to get jolycdcr running.
 - Managed royalcdb to work, using the 2nd half of program ROM.
 - Managed jolycdit to work, but with imperfect graphics.
 - Fixed CPU clock to 2MHz. in all remaining games.
 - Fixed ay8910 frequency based on elephfam audio.
 - Fixed ay8910 volume in all games to avoid clipping.
 - Reworked jolycdcr, jolycdit inputs.
 - Set jolycdat as bigdeal clone. 
 - Added the bipolar PROM and GAL to jolycdit. 
 - Added color PROMs to cuoreuno and elephfam sets. 
 - Corrected jollycrd screen size and visible area.
 - Hooked, wired and decoded the color prom in jollycrd sets.
 - Wired and decoded the color prom in cuoreuno and elephfam sets.
 - Wired and decoded the color prom in royalcrd.
 - Hooked, wired and decoded the color prom in bigdeal sets.
 - Decrypted jolycdit gfx roms.
 - Decrypted jolycdae and managed the planes to show correct colors.

Minor Unicode changes for the Windows code. [Nathan Woods]

Added serial in/out support to the Amiga hardware. Added hooks for
output pins and light pen positioning. Also fixed the horrible static 
at startup in the debug build. [Aaron Giles]

Reorganized the laserdisc support a bit to accommodate new players.
Added Sony LDP-1450 support. [Aaron Giles]

Added new render texture format TEXFORMAT_YUY16, which is used to
hold 4:2:2 Y/Cb/Cr format pixels. Updated the Windows Direct3D code
and the software renderers to use this format directly. [Aaron Giles]

Added new render texture fromat TEXFORMAT_PALETTEA16, which is the
same as TEXFORMAT_PALETTE16 but respects the alpha component of the
palette entry. Updated the Windows Direct3D code and the software
renderers to use this format. [Aaron Giles]

Changed the render system to respect blendmodes for screen elements
rather than hard-coding them. This allows individual VIDEO_UPDATE
routines to do their own compositing. [Aaron Giles]

Removed the illusion from the rendering system that you could pass in
arbitrary palettes. The system palette is all that is supported.
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Twin Adventure [David Haywood]
Royal Card [Roberto Fresca]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Twins (set 2) [David Haywood]
Jolly Card (Austria, encrypted) [Roberto Fresca]
Royal Card (Slovakia, encrypted) [Roberto Fresca]
Elephant Family (Italia, old) [Roberto Fresca]
Phoenix (Centuri), Set 2 [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
ParaParaParadise [Ville Linde]
Keyboardmania 3rd Mix [Ville Linde]
Mad Dog McCree [Andrea Turci, Aaron Giles]
Who Shot Johnny Rock? [Andrea Turci, Aaron Giles]
Mad Dog II: The Lost Gold [Andrea Turci, Aaron Giles]
Space Pirates [Andrea Turci, Aaron Giles]
Gallagher's Gallery [Andrea Turci, Aaron Giles]
Crime Patrol [Andrea Turci, Aaron Giles]
Crime Patrol 2: Drug Wars [Andrea Turci, Aaron Giles]
The Last Bounty Hunter [Andrea Turci, Aaron Giles]
Fast Draw Showdown [Andrea Turci, Aaron Giles]
Platoon [Andrea Turci, Aaron Giles]
Zorton Brothers (Los Justicieros) [Andrea Turci, Aaron Giles]
Joker Card [Roberto Fresca]


==========================================================================

0.110u4

MAMETesters bugs fixed (there are probably more)
-----------------------
raiga0104u4yel [Mamesick]


Source Changes
--------------

SCSI CD emulation improvements: [Ville Linde]
 - Added Play Audio (12) command
 - Fixed track number and added MSF support to Read Sub-Channel 
    command

Added workaround for broken MediaGX driver. [Ville Linde]

Reworked the SNES raster timing to use MDRV_SCREEN_RAW_PARAMS() and 
friends. All but one of the "electronics tests" in the SNES 
diagnostics cart now pass with flying colors. [R. Belmont]

Fixed Super Breakout layout. [Mr. Do]

CPS2 updates: [David Haywood]
 - Added table for Jyangoku (from Guru). Note that GFX/Sound roms 
    aren't dumped on this one.
 - Removed old 'handcrafted' xors for games which we have CHDs for 
    and replaced them with xors generated from MAME using the CHD.  
    This means anyone with the CHD can easily generate the xors 
    (using the code I've left in there) if they need to be able to 
    run the games with a shorter startup time.
 - Disabled the loading of the xors by default for all sets with a 
    CHD. Now only the CHD is loaded, unless the #define is changed 
    at the top in which case only the xors generated from the CHD 
    are loaded.

Added support for more than 4 mouse buttons on versions of Windows 
that support it. Win98/Me with DX7+ or XP. It defaults to regular 4 
buttons if not supported. [Derrick Renaud]

Fixed the crosshairs in the PlayChoice-10 gun games that got 
buggered in the conversion to multi-monitor support. [Derrick Renaud]

Rewrote the Dragon's Lair driver from the schematics. Added new
module machine/laserdsc.c which has laserdisc emulation for the
PR-7280 and LD-V1000 laserdisc players. Full emulation of the
laserdisc is pending support for CHD audio/video and high quality 
rips, but you can operate the game and see the frame numbers that
would be displayed. Added built-in layout to display the scores, 
lives, and credit information. [Aaron Giles]

Added some hacks to windows.mak to allow limping compilation under
Windows Vista. To make these work set an environment variable called
VISTA_MINGW_ROOT equal to the base of your mingw directory, and add
%VISTA_MINGW_ROOT%\libexec\gcc\mingw32\3.4.2 to your PATH environment.
There are still a few issues, but this will let you build with MSVC,
and will compile most of the code with gcc (minus a couple of Windows
OSD files). Hopefully the mingw folks will resolve these issues.
[Aaron Giles]


==========================================================================

0.110u3

MAMETesters bugs fixed (there are probably more)
-----------------------
sandscrp0110u1yel [Mamesick]


Source Changes
--------------

Added raw decryption table to choko. Enabled the use of the large
CHD-based tables by default. [David Haywood]

Changed kram3 decryption to use external tables instead of hard-
coded ones in the source. [Atari Ace]

Konami driver updates: [Ville Linde]
 * drivers/gticlub.c:
   - Moved video hardware to vidhrdw/gticlub.c
   - Hooked up sound emulation
   - Added dual-screen support for Hang Pilot
 * drivers/hornet.c:
   - Added support for multiple K037122 chips
   - Added dual-screen support for Silent Scope & Silent Scope 2
 * drivers/nwk-tr.c:
   - Added support for multiple K001604 chips
   - Hooked up sound emulation
 * vidhrdw/gticlub.c:
   - Added texture-mapping and z-buffer to K001005 emulation
 * general:
   - Consolidated K056800 emulation (machine/konamiic.c)
   - Improved Hang Pilot/NWK-TR gfx board emulation

STV fixes: [Mariusz Wojcieszek]
 - vdp2: fixed vertical scrolling for RGB bitmaps (fixes corrupted
    gfx in batmanfr)
 - vdp2: fixed vertical line scrolling for zoomed layers (fixes
    corrupted backgrounds in astrass)
 - stv:  added speedup for master sh2 in batmanfr

Fixed bug in overflow handling and SUBC emulation in the TMS32010
core. [Rainer Keuchel]

Reverted Mario Bros. graphics offset since it caused issues 
elsewhere. [Derrick Renaud]

Enhanced chd.c to support hunk sizes up to 16MB, versus the previous
64k limit. [Aaron Giles]

Added hooks to chd.c to specify codec-specific configuration info.
[Aaron Giles]

Removed obsolete timing parameter from stream_update(). [Aaron Giles]

Cleaned up cdrom.c. Removed audio implementation and relocated code
into sound/cdda.c. Changed metadata format to be textual instead of
binary (old metadata format is still supported). Removed external
access to CHD positions; all accesses are now done at the physical
LBA level and converted internally. [Aaron Giles]

Added support for split CHD files. CHD files can be transparently
split into multiple pieces and left that way during read access.
Modifications to split files are always written to the last file.
A new command chdman -split is now available to split an existing
CHD file. [Aaron Giles]

Added new option -fontpath to control where the font files are loaded
from. [Aaron Giles]

Added ability for options_add_entries() to override defaults 
specified in the core. To do this, simply include an option in the
list with the same name as the core option and provide a new default.
This default will override the one specified in the core.
[Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
World Rally (set 3 - 930217) [Kevin Eshbach]
Bionic Commando (Euro) [Stefan Lindberg]


==========================================================================

0.110u2

MAMETesters bugs fixed (there are probably more)
-----------------------
vulcan137b1gre [robiza, Mamesick]
mario0110u1gre [Derrick Renaud]


Source Changes
--------------

Fixed flags access in the i286 core. [Barry Rodewald]

Updated MC146818 module to use new core date/time routines.
[Nathan Woods]

Cleaned up disassemblers to remove stubs and ensure the disassemblers
are not referenced except in debug builds. [Nathan Woods]

Added support for using CHDs to decrypt CPS2 games. This code is
disabled for the moment, but will be enabled in the future. Only a 
handful of games have complete tables so far. These tables are huge 
(~4GB) and uncompressable until the encryption algorithm is 
understood. [David Haywood]

Fixed bug in the debugger that caused watchpoints to not be active
until the next context switch. [smf]

Cleaned up the input definitions for n-way joysticks so they are
more explicit. Added concept of a "16-way" joystick, which is a
joystick that doesn't prevent simultaneous opposing directions from
bring reported. [smf]

Major System 573 update: [smf]
 * fixed PSX SIO control register behavior
 * implemented several SCSI CD commands: START/STOP UNIT, PAUSE/
    RESUME, READ SUB-CHANNEL, READ TOC
 * added uPD4701 emulation
 * fixed ATAPI reset, PIO, and command IDENTIFY PACKET DEVICE 
 * hooked up controls for fishing, DRR, and Guitar Freaks games
 * hooked up CDDA audio
 * removed some unused bytes from the Konami 80's security chips

Fixed upside down service mode in the commando.c driver. [Canim]

Added support for the Triple Hunt 8-track audio. [Derrick Renaud]

Galaxian/Scramble driver reorganization: [Atari Ace]
 * machine/scramble.c is broken up into two files, 
    machine/galaxian.c and machine/scramble.c
 * drivers/amidar.c, drivers/frogger.c, drivers/scobra.c get copies 
    of some of the data structures they shared from other drivers 
 * galaxian_base is made static and uses outside of the main driver
    were rewritten
 * cclimber_decode code from drivers/cclimber.c was separated into 
    its own machine/cclimber.c file to allow mshuttle to share it 
    without taking on other dependencies

Added missing x-flipping support in Major Havoc. [Mathis Rosenhauer]

Made some improvements to trivia madness driver. There still is 
something wrong in the question roms banking. [Pierpaolo Prazzoli]

More updates to the ST-V driver: [Mariusz Wojcieszek]
 * vdp1: added shading for sprites (used by znpwfv, cotton, others)
 * vdp1: fixed sprite clipping (fixes incorrect sprites in znpwfv)
 * vdp1: fixed transparency on colour lookup table sprites (fixes bad
          sprites in znpwfv)
 * vdp2: fixed caching of RGB layer (fixes bad backgrounds on bosses 
          in rsgun)
 * vdp2: added additive blending for tilemaps and sprites (rsgun)
 * vdp2: added vertical line scroll and linezoom (fixes diehard logo)
 * stv:  improved speedups for diehard
 * stv:  fixed speedups for znpwfv
 * stv:  added preliminary save state support

Significant cleanup of chd.c: [Aaron Giles]
 * got rid of the horrible last_error concept; now all routines 
    return an error directly
 * fixed several issues in managing metadata 
 * changed compression and verification routines to be client-driven 
    rather than monolithic
 * changed internal codec usage to be more flexible
 * altered chdman and MAME to use the new interfaces
 * added new -createraw command for creating raw data CHDs

Fixed crash bug in romcmp when comparing ZIP files. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Fisherman's Bait * A Bass Challenge / Bass Angler [smf]
Fisherman's Bait 2 * A Bass Challenge [smf]
Fisherman's Bait * Marlin Challenge [smf]
Dancing Stage / Dance Dance Revolution [smf]
Guitar Freaks [smf]
Dance Dance Revolution 2nd Mix [smf]
Dance Dance Revolution 2nd Mix Link [smf]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Hellfire (2P Ver., first edition) [Tirino73]
Konami 80's AC Special (3 versions) [smf]
Stratovox (bootleg) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Jyangokushi: Haoh no Saihai (Japan) [David Haywood]


==========================================================================

0.110u1

MAMETesters bugs fixed (there are probably more)
-----------------------
warriorb0109u2gre [Aaron Giles]
ballbros0109u5gre [Aaron Giles]


Source Changes
--------------

Numerous improvements to the cheat engine again. [ShimaPong]
 * Operation
  - Mounted copy prevous value.
  - Defined link extension bit in type field.
  - Improved one shot operation when restore previous value is 
     available.

 * Menu
  - Major update for classic search menu.
  - Arranged the cheat general menu a bit.
  - Improved item display for selection type code on the code 
     edit screen.
  - Added entry index parameter to EditCheatMenu().

 * Watchpoint
  - Added watchpoint for ROM region.
  - Improved adding watch from cheat list.

 * Activation key
  - Added save activation key.
  - Added 2nd activation key.
  - Added show activation key message option.

 * Others
  - Refined command code format.

Added support for Fixed Interval Timer to the PPC403 core.
[Ville Linde]

Polygonet Commanders update: [Andrew Gardner]
 * Added more accurate host interface to dsp56k core
 * Removed a bunch of hacks in plygonet.c

Added new field Machine->basename which is used to describe the path
used for various file accesses. This is a helper for MESS, and should
not have any user-visible changes. The file accesses affected are:
configuration (cfg) files, snapshots, debugger comments, NVRAM,
and memory cards. [Aaron Giles]

Changed naming of screenshots. They are now created in separate
folders per game, with numeric names 0000.png, 0001.png, etc.
[Aaron Giles]

Changed artwork layout loading to load either gamename/gamename.lay
or gamename/default.lay. The latter is preferred, and allows for
easier reuse of layouts between games. [Aaron Giles]

Fixed max instruction bytes for 68020+ CPUs to avoid assertion in
new disassembler. [Aaron Giles]

Added flip screen offsets needed with new video parameters in the
pacman.c driver. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Fishing Frenzy [Aaron Giles]
Freeze (Atari) [Aaron Giles]


==========================================================================

0.110

MAMETesters bugs fixed (there are probably more)
-----------------------
irobot0106u1gra [Luigi30]
astrofc057ora [Luigi30]


Source Changes
--------------

Fixes auditting sets where all the roms in the clone are also in the 
parent. [smf]

Fixed assertions in 6809 and 6502 diassemblers caused by stricter
checking introduced in u5. [Aaron Giles]

Fixed crash when resetting PSX games. [smf, Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Trivia (Version 1.01C Alt questions 1) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
M075 Poker (Version 16.03B) [Brian Troha]
Super Bowl (Version 16.03B) [Brian Troha]
Trivia (sms) [Pierpaolo Prazzoli]


==========================================================================

0.109u5

MAMETesters bugs fixed (there are probably more)
-----------------------
uicrash0108u5red [Nicola Salmoria]


Source Changes
--------------

Fixed subtle bug in the UI menu handler that only manifested on
mingw-based compiles. [Nicola Salmoria]

Updated CHD locating behavior to accept CHDs referenced by the 
parent of a clone if the hash matches, even if it has a different
name. [smf]

Improved flash emulation and added support for Fujitsu flash chips.
Switches Konami games over to new flash chips. [smf]

Improved behavior of SCSI CD implementation for audio playback and
TOC reading commands. [R. Belmont]

Fixed priorities and the offset of layer 3 in fcrash. [robiza]

Added save state support to the COP4xx core. [Aaron Giles]

Changed the new disassembler and override callback prototypes to
take const parameters and to remove the generally unused 'bytes'
parameter. The disassemblers can now assume that the buffers contain
enough bytes to hold the maximum instruction length as returned by
the CPU core get_info callback. [Aaron Giles]

Converted the following disassemblers to the new format, and added
step in/out support where it was obvious: adsp21xx, alph8201, 
arm, arm7, asap, ccpu, cdp1802, cop4x0, dsp32c, e132xs, g65816, 
h6280, h83002, i8x41, i960, i8051, i8085, jaguar, m680x, m6805, 
m37710, mc68hc11, pic16c5x, rsp, s2650, se3208, sh2, sharc, t11,
tms32010, tms32025, tms32031, tms34010, upd7810, v60, v810, z180,
and z8000. [Aaron Giles]

Deprecated the old disassembler interfaces in favor of the new ones.
[Aaron Giles]

Fixed subtle bug in subtable allocation in the memory system that
caused the Eolith games to assert with the debugger. [Aaron Giles]

Tweaked the disassembly view to detect if the disassembly for the
current instruction has changed, and if so, recompute the entire 
view. This provides more dynamic updating when system states change
under certain CPUs. [Aaron Giles]

Added new symbol 'curpc' for all CPUs which represents the value of
the current instruction pointer, to avoid naming conflicts with the
'pc' register in other contexts. Changed this to be the default
value for the disassembly window in the Windows version of the
debugger (OSD ports will need to do likewise). [Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Trivia (Version 1.01C) [Brian Troha]
Space Battle (bootleg set 2) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Tetris (Unknown Manufacturer) [David Haywood]
Out Run (Mega-Tech) [Charles MacDonald, Brian Troha]
Forgotten Worlds (Mega-Tech) [Charles MacDonald, Brian Troha]
Super Real Basketball (Mega-Tech) [Charles MacDonald, Brian Troha]


==========================================================================

0.109u4

MAMETesters bugs fixed (there are probably more)
-----------------------
hvysmsh0103u3gre [robiza]


Source Changes
--------------

Added a COP410 core to the COP4xx collection. [Nathan Woods]

Improved banking in the alpha68k games. [robiza]

Fixed memory leak when writing MNG files. [Buddabing]

Fixed several audit bugs introduced with the rewrite. [Mamesick]

Fixed lamps in funworld/cardline drivers. [wolf676]

Normalized realtime clock accesses across drivers. Now ensure that
realtime clocks are reset when recording/saving INP files.
[Nathan Woods]

Updated documentation in pacman driver to reflect actual sync chain.
Fixed sound frequencies for 2650 conversions. [Aaron Giles]

Fixed bug in displaying disassembly of CPUs whose minimum instruction
size was larger than their data bus size. [Aaron Giles]

Added new debugger command 'history' which dumps the most recent
instructions executed. [Aaron Giles]

Improvements to the Looping driver: [Aaron Giles]
 * fixed clock speeds
 * proper video timing
 * fixed protection (game would reset; should never have been marked
    'working' in the first place!)
 * various other driver cleanups

Cleaned up tms99xx core debugging and converted to new disassembler
syntax, adding step over/out support. [Aaron Giles]

Removed obsolete CPUINFO_PTR_REGISTER_LAYOUT and 
CPUINFO_PTR_WINDOW_LAYOUT data items. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Konami 80s Gallery [R. Belmont, smf]
Dark Horse Legend [R. Belmont, smf]
Powerful Pro Baseball EX [R. Belmont, smf]
Bowling 3D [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Trivia (Version 1.03a) (alt 4) [Brian Troha]
Arian Mission [Brian Troha]


==========================================================================

0.109u3

MAMETesters bugs fixed (there are probably more)
-----------------------
ftroption0109u2ora [Aaron Giles]


Source Changes
--------------

Added missing InitCommonControls(), which caused the debugger UI
to fail with recent updates. [Nathan Woods]

Fixed dip switches and added second player controls for beaminv
driver. [stephh]

Major rewrite of the SHARC core: [Ville Linde]
 - Bit-accurate reciprocals
 - More accurate pipeline emulation
 - Fixed the problems with operation latencies
 - Regression tested a few floating-point operations for bit-accurate 
    results
 - Improved DMA emulation
This update will fix most (but not all) of the clipping problems in 
Gradius 4 and NBA Play by Play.

Updated cardline driver lamps and layout: [wolf676]
 - converted hardcoded fake lamps to new artwork system
 - added button lamps card1-5, collect, bet, start
 - added simple button lamps artwork "cardline.lay".
 - re-ordered buttons and added "collect" button

Updated funworld driver lamps and layout: [wolf676]
 - added external credit in counter (mapped as coin 1 counter)
 - added external credit out counter (mapped as coin 8 counter)
 - added button lamps hold1-5, cancel, start
 - added simple button lamps artwork "funworld.lay".

Added COP420 core for the Altair games. [Curt Coder]

Increased the interleave in Xevious to fix synchronization issues.
[robiza]

Added new output control system. This system is designed to support
multiple output streams, and should replace all instances of printf
in the code. You can now call one of these functions:

  mame_printf_error
  mame_printf_warning
  mame_printf_info
  mame_printf_debug

to output data. By default, these go to the console, but they can be
overridden by the OSD layer to route wherever is appropriate.
[Aaron Giles]

Some additional Grand Champion cleanup. [Aaron Giles]


==========================================================================

New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Cuore Uno (Italia) [Roberto Frecsa]
Elephant Family (Italia) [Roberto Fresca]


==========================================================================

0.109u2

IMPORTANT NOTE TO OSD DEVELOPERS: As of this release, you are now
required to make use of options.c to set core options. At a minimum,
this requires calling options_init(NULL) before calling run_game().


MAMETesters bugs fixed (there are probably more)
-----------------------
capbowl0109u1yel [Aaron Giles]


Source Changes
--------------

Improved DIP switches in the yunsun16 driver and added more
documentation. [stephh]

Improved timer accuracy and added save state support to the 
6526 CIA module. [Nathan Woods]

Fixed bug in memory map dumping code that caused wrong addresses
to be dumped. [Wilbert Pol]

Connected TMS5220 speech support to the Major Havoc: Return to Vax
mod. [Jess Askey]

Changed comment shortcut in disassembly windows to avoid clash with
Ctrl+C for "Copy". [Nathan Woods]

Added checking for register symbol names to ensure they aren't
numeric (which prevents their identification by the expression
parser). Changed the M4510 CPU symbols to avoid tripping this
check. [Nathan Woods]

Fixed crash in the Win32 debugger code with small window sizes.
[Samuele Zannoli]

Fixed assertion when auditing systems with no samples or ROMs.
[Nathan Woods]

Some pmpoker driver improvements: [Roberto Fresca]
 - Added service/settings mode to pmpoker.
 - Added PORT_IMPULSE to manage correct timings for most inputs 
    in all games.

Fixed "run to cursor" functionality for CPUs that had an address
bus shift. [Andrew Gardner]

Fixed bug that caused false positive ZIP filename matches.
[Aaron Giles]

Added PATH_SEPARATOR define so that platforms with non forward-slash
path separators can get preassembled paths in their native format.
[Aaron Giles]

Some enhancements to the options manager: [Aaron Giles]
 * added a simpler options_init for startup
 * added support for internal options
 * added support for multiple unadorned options
 * moved core options definitions into the core options.c
    (note that the default INI path no longer includes $HOME/.mame
     since that is not cross-platform; *nix platforms will need to
     explicitly override that default in their OSD code)
 * added accessor to set the default value of a given option
 * changed error reporting so that errors are tracked internally
    and reported only once

Improved documentation in osdepend.h to better describe some of the
functions and provide a general overview of how things work. Removed 
unused osd_readkey_unicode function. [Aaron Giles]

Fixed bug in the bilinear software scaler that would read out of
bounds on a bitmap. [Aaron Giles]

Added supervisor DAC support to the Max-a-Flex driver. [Aaron Giles]

Fixed clock speeds on Turbo/Buck Rogers. [Aaron Giles]

Fixed -romident with ZIP files. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Rock Duck [Roberto Fresca, Tomasz Slanina, David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
DonPachi (Hong Kong) [Arenzo Fabrice]
Las Vegas, Nevada [Roberto Fresca]

New games marked as GAME_NOT_WORKING
------------------------------------
Destroyer (Cidelsa) [Curt Coder]
Altair [Curt Coder]
Draco [Curt Coder]


==========================================================================

0.109u1

IMPORTANT NOTE TO OSD DEVELOPERS: The file I/O interface has changed
significantly. It is now much simpler. Please read osdepend.h for
full details on how the new OSD-defined functions work. In addition,
you must now use the options.c to specify your search paths. If you
are parsing standard command line options and INI files, this work
is relatively straightforward. Otherwise, you can manually call
options_set_string() for each of the search paths to configure them
from whatever options store you are using.


MAMETesters bugs fixed (there are probably more)
-----------------------
silentd0108u5yel [Mamesick]
gradius30104u3gre [Mamesick]
spelunk2099u6gre [robzia]
twinactn0105u2gre [robzia]
czeroize0108u2yel [David Haywood]
listrom0109red [Aaron Giles]
chdbaddump0109ora [Aaron Giles]
ddrawcoloroverlay0109yel [Aaron Giles]
new_debugger0109ora [Aaron Giles]
ronnamelength0109ora [krick]
shtngmst0108u4ora [Pierpaolo Prazzoli]


Source Changes
--------------

More findout.c/getrivia.c improvements: [wolf676]
 - added ticket dispenser to Trivia/Sexual Trivia
 - found last unknown dipswitch in Selection/Poker
 - added missing "Payout" button; payout hardware unknown 
 - added missing "Play / Raise" button and its lamp 9
 - added "Button 12 ?" to selection, function unknown
 - re-added PORT_IMPULSE(2) to poker games buttons because they do 
    not like it if two or more buttons are held; trivia games still 
    respond better without this
 - changed coin_lockout_global to coin_lockout_w(0) and 
    coin_lockout_w(1) for 2 coin slots in selection; 
 - added missing lamps 11 (coin slot 2), 12 and 13 (unknown) 
    to selection

Fixed crash in the MPU4 driver. [El Condor]

Hooked up ARM ROM for kovsh, though it doesn't work yet. [ElSemi]

Some fixes for the 8080bw driver: [Robert]
 - The correct samples are being used for lrescue, lrescuem, 
    grescue, desterth 
 - Dipswitch corrections for superinv, invadrmr, sinvemag, 
    spceking, spacewr3 
- Remove extraneous beeping noise from indianbt 

Converted all the toaplan2.c games to mono since the PCBs are JAMMA
without external stereo connectors. [Corrado Tomaselli]

Added bounds checking to the qsound driver. [David Haywood]

Redesigned the OSD file I/O interfaces to be simpler and more
straightforward. Also simplified the core's file I/O routines and
included some functionality that was previously left to the OSD
layer. [Aaron Giles]

Rewrote unzip.c to return richer errors and generally behave better.
[Aaron Giles]

Rewrote audit.c to simplify the code and not rely on extraneous
functions that were in the old file I/O system. [Aaron Giles]

Simplified the 68000 core generation logic to just produce one
file. Hopefully this will cure some of the build issues with the
core. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Five a Side Soccer [Ville Linde]
Super Street Fighter II - The New Challengers [David Haywood, stephh]
Dynamic Shooting [Tomasz Slanina, Guru]
Doki Doki Penguin Land [Tomasz Slanina, Guru]
Shooting Gallery [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
The Cliffhanger - Edward Randy (World) [Patrik Styrnell]
Double Dragon 3 (Japan) [Corrado Tomaselli]
Twin Brats (set 2) [Patrik Styrnell]


==========================================================================

0.109

MAMETesters bugs fixed (there are probably more)
-----------------------
pitfight0106u3gra [Canim]
turbofrc37b1gre [Canim]


Source Changes
--------------

More merit, getrivia, and findout improvements: [wolf676]
 - added external coin counters and coin lockouts
 - fixed lamps in upright and cocktail modes
 - getrivia.c: fixed sound in selection and clone
 - located ticket out bit in trivia games and commented it in 
    both drivers.
 - fixed merge collision from u5

Input port cleanup and additional comments in the CPS1 driver.
[stephh]

Fixed ES5503 behavior for voice volumes > 127 (cures missing 
sounds/music notes in several Apple IIgs demos and games).
[R. Belmont]

Made MSC1937 operation more accurately match datasheet and wiring
diagram. Added indexed getters to the output system to match the
newly introduced setters. [El Condor]

Changed input port calculations to go in two passes, to catch
out-of-order conditionals properly. [HobbesAtPlay]

Fixed priorities in the m62 driver, mainly affecting Lode Runner
sequels. [robiza]

Fixed PNG code so that it doesn't NULL terminate tEXt chunks.
[Mathis Rosenhauer]

Changed disassembler override callbacks to match new disassembler
syntax. [Nathan Woods]

Changed artwork loading to be on-demand rather than all up-front.
Also added a message during artwork resizing/loading so it's more
clear what is going on. [Aaron Giles]

Added new osd function osd_break_into_debugger() which can be hooked
to cause a break into the OSD's debugger when an assertion or
fatal error occurs. Hooked it up on Windows to do just that.
[Aaron Giles]

Normalized exit codes from mame.exe. The core-specific ones are
defined in mame.h. The Windows build will also return code 100 on
an unhandled exception now. [Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Astro Combat (older, PZ) [f205v]
Funky Bee (bootleg, harder) [f205v]


==========================================================================

0.108u5

MAMETesters bugs fixed (there are probably more)
-----------------------
mf_bdash0108u4gre [Aaron Giles]


Source Changes
--------------

Fixed priority in galivan and danger (and clones). Added save state
support to all games in galivan.c. Fixed portability issue in DAC
audio save states. [Vas Crabb]

Fixed bug in software renderer that prevented lower-resolution
targets from being properly supported. [smf]

Rewrote the Atari vector generators, using the schematics and actual
state machine PROMs. The state machine is now emulated so timing 
should be much more realistic. Clipping hardware in bzone and others 
is emulated instead of hardcoded. Improved accuracy of clocks and
various other bits of cleanup. [Mathis Rosenhauer]

Some more cleanups to the getrivia, findout, and merit drivers:
[wolf676]
 - corrected order of buttons and lamps in the games
 - removed impulse(2) from buttons -> buttons respond much better now
 - added coin 2 to Selection and Trivia
 - Poker and Sexual Trivia have no coin 2 -> unique inputs defined
 - used PORT_INCLUDE() and PORT_MODIFY() where possible
 - connected outputs for use with artwork

Major updates to the Nintendo 64 based driver. [Ville Linde]

More improvements to the pmpoker driver: [Roberto Fresca]
 - Confirmed the GFX banks (a complete dump appeared!).
 - Improved technical notes and added a PCB layout based on PCB pics.
 - Found and fixed the 3rd bitplane of BigBoy gfx.
 - Renamed Big-Boy to Golden Poker Double Up.
 - Added 'Joker Poker' (Golden Poker version without 'double-up').
 - Added 'Jack Potten's Poker' (same as Joker Poker, but with 
    'Aces or better' instead of jacks).
 - Simulated colors for all sets till color PROMs appear.
 - Completed inputs in all sets (except DIP switches).

Undid previous (incorrect) 'fix' of shangha3 sound clock. [Canim]

Implemented some port conditions for gmgalax, so you only see the
relevant DIP switches for the active game. [Canim]

Numerous fixes to the cheat engine. [ShimaPong]

Updated the TN2A03 CPU to match the proper cycle timings and 
unsupported opcodes revealed by Blargg's NES chip test. [Wilbert Pol]

Another big update to the ST-V driver: [Mariusz Wojcieszek]
 - scsp: improved interrupt reset. diehard, dnmtdeka, vfkids, 
 - colmns97 have sound now
 - vdp1: added mesh effect for the sprites 
 - vdp1: added polylines
 - vdp2: optimized rbg rendering
 - stv:  added speedups for dnmtdeka and diehard
 - stv:  corrected some set names/descriptions

Fixed crash in Windows code if we are unable to create sound buffers.
[Nathan Woods]

Fixed bug that caused Turbo sprites to be exceedingly large.
[Aaron Giles]

Began rewrite of Grand Champion driver. Still work to do on collision
detection, radar, and some glitches. [Aaron Giles]

Added new output utilities: output_set_led_value(), 
output_set_digit_value(), output_set_lamp_value(), which are used to
set a generic indexed data type. Changed Turbo and Max-a-Flex over to
using output_set_digit_value() for their digits. [Aaron Giles]

Rewrote the PNG reading/saving code, improving error reporting and

simplifying the code significantly. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Pocket Racer [smf, Guru]
PlayMan Poker (Germany) [Roberto Fresca]
Killer Instinct (SNES bootleg) [Tomasz Slanina]
Real Fun (Version 7.01) [Brian Troha]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
World Class Bowling (v1.5) [Brian Troha]
Gryzor (Set 2) [Stefan Lindberg]
Power Drift (World) [Stefan Lindberg]
Strikers 1945 (Korea) [Arzeno Fabrice]
10-Yard Fight (World) [Brian Troha]
Final Lap R (Japan Rev. C) [Arzeno Fabrice]


==========================================================================

0.108u4

MAMETesters bugs fixed (there are probably more)
-----------------------
gotya0107u3yel [David Haywood]
spcewars36rc2ora [Robert]
prehisle0104u5gre [Vas Crabb]
shangha3237b7gre [Canim]


Source Changes
--------------

Added support for reverse-order entry in the BFM code. [El Condor]

Cleaned up DIP switches and documentation in the merit.c and 
coinmstr.c drivers. [wolf676]

Updated the MPU4 layout and added more documentation. [El Condor]

Fixed neocrypt.c to work on big-endian machines. [R. Belmont]

Improved DIP switches for spcewars and invadpt2. Fixed sound in
spcewars. [Robert]

Fixed UI for cheat system watchpoints, making them usable again.
[Nicola Salmoria]

Fixed flipscreen mode for liquidk and other games using the same
Taito graphics chips. [Robzia]

Added many more notes/info to the arkanoid driver. [stephh]

Added save state support for YM3812, YM3526 and uPD7759 sound chips, 
and Prehistoric Isle video hardware. Also added partial save state
support for the Y8950 sound chip. [Vas Crabb]

Did a bit of object-orienting the core. All core init functions now
take a running_machine parameter. All exit, reset, and pause 
callbacks now require a running_machine parameter to register, and
pass in the running_machine when called. [Aaron Giles]

Added a running_machine parameter to the following driver callbacks:
  DRIVER_INIT
  MACHINE_START/MACHINE_RESET
  SOUND_START/SOUND_RESET
  VIDEO_START/VIDEO_RESET/VIDEO_EOF/VIDEO_UPDATE
  NVRAM_HANDLER/MEMCARD_HANDLER
For the most part, this didn't affect the code thanks to the macros,
apart from cases where direct calls were made. [Aaron Giles]

Altered most of the mame.c and palette.c interfaces to take a
running_machine parameter. Hung private data for these modules off of
the running_machine structure instead of using global variables.
[Aaron Giles]

Did some cleanup and de-Achoization of the palette code. Removed some
features used only by Grand Champion, which only complicated things
for all the other drivers. Marked Grand Champion as imperfect graphics
until it gets rewritten. [Aaron Giles]

Since I had to visit all call sites of palette_set_color to add the
running_machine parameter, I also updated quite a lot of them to use
the nice palnbit() inlines in palette.h, which cleaned up the code in
many cases. Since this was a manual process, I probably messed up one
or two cases, so if you notice odd colors, please report them to the
http://mametesters.org site. [Aaron Giles]

More Turbo work: cleaned up the sound code, added support for proper
speaker placement in all games, a few other minor fixes. Sprite
scaling is still not 100%, but I need some real hardware to verify.
Apart from that, no further work is planned. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Shooting Master [David Haywood, Tomasz Slanina]
Quizmaster (German) [wolf676]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Gals Panic II (German) [Patrik Styrnell]
Pocket Gal 2 (Japanese) [Patrik Styrnell]
Locked 'n Loaded (World) [Patrik Styrnell]
Mad Ball V2.0 (hack? With Nudity) [f205v]
Arkanoid (Tayto bootleg, harder) [stephh]
Arkanoid (Game Corporation bootleg, set 2) [stephh]
Arkanoid (bootleg with MCU, harder) [stephh]


==========================================================================

0.108u3

Source Changes
--------------

Improved offsets of the "normal spites" in the SSV games twineag2,
ultrax, and dynagear. [robzia]

Added missing video change to the lethalen driver. [David Haywood]

Some nice improvements to the debugger: [Andrew Gardner]
 * added ability to tab between views in the disassembly windows
 * added a 'cursor' to the dasm view and hooked up navigation keys
 * added F4 'run to here' key when the disasm view has focus
 * added F9 'toggle breakpoint' key when the disasm view has focus
 * enhanced memory view keyboard navigation

Added workaround for crash in the sound code under some edge cases.
[David Haywood]

Fixed background ROM loading in the new wbmlbg set. [David Haywood]

Overhauled and corrected the DIP switches in the trivia and quiz 
games in the findout driver. [wolf676]

Added PORT_DIPLOCATION to the airbustr driver. [Roberto Fresca]

TIA-MC1 driver improvements: [Eugene Sandulenko]
 - fixed documentation
 - hooked game counter and coin lockout
 - added save state support

Fixed 6840 counter behavior in continuous mode. [El Condor]

Identified some unknown DIP switches in Robby Roto. [wolf676]

Big update to the arkanoid driver which improves emulation of some 
bootlegs: [stephh]
 - Interverted 'arkblock' and 'arkbloc2' sets for better comparaison
 - Renamed sets :
    * 'arkbl2' -> 'arkmcubl'
    * 'arkbl3' -> 'arkgcbl'
 - Changed some games descriptions
 - Removed flags from the following sets :
    * 'arkbloc2' (old 'arkblock')
    * 'arkgcbl' (old 'arkbl3')
    * 'paddle2'

Fixed a multithreading race condition at startup. [Nathan Woods]

Added some minimal validation on the sample rate configuration
parameters. [Firewave]

Fixed a few dips and added diplocation setting for Wonder Stick 
in the nmg5.c driver. [Brian Troha]

Big update to the MPU4 driver: [El Condor]
 - added support for reverse clocking in the VFD code. 
 - changed the 6840 to not run the counter clock if no frequency 
    is specified
 - reworked the MPU4 drastically to be more in sync with AGEMAME
 - MPU4 video should now be working a little better
 - deprecated 6850acia.c, replacing it with a specialized driver

Updated core.mak to ensure the make clean will remove file2str.exe.
[Nathan Woods]

Added new ROM loading option, ROM_IGNORE() which works just like
ROM_CONTINUE() except that you don't need to load the data anywhere.
It can be used when larger ROMs are present and only a portion of the
data is used. See solomon.c for an example. [Aaron Giles]

Removed support for the old debugger. [Aaron Giles]

Added driver_data member to the Machine structure, where drivers can
hang data instead of using global variables. Added MDRV_DRIVER_DATA
macro so the core can allocate this structure at startup. Added
AM_BASE_MEMBER and AM_SIZE_MEMBER which are similar to AM_BASE and
AM_SIZE but let you specify a member of a struct hanging off of 
driver_data. Updated the Turbo driver to use these new features as an 
experiment. [Aaron Giles]

More Turbo driver cleanup: [Aaron Giles]
 * doubled the horizontal resolution to better draw analog sprites
 * improved Buck Rogers and Subroc video


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Solomon's Key (US) [Bobby Conover]
Commando (bootleg) [ClawGrip]
Beam Invader (set 2) [Peter Townson]

New games marked as GAME_NOT_WORKING
------------------------------------
Connect 4 [El Condor]
PlayMan Poker (Germany) [Roberto Fresca]
Big Boy [David Haywood]


==========================================================================

0.108u2

MAMETesters bugs fixed (there are probably more)
-----------------------
loadstate0108u1red [Aaron Giles]
dooyong0108u1red [Aaron Giles]
deadang0108u1red [Aaron Giles]
pang337b15gre [robiza]
botanic080u1gra [robiza]


Source Changes
--------------

Fixed options_output_ini_file() and options_output_ini_mame_file() 
to properly handle string options containing spaces. [Nathan Woods]

Fixed incorrect DIP switches in Trivia (Version 1.03), Selection,
and Poker games (getrivia.c). [wolf676]

Added PORT_DIPLOCATION macros to a number of drivers based on 
research. [Roberto Fresca]

Fixed several issues with pausing and the multithreading code.
[Nathan Woods]

Cleaned up the vacfdisp module to display 14 and 16 segment displays.
Added a separate character set for the OKI MSC1937. Changes Scorpion
2 to the new system. Tidied up the 6840 emulator a bit. [El Condor]

Attempted to fix the bad Space Odyssey ROM by using data from the
previous dump. It is still marked BAD_DUMP (we would like to get an
actual dump), but the new Space Odyssey is now playable. [MASH]

Removed recently-introduced case dependency in the ROM naming.
[Buddabing]

Added new option -multithreading (-mt) which enables the previous
multithreaded rendering code. This code has had problems on some
systems, especially pre-XP systems, so consider it experimental. If
you want to help debug issues, enable LOG_THREADS in windows/window.c
and post them to MAMETesters.org with a description of your problem
and your system. If you don't have hyperthreading, dual core, or a
multi-CPU system, don't bother turning this flag on. [Aaron Giles]

Changed the behavior of the led7seg primitive. It now no longer takes
a state value but accepts states from 0-255, allowing independent
control over all 7 segments and the decimal. Ordered the segments
according to standard order. Updated the Turbo driver to do its own
BCD decoding via an LS48 decoder to control the segments directly.
This will break existing layouts using the led7seg primitive. 
[Aaron Giles]

Further turbo driver cleanup. Still in WIP. [Aaron Giles]
 * derived sprite scaling from PROMs and R/C values (still not 100%)
 * rewrote most of the video/sprite handling
 * identified all PROMs and used them where appropriate
 * added a more complete 8279 implementation
 * converted 7-segment LEDs to the new behavior described above


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Carrera (Version 6.7) [David Haywood]
Swinging Singles [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Lethal Enforcers (4 sets) [Patrik Styrnell, David Haywood]
Muroge Monaco (set 2) [Roberto Fresca]


==========================================================================

0.108u1

MAMETesters bugs fixed (there are probably more)
-----------------------
mbrush067gre [robiza]
bonzeadv0107u4red [robiza]


Source Changes
--------------

Fixed some DIP switches in bigrun and wildplt, and changed UK region
to Europe in f1gpstar and f1gpstr2. [Sonikos]

TIA-MC1 improvements: [Eugene Sandulenko]
 - More documentation
 - fixed inputs
 - fixed video framerate and VSYNC delay
 - adjusted CPU freq according to documentation
 - removed hack with off-board video RAM
 - implemented sound
 - added NO_DUMP PROMs

Improved documentation in the asteroids and tempest drivers.
[Brian Troha]

Improved DIP switches and documentation in the Championship Bowling
driver. [Brian Troha]

Major cleanup/rewrite of the NES PPU rendering code. [Brad Oliver]

Fixed protection in the world version of Virtua Bowling. [Brian Troha]

Fixed collision detection in Halley's Comet '87. [Brian Troha]

Added missing DIP switch to Hangman driver. [Wolfi]

Added a callback to the 68000 emulator for the TAS instruction,
which allows different implementations based on external hardware.
[David Haywood]

Namco System 22 update: [R. Belmont]
 - Fixed ROM loading problems reported by Guru
 - Hooked up Prop Cycle fan and lamp to the new output system

Added new flag: VIDEO_ALWAYS_UPDATE, which causes the VIDEO_UPDATE
callback to be called even on skipped frames. This should be used
for games where the process of rendering has side effects such as
collision detection that need to always be present. [Aaron Giles]

Fixed the new scanline timing functions to compute things
correctly and without using unnecessary timers. [Aaron Giles]

Fixed inputs in the Sega G80 vector games which were broken in the
last release cycle. [Aaron Giles]

Began cleanup/rewrite of the Turbo driver: [Aaron Giles]
 - proper video timings
 - full memory map
 - cleanup/simplification of the video code with better documentation
 - some things are still broken, this is a WIP


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Space Bugger (set 2) [Tomasz Slanina]
Reaktor (Track & Field Conversion) [Col Turner]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Ninja Ryukenden (Japan, set 2) [Patrik Styrnell]
Silent Dragon (US) [Patrik Styrnell]


==========================================================================

0.108

MAMETesters bugs fixed (there are probably more)
-----------------------
darius2056gre [robiza]


Source Changes
--------------

Fixed bug that prevented in-game MNG recording from working.
[Rene Single]

Added more extensive documentation to several of the Sega 16-bit
drivers. [Brian Troha]

Fixed color decoding in Cheeky Mouse. [Nicola Salmoria]

Improved DIP switches for headoni and spacbeam. [wolf676]

More debugger comments fixes: [Andrew Gardner]
 - adding a comment no longer redefines the disasm range.
 - comments properly save and load special characters (&,", etc)

Added sample_get_base_freq() to allow for querying to the base
frequency of samples. [Aaron Giles]

More G80 work: [Aaron Giles]
 - finished video cleanup
 - fixed Space Odyssey controls
 - added crude support for Astro Blaster attack rate
 - hooked up 005 melody generator, but missing sound PROM
 - finished sound cleanup

Changed debugger to default to 'on' in debug builds. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Konek-Gorbunok [Eugene Sandulenko]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Teenage Mutant Hero Turtles (UK 2 Players, set 2) [Patrik Styrnell]
Teenage Mutant Hero Turtles - Turtles in Time (2 Players ver EBA)
   [Patrik Styrnell]
Wonder Boy (set 4) [Nicola Salmoria]


==========================================================================

0.107u4

MAMETesters bugs fixed (there are probably more)
-----------------------
mngrecording0107u1ora [Aaron Giles]
vectorsnapshot0107u1red [Aaron Giles]
tdfever087u4gra [Canim]
quizmeku087u4gra [Canim]


Source Changes
--------------

Fixed the dips for Apache 3 and Dark Mist. [Brian Troha]

Added built-in overlays for clowns and maze. [Mr. Do!]

Converted Final Romance 2 to be dual screen. [David Haywood]

Converted the VFD display in the BFM games to use a second screen
rather than hacking onto the main screen. [El Condor]

Fixed detection of left/right modifier keys when paused. Also added
support for recently added keys so they are detected by MAME when
paused. [Ben Rudiak-Gould]

Changed render_target_alloc() to take a bitmask of flags. In addition
to loading a single file, targets can also be marked "hidden", and
only non-artwork views can be made visible. [Aaron Giles]

Added new render target layer config flag to disable screen overlays.
[Aaron Giles]

Changed snapshot taking code to render the particular screen to a
temporary render target. This allows vector games to have snapshots
again. [Aaron Giles]

Normalized the naming of several functions in video.c, most 
importantly: [Aaron Giles]

   force_partial_update -> video_screen_update_partial
   configure_screen -> video_screen_configure
   set_visible_area -> video_screen_set_visarea

Added new functions that do accurate per-screen timing based on
video parameters: [Aaron Giles]

   video_screen_get_hpos
   video_screen_get_vpos
   video_screen_get_hblank
   video_screen_get_vblank
   video_screen_get_time_until_pos

Fixed bug that caused the VIDEO_EOF to be called repeatedly while in
the debugger. [Aaron Giles]

Split render.c into rendutil.c, rendlay.c, and render.c to keep the
code more organized. [Aaron Giles]

Abstracted the notion of outputs. A new module, output.c, now controls
all outputs. Each output is tagged with a name; some standardization
eventually needs to happen on these names, but at the moment it's
fully open. The OSD layer can register with output.c to be notified
when outputs change. From there, it is free to do what it wants. LEDs
have now been converted to outputs with the name "led0", "led1", etc.
[Aaron Giles]

Added support for notifying external clients of changes in output
states in the Windows OSD system. See windows/output.h for a list of
messages that external clients can register to receive. Removed the
built-in hacky LED support in the Windows OSD layer. Created a sample
application ledutil.exe which subscribes to the external events and
routes the "led0", "led1", and "led2" outputs to the keyboard LEDs
just like before. If you want to continue to have LED support, simply
copy ledutil.exe into your startup folder and let it run in the
background. [Aaron Giles]

Modified the Q*Bert driver to signal a "knocker0" output when the
knocker is triggered. [Aaron Giles]

Added new layout element component type "text", which lets you draw
text in the built-in MAME font onto an element in a layout. This
can be used for basic lamps and built-in layouts. See maxaflex.c for
an example. [Aaron Giles]

Added new layout element component type "led7seg", which constructs
a 7-segment LED in an element in a layout. This is commonly used for
external score and timer displays. See maxaflex.c for an example.
[Aaron Giles]

Added built-in layouts for Turbo, Subroc 3D, Buck Rogers, Atari
Football, Atari Baseball, and Super Speed Racer using the new 
primitives. [Aaron Giles]

Fixed overflow computation in the S2650 core. [Aaron Giles]

More Sega G-80 raster cleanup: [Aaron Giles]
 * consolidated the video hardware implementations
 * fixed cocktail mode video and controls in all games
 * fixed Monster Bash (2 board version) video
 * revived Sindbad Mystery and fixed sound chip frequencies


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Trivia Quest [Pierpaolo Prazzoli]
SunA Quiz 6000 Academy [David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Zero (set 2) [David Haywood]


==========================================================================

0.107u3

MAMETesters bugs fixed (there are probably more)
-----------------------
pignewt0106u3gre [Aaron Giles]
ui_draw_text0.107u2red [Aaron Giles]
blueprnt0107u2red [Aaron Giles]


Source Changes
--------------

Improved DIP switches in benberob. [Brian Troha]

Added support for real Bubble Bobble MCU. [Trinity, Nicola Salmoria]

Fixed track lookup implementation in Virtua Racing, bringing the
game much closer to playable. [Olivier Galibert]

Minor cleanup and speed hack removal in the konamigx.c [R. Belmont]

Improved magicfly driver. All graphics are properly decoded / banked 
now. [Roberto Fresca]

More improvements to the 6840 timer module. Updated the MPU4 driver
to the most recent implementation. Convert Cosmic Chasm over to
using the new system. [El Condor]

65816/377xx update: [R. Belmont]
 * Made block transfer instructions interruptable as they are on 
    both actual chips (previously a single opcode could eat >400,000 
    cycles with obvious consequences for interrupt timing)
 * M377xx block transfers move one less byte than the 65816, fixed

Adjusted the DAC sound level on the 2612 to something more 
reasonable. [David Haywood]

Taito JC update: [Ville Linde]
 * Some general improvements to the driver
 * Added some more opcodes to the TMS320C51 core

Improved the M2 driver so that the M2 kernel starts to boot, but it 
hangs quite soon due to some multiprocessor issues. [Ville Linde]

Updated several games' input ports to use IPT_BILL1 for bill 
acceptors. [ClawGrip]

Properly documented and connected the MCU code in the Namco System 1,
System 86, Baraduke, Pacland, and Sky Kid drivers. [Brian Troha]

Renamed "Native" views to "Pixel Aspect" views to avoid the confusion
that they are anything but artificial aspect ratios. [Aaron Giles]

Added beam width control to the UI sliders. [Aaron Giles]

More Zaxxon driver cleanups/fixes: [Aaron Giles]
 * fixed sound problems in Razmataz
 * corrected background and sprite positioning
 * fixed bugs introduced in sample handling
 * bootlegs and alternate versions work again
 * added state saving support to the Sega universal sound board

Added several common generic graphics layouts to vidhrdw/generic.c, 
for use by multiple drivers. [Aaron Giles]

Added new option -video none which can be used for CPU benchmarking
without the overhead of the video system. [Aaron Giles]

Fixed remaining crashes in GDI/ddraw mode when drawing vector games.
[Aaron Giles]

Removed the -artwork option to avoid confusion. If you want to run
without any artwork, use -view standard instead. [Aaron Giles]

Added options -screen, -aspect, -resolution, and -view which apply
to all windows. These values can be individually overridden for each
specific window by using the existing -screen<n>, -aspect<n>,
-resolution<n>, and -view<n> options. [Aaron Giles]

Fixed bug that caused the sound sampling code to not track changes in
the refresh rate. [Aaron Giles]

Began cleanup/rewrite of the Sega G-80 raster games. This is still
very much a WIP, so don't report any bugs: [Aaron Giles]
 * cleaned up input port handling similar to the G-80 vectors
 * proper clock and video speeds
 * reimplemented Space Odyssey background including collision detect
 * fully implemented Pig Newton background
 * connected 2-board Monster Bash more correctly

Added new macro PORT_SERVICE_DIPLOC for specifying a PORT_SERVICE
and a DIPLOCATION. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Trivia ? Whiz (Edition 3) [Pierpaolo Prazzoli]
Legend of Heroes [Pierpaolo Prazzoli]
Super Bubble 2003 [Pierpaolo Prazzoli]
Dambusters [Norbert Kehrer]
Catacomb [Mike Coates]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Galaga (Midway set 1 with fast shoot hack) [David Widel]
Versus Net Soccer (3 new versions) [R. Belmont, f205v]
Ace Attacker (System 16A) [Arzeno Fabrice]
Arm Champs II v2.6 [Gerald Coy]

New games marked as GAME_NOT_WORKING
------------------------------------
Casino 5 [Pierpaolo Prazzoli]


==========================================================================

0.107u2

MAMETesters bugs fixed (there are probably more)
-----------------------
savestate0104u7ora [Adam Bousley]
ripoff097gre [Adam Bousley]
cuebrckj0104u2gra_fix [Canim]


Source Changes
--------------

Massive cleanup/fixing of 16-bit Sega drivers: [AWJ]
 * many corrections to descriptive set names, adding revision letters,
    cabinet types, etc.
 * fixed many DIP switches and added PORT_DIPLOCATION support
 * adjusted min/max values for analog controls to improve response
 * fixed button ordering between System 16A/B
 * cleaned up a number of ROM names and fixed some incorrect guesses
 * some cleanup of turbo.c as well
 * fixed visible area in Hang-On hardware
 * actually disabling 8751 in games that have a fake replacement
 * hooked up 8255 PPI correctly now that it has mode 2 support
 * fixed behavior of NMI line in later sega sound boards
 * fixed addressing in the SegaPCM sound system
 * some hardware/documentation cleanup

Some cleanups in the new UI/video code to make MESS happy.
[Nathan Woods]

Added macros to prevent use of strcasecmp and strncasecmp for
better cross-platform compatibility. [Nathan Woods]

Connected unimplemented opcode $01 on the 6809 core. [Antoine Mine]

Implemented CNT pin and some serial features of the 6526 CIA chip.
[Nathan Woods]

Mapped service button in slammast. [Canim]

Fixed bug in 8039 CPU handling of A11 latch. [Aaron Giles]

Rewrote Zaxxon driver from the schematics. This is still a WIP (not
finished yet): [Aaron Giles]
 * correct clock speeds and video timing
 * complete memory maps
 * connected universal sound board to Ixion and Razmataz
 * simplified video code and merged common cases together
 * palette derived from resistor weights
 * background positioning still a little off

Added service_coin_lockout_w() to lockout service coins. [Aaron Giles]

Added MDRV_SCREEN_RAW_PARAMS() which lets you specify a pixel clock,
horizontal, and vertical video timing values in place of the usual
screen size, visible area, refresh rate, and VBLANK timing values.
[Aaron Giles]

Fixed bug that prevented save/restore from working in the UI.
[Aaron Giles]

Changed mode selection logic so that refresh is weighted more strongly
when picking a mode. This allows you to specify -resolution 0x0@60 to
force MAME to pick a 60Hz screen refresh while allowing it to choose
the best resolution. [Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Viper Phase 1 (World, New Version) [Corrado Tomaselli]
Wonder Boy in Monster Land (Galaxy Electronics English bootleg)
Gals Panic II (Asia) [Patrik Styrnell]


==========================================================================

0.107u1

MAMETesters bugs fixed (there are probably more)
-----------------------
timecrsa0100u1gra [Luigi30]
inputduplication0106u7gra (nyny, joust, lghost, hyhoo) [Luigi30]
lastduel0106u7gra [Luigi30]
jdreddp0106u1gra [Luigi30]
bzone0104u7gra [Aaron Giles]
pturn0104u7gra [ShimaPong]
tsamurai0103gra [Aaron Giles]
pause0102gra [BUT]
mameini0107ora [Aaron Giles]
omegafc0107yel [Aaron Giles]
s2650_0106u11ora [Minuous]
syvalion0107yel [Aaron Giles]
congo0107red [Aaron Giles]


Source Changes
--------------

Removed hard core dependency on samples. [Andrew Gardner]

Added what seems to be a proper fix for the background transparency 
flag that was needed by champbwl to show the green background.
[Pierpaolo Prazzoli]

Updates to the MagicFly driver: [Robert Fresca]
 - Figured out the MC6845 (mapped at $0800-$0801)
 - Fixed the screen size based on MC6845 registers.
 - Fixed the visible area based on MC6845 registers.
 - Corrected the gfx rom region.
 - Solved the NMI/vblank issue. Now attract works.
 - Changed CPU clock to 625khz.
 - Added new findings to the technical notes.
 - Marked magicfly PAL as NO_DUMP (read protected).

Fixed memory write ordering bug in the 68000 core. [Charles MacDonald]

Added some PPC602 specific opcodes and registers. [Ville Linde]

Removed NEW_RENDER definition and all support for the old rendering
system from the core. Cleaned up a bunch of useless and deprecated
code as a result. [Aaron Giles]

Massively rewrote the user interface to rely on the new rendering
systems. Broke the UI into multiple pieces (ui.c, uimenu.c, uigfx.c).
The code is now verging on readable. [Aaron Giles]

Renamed ui_popup to popmessage across the code, and implemented
popmessage in mame.c. This breaks the dependency between the core 
driver code and the user interface in almost all cases. [Aaron Giles]

Added a red background to serious warning messages in the vain hope
that people might take better notice. [Aaron Giles]

Fixed vector game crashes with DirectDraw rendering. [Aaron Giles]

Consolidated live screen parameters into a screen_state structure.
Machine->visible_area[num] is now Machine->screen[num].visarea.
Machine->refresh_rate[num] is now Machine->screen[num].refresh.
[Aaron Giles]

Added new function configure_screen() which can control the width,
height, visible area, and refresh rate of each screen. This function
allows for widths and heights larger than what were specified in the
game driver, so you no longer have to specify the maximum width and
height in the driver, but can instead specify a typical width and
height. This function supercedes the old set_visible_area() and
set_refresh_rate() functions. The former has been rewritten to call
configure_screen(), while the latter has been removed entirely.
[Aaron Giles]

Changed the behavior for supporting overscan and other effects. The
width and height of a screen control the overall bitmap size. The
visible area of a screen specify its non-blanked boundaries (and 
default visible area, as before). [Aaron Giles]

Moved line-to-quad conversion routine into the core render.c as
another utility function. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
TomCat (Star Wars hardware, prototype) [Mathis Rosenhauer]
Poke Champ [David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Dungeons & Dragons: Shadow over Mystara (Brazil 960223) [Brian Troha]


==========================================================================

0.107

NOTE: This is the first full release of MAME with the new rendering
system. Before freaking out that things don't work the way you
expected, please read the docs/newvideo.txt file that gives some
suggestions for how to set up your base configuration. If you still
encounter issues, then run your system with the -v option and post
about your problem at http://mametesters.org.


MAMETesters bugs fixed (there are probably more)
-----------------------
xxmissio0106u12yel [quzz]
laser0106u10ora [gregf]
kof10th0106u1ora [f205v]
pignewt0106u3gra [Machone]
cheatwatchpoint0106u11ora [ShimaPong]


Source Changes
--------------

Fixed keyboard inputs in the Taito Wolf driver. [Ville Linde]

Added tile flipx to tilemaps in yunsung16.c (bomb kick needs it) 
and changed the DIP switches used for protection to real DIP 
switches. [Pierpaolo Prazzoli]

Fixed crash in the PGM driver. [David Haywood]

Properly emulated the sprite overdraw effect in ninjakd2. Now you 
can see the "opening" effect and the previously 2 bugged levels are 
fixed. Converted the driver to use tilemaps as well.
[Pierpaolo Prazzoli]

Additional updates to the magicfly driver. Improved documentation
and input port mapping. [Roberto Fresca]

Fixed gamma and brightness ranges in the UI to match the limits from
the command line. [Aaron Giles]

Fixed default flicker value to 0. [Aaron Giles]

Fixed scrolling in the palette view. [Aaron Giles]

Fixed assertion when the MAME window was minimized. [Aaron Giles]

Fixed bug that prevented resizing of secondary windows. [Aaron Giles]

Rewrote Missile Command driver from schematics: [Aaron Giles]
 * CPU speed now correct (slows down for lower 32 scanlines)
 * proper frame rate and IRQ signal timing
 * service mode works on some sets, fails on others due to 6502 bug
 * accurate bitmap mapping and cycle counts for 3-bit accesses
 * using bitmap access PROM for bit mode writes


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Head On (Sidam bootleg) [David Haywood]
Super Crash (bootleg of Head On) [David Haywood]
Borderline (Sidam bootleg) [David Haywood]
Lunar Rescue (Model Racing bootleg) [David Haywood]
Agent X (prototype) [Aaron Giles]

New games marked as GAME_NOT_WORKING
------------------------------------
Ripper Ribbit [Guru]
Chicken Farm [Guru]
Crazzy Clownz [Guru]
Super Bubble 2003 [Pierpaolo Prazzoli]
Legend of Heroes [Pierpaolo Prazzoli]
Hidden Catch 3 [Pierpaolo Prazzoli]
Pro Golf [Pierpaolo Prazzoli]
Midnight Landing [David Haywood]


==========================================================================

0.106u13

MAMETesters bugs fixed (there are probably more)
-----------------------
resolutionrating0106u12yel [Aaron Giles]


Source Changes
--------------

Some more fixes for the DTD in the -listxml output. [Krick]

Added more previously dumped PLDs to a number of games. [MASH]

Fixed uninitialized variable in the debugger commenting code. Cleaned
up allocations. [Nathan Woods]

Improved multisession support with the new renderer. [Nathan Woods]

Hooked up color PROM for schaser and fixed DIP switches.
[Robert]

Fixed bug that caused -prescale in Direct3D mode to fail in the last
release. [Aaron Giles]

Fixed bug that led to black crosshairs in lightgun games.
[Aaron Giles]

Reimplemented the sparkle circuit to bring back stars in Tempest.
[Aaron Giles]

Removed the background brightness in vector games by default. If you
want to see the overlays faintly on vector games, increase the
brightness a bit. [Aaron Giles]

More Crystal Castles tweaks: [Aaron Giles]
 * Connected EAROM correctly (passes POST now)
 * Added a guess for what the "POTATO" chip does. If you're a CC fan
    report to MAMETesters how MAME looks compared to the arcade when 
    the screen scrolls up inbetween level 4 and 5.

Rewrote Cloud 9 driver to mimic the Crystal Castles driver since it
is obviously an early version of the same hardware: [Aaron Giles]
 * Implemented video RAM banking correctly based on tracing out a
    Firebeast PCB, which appears to be identical
 * Traced out color mapping and implemented correctly
 * Reduced EAROM down to 4 bits
 * Fixed DIP switch definitions

Some minor modernization of the xxmissio driver. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Firebeast (prototype) [F.J. McCloud]
Digger Man (prototype) [MAME32Plus]


==========================================================================

0.106u12

MAMETesters bugs fixed (there are probably more)
-----------------------
gaelco20106u1ora [David Haywood]


Source Changes
--------------

Added a large number of previously-dumped PALs to various games
across the whole source base. [MASH]

Some graphics improvements to the Magic Fly driver. [Roberto Fresca]

Fixed the fire button INPUT_PORT of player2 in Lethal Enforcers.
[Cananas]

Changed the coordinates where for offscreen lightgun reloading, moving
it from the upper-left to the upper-right for better compatibility.
[Cananas]

Fixed interrupt clearing function in 6840 module. [El Condor]

Added multiple input controls in -listxml output for games with more 
than one type. Added pedal control type. Added more info on analog 
controls as defined in the driver: minimum, maximum, sensitivity, 
keydelta, and reverse. This required the 'control' attribute in the 
XML to be moved into an element. There can now be more than one
'control' element in the input secction. [uRebelScum]

Improved the description of screens in -listxml. Multiple screens
are now listed, each with their own attributes. Rotation is now fully
specified (rather than just vertical/horizontal). The width and 
height now describe the raw game screen before any rotation.
[Krick]

Fixed bug that caused the UI to be impacted by command-line 
brightness, contrast, gamma controls. [Aaron Giles]

Fixed bug that prevented the contrast from pushing vector games to
their maximum brightness. [Aaron Giles]

Rewrote Crystal Castles driver from the schematics: [Aaron Giles]
 * corrected clock speeds and frame rates
 * reimplemented video system to use mixer PROM
 * now using sync PROM to generate interrupts at correct times
 * sync PROM is also used to determine proper visible area and
    VBLANK timings
 * implemented the VRAM write protection by using the WP PROM
 * hooked up second player trackball properly
 * fixed coin counters
 * now computing palette based on resistor weights
 * watchdog is now set for 8 VBLANKs to match the schematics
 * added save state support
 * mapped complete memory space according to schematics

Fixed bug in JED parsing code that would checksum fuses beyond the
number explicitly specified. Some programs write extra fuse data
beyond the end and this should not be part of the checksum. Also made
the checksum parsing more flexible to handle JED files with extra 0
digits in the file checksum. [Aaron Giles]

Removed xml2info utility. The -listinfo format was retired over 2 
years ago. It is time to move on. [Aaron Giles]

Changed the core makefile to put back specific rules for building
EXEs to promote more commonality with platforms that don't put an
extension on executable files. [Aaron Giles]

Added gapless variants to the dual and triple screen layouts.
[Aaron Giles]

Removed 1 pixel border now that the Direct3D code is properly setting
texture clamping. This should get rid of the gaps in the Darius
layout, which were caused by bilinear filtering the last pixel on the
screen with the black pixel border. [Aaron Giles]

Fixed -effect none to longer produce an error message. [Aaron Giles]

Removed the VIDEO_PIXEL_ASPECT_RATIO_* flags for drivers. These flags
were used inconsistently, and can be effectively computed if 
necessary from the screen width/height and orientation. [Aaron Giles]

Changed the on screen display so that pressing ENTER resets a value
to its default. [Aaron Giles]

Moved all options to a single central location in windows/config.c.
Cleaned up and reordered the options more logically. [Aaron Giles]

Rewrote windows.txt to reflect all of the new options and to update
the behavior of existing options to match the current implementation.
[Aaron Giles]



0.106u11
--------

MAMETesters bugs fixed (there are probably more)
-----------------------
kikstart0106u7gra [Canim]


Source Changes
--------------

Changed XML output so that BIOS sets, ROM sets, and disks are output
in the defined order. [MadSkunk]

Fixed a couple of bugs in the new screenshot taking code.
[Nathan Woods]

Improved memory map and clock speeds for the MPU4 driver. [El Condor]

Moved clipping into the core, rather than relying on the OSD layer to
do the work. Removed the PUSH_CLIP and POP_CLIP primitives as they
are no longer necessary. Added U/V coordinates to the primitives.
[Aaron Giles]

Fixed the rendering order so that overlays mixed with backdrops work
as expected. Note that over-rendering backdrop pieces (like gollygho
does) may not be supported in the future. [Aaron Giles]

Changed DirectDraw behavior so that it will render to an offscreen
system memory buffer if any blending is required, thus providing
access to all the effects with a bit of slowdown in those cases.
[Aaron Giles]

Added a new command line option: -effect <filename>, which specifies
a PNG file that is loaded and used as an RGB multiply overlay. This
allows for scanline and RGB aperture mask effects. These overlays
rotate with the game screens and only affect the game screens, not
any of the other artwork. They also only run at the raw resolution
of the render_target. This means in Direct3D or GDI modes, they
map 1:1 to the pixels on your screen. In DirectDraw mode, they map
1:1 to the source pixels of the image (for DirectDraw, you can use
-prescale n if you want an n:1 mapping; for example, you would
probably want -prescale 2 if using a 2-pixel-tall scanlines overlay).
[Aaron Giles]

Added brightness, contrast, and gamma controls per-screen in the
on-screen display section of the UI. This requires a change to the
OSD rendering code to use lookup tables when copying RGB data to
textures. Default values can be specified via the -brightness,
-contrast, and -gamma command line/configuration options. Note that
these options only affect screen areas of the final output and have
no effect on artwork or the UI. The values configured in the OSD are
saved in the config file for each game. [Aaron Giles]

Added full screen equivalents of the brightness, contrast, and gamma
controls. Unlike the screens-specific options, these only work in
full screen mode using DirectX, and apply globally, affecting 
artwork and user interface as well. They are controlled via the
-full_screen_brightness, -full_screen_contrast, and 
-full_screen_gamma options. [Aaron Giles]

Added generic pen changing notification callbacks to the palette
system. [Aaron Giles]

Removed vector intensity controls as they are redundant with the new
contrast controls. [Aaron Giles]

Added X and Y offset/scale controls for each screen. This allows you
to control the actual position of the screen within its container. In
order to see beyond the game-configured visible area, the game must
have set up the screen size to be larger than the core visible area.
The Williams drivers have been updated as an example. Eugene Jarvis
mentioned that if you adjust your monitor, you can see the stack in
Robotron off to the right, and now you can in MAME as well. The values 
configured in the OSD are saved in the config file for each game.
[Aaron Giles]

Changed logic so that no rendering apart from the UI happens before
MAME is in a running state. Until that time, a single pixel border
will be displayed around the edges of each screen. [Aaron Giles]

Added option_get_int_range() and option_get_float_range() functions
which do added range checking on parameters, rather than requiring 
the callers to do the work. Also changed the behavior on options
parsing failure to set to the default value rather than defaulting
to 0. [Aaron Giles]

Changed behavior of secondary windows so that they are not created
as children of the primary window. Please re-verify that multiple
screens still work with this change on your setup. [Aaron Giles]

Added new video option to move the user interface to secondary 
screens. The selected screen is saved in the video configuration.
[Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Emeraldia (World) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Magic Fly [Roberto Fresca]
7 e Mezzo [Roberto Fresca]


==========================================================================

0.106u10

MAMETesters bugs fixed (there are probably more)
-----------------------
coininputs0106u6gra [Canim]
champbwl0106u9gre [Pierpaolo Prazzoli]


Source Changes
--------------

Added dual screen support for the Dynax games, TX1, RockMS, some of
the Nichibutsu mahjong games, and Subs. [David Haywood]

Complete DIP switches for Pairs Love. [Roberto Fresca]

Some misc bugfixes to the Taito JC system. [Ville Linde]

Cleaned up screenshot taking code, and re-connected the debugger
command that created them. [Nathan Woods]

Added save state support to the centiped driver. Enabled save 
states in the minivadr, zaxxon drivers. [Buddabing, Aaron Giles]

Fixed PIA addressing regression in the Atari computer driver.
[Nathan Woods]

Added rudimentary progress displays during ROM loading and graphics
decoding so you have something to look at instead of a black screen.
[Aaron Giles]

Added support for remembering the selected view, rotation, and
artwork enabled states in the game's cfg file. [Aaron Giles]

The renderer no longer displays non-UI elements prior to 
initialization. [Aaron Giles]

Fixed keyboard LEDs so they work again. [Aaron Giles]

Added back support for full screen brightness correction. 
[Aaron Giles]

Added support for +/- keys in the palette view. Added "tick marks"
when a large number of palette or gfx entires are displayed to 
indicate which row/column the header refers to. [Aaron Giles]

Made the UI keys for navigating the graphics/palette viewer
configurable. [Aaron Giles]

Fixed inheriting of artwork files from parent. [Aaron Giles]

Updated dotron, skydiver, spacewar, gorf, atarifb, sspeedr, gollygho,
and spyhunt drivers to support the new artwork system. [Aaron Giles]

Made all solid single-color overlays standard pieces that can be
easily reused. [Aaron Giles]

Converted all the internal layouts into .lay files and updated all
remaining drivers to use the new layouts. [Aaron Giles]

Updated -listxml output to display information for multiple screens.
[Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Cruisin' World (version 2.4) [Aaron Giles]


==========================================================================

0.106u9

Source Changes
--------------

Fixed Address Error in Pairs Love (simulated 'buffered ram' 
protection?) [David Haywood]

Fixed Address Error in Grand Cross Pinball (it's caused by the 
sound IRQ..but the music player was ripped out by Aaron ages ago, 
related?)  I've disabled the IRQ rather for now rather than making 
a new sound core. [David Haywood]

Fixed crash in debug builds running the Deco MLC games.
[David Haywood]

Updated the Tecmo Bowl, Gaelco 2, X-Men 6p, and Megatech drivers to 
support dual screens. [David Haywood]

Changed VIDEO_UPDATE to return a set of flags. Only one flag is
currently defined, indicating that video has not changed at all
since the previous update. Most drivers should just return 0.
[Nathan Woods]

Changed the MSM5205 ADPCM decoder to no longer perform bounds 
checking to prevent the signal from overflowing. The MSM5205 data 
sheet clearly states that this isn't the case, and there is no 
overflow protection in the chip. Also, the chip's internal DA 
converter is just 10-bit, even if the processed signal is 12-bit.
[Nicola Salmoria]

Sega Model 2 driver update: [Ville Linde]
 - i960 bugfixes
 - SHARC improvements and bugfixes
 - Added HLE of the geometry DSP for now
 - Moved video hardware emulation to vidhrdw/model2.c and added 
    preliminary 3D graphics emulation

Taito JC driver update: [Ville Linde]
 - Improved M68040 FPU emulation
 - Improved the TMS320C51 core
 - Added 2D graphics emulation
 - Added inputs to all games
 - Properly hooked up sounds in all games

Added "fast forward" function (defaults to the INSERT key). While
holding this key down, the frameskip is temporarily maxed out and
throttling is turned off. This is useful for skipping over parts of
the emulation. [Aaron Giles]

Fixed some glitchiness in font displaying where they would switch in
and out of scaled modes due to rounding errors. [Aaron Giles]

Cleaned up handling of layout dependencies in the makefile.
[Aaron Giles]

Fixed bug when clipping quads in Direct3D mode. [Aaron Giles]

Flipped Punchout and Playchoice drivers so that screen 0 is the 
"main" screen. [Aaron Giles]

Added "left half" and "right half" to the Darius layouts so you can
stretch three screens over two, though you need to explicitly set 
them either in the UI or using the -view0 and -view1 parameters on
the command line. [Aaron Giles]

Changed the initial UI screens to only compute their text a single
time. This reduces the CPU usage greatly when displaying some of the
"game doesn't work" warnings. [Aaron Giles]

Added support for pausing/unpausing while showing graphics and 
tilemaps. [Aaron Giles]

Added get/set calls to control layers on a per-target basis. This
allows for dynamic control of visibility of artwork layers and the
option to crop to the screen. Added menu items to control these
options. [Aaron Giles]

Removed options.use_artwork from the global options. This is now
directly configured by the OSD layer. [Aaron Giles]

Fixed edge case where the extra pixel on non-wrapping textures would
sometimes lead to exceeding the maximum texture size. [Aaron Giles]

Added concept of maximum texture size to the core renderer to prevent
giant textures from being requested if the OSD layer can't handle
them. [Aaron Giles]


==========================================================================

0.106u8

MAMETesters bugs fixed (there are probably more)
-----------------------
listxmlvaridation0106u7ora [Aaron Giles, VGR]
screenshot0106u5ora [Aaron Giles]


Source Changes
--------------

Changed -listxml to accept a wildcard gamename like most other
frontend options to limit which games are output.
[Aaron Giles, Buddabing]

More generic 6840 module improvements. [El Condor]

Moved MESS-specific Atari FDC code into a MESS specific file, in 
addition to fixing bugs. [Nathan Woods]

Updated the Psikyo4 and Backfire drivers to support multiple 
screens. [David Haywood]

Moved some common code into taito_en.c (taito ensoniq sound system).
[David Haywood]

Added 16-bit color support for the DirectDraw renderer (only used if
switchres is off or in a window). Fixed 16-bit line rendering in the
software rasterizer. [Aaron Giles]

Fixed ddraw bug where switching views sometimes didn't clear out the
edges of the screen. [Aaron Giles]

The UI is now limited to a single screen. [Aaron Giles]

Reimplemented the palette/graphics/tilemap viewer. It is still 
connected to F4, but works differently. To switch between modes,
press the ENTER key. Here are the new keys in each mode:

 * Palette/colortable mode:
    [ ] - switch between palette and colortable modes
    up/down - scroll up/down one line at a time
    pgup/pgdn - scroll up/down one page at a time
    home/end - move to top/bottom of list
    enter - switch to graphics viewer

 * Graphics mode:
    [ ] - switch between different graphics sets
    up/down - scroll up/down one line at a time
    pgup/pgdn - scroll up/down one page at a time
    home/end - move to top/bottom of list
    left/right - change color displayed
    r - rotate tiles 90 degrees clockwise
    - + - increase/decrease the number of tiles displayed per row
    enter - switch to tilemap viewer

 * Tilemap mode:
    [ ] - switch between different tilemaps
    up/down/left/right - scroll 8 pixels at a time
    shift+up/down/left/right - scroll 1 pixel at a time
    control+up/down/left/right - scroll 64 pixels at a time
    r - rotate tilemap view 90 degrees clockwise
    - + - increase/decrease the zoom factor
    enter - switch to palette/colortable mode

Note that both graphics and tilemap modes only display data at an
integral scale factor so you are limited based on the resolution of
your render target. For -video ddraw, you can get more pixels by
using -prescale to scale the screen. For -video d3d, the render
target is at your screen's native resolution already. [Aaron Giles]    

Improved scaling calculations when running with -video ddraw and no
hardware stretch to better approximate the real aspect ratio.
[Aaron Giles]

Added more internal texture reference tracking to ensure that stale
data is not being referenced if the OSD layer holds onto a render
list. [Aaron Giles]

Moved cygwin-specific compiler options to windows.mak. [Aaron Giles]

Removed screen aspect ratio specification from the machine driver.
This information is now provided by the render/view system. Games
with odd aspect ratios should include a game-specific layout to
position the screens. [Aaron Giles]

Screenshots are now properly rotated again. Also, MAME now saves one
screenshot per visible screen for multi-screen games (i.e., cyberbal 
will write two PNGs per snapshot taken if both screens are visible).
[Aaron Giles]

Changed the way built-in layouts are handled. There is now a new
layout directory in the source which contains actual .lay files.
These are converted at compile time into .lh files which are 
#included by various drivers and then referenced. The built-in set
of horizontal, vertical, and dual screen layouts are also handled
this way now instead of being dynamically generated. In order to
support things like "native" aspect ratios, a limited form of 
variable substitution is now done on most of the XML attributes when
they are read. [Aaron Giles]

Improved default layout selection. For multiscreen games on a single
monitor, the default layout will show all screens at the same time.
For multiscreen games on multiple monitors, the default layouts will
select one screen per game. [Aaron Giles]

Converted the punchout driver to a proper dual screen game. Rewrote
the video portion to use tilemaps. [Aaron Giles]

Added dual screen support to the PlayChoice 10 and vsnes drivers.
[Aaron Giles]

Added MDRV_DEFAULT_LAYOUT to specify a default layout at the machine
driver level. [Aaron Giles]

Added triple screen support to the Darius and Ninja Warriors drivers,
and dual screen support to the Warrior Blade driver. [Aaron Giles]

Fixed palette for games which were using palette_set_brightness.
[Aaron Giles]

Changed logic so that trying to run more screens than you physically
have in full screen mode will just display as many as will fit rather
than fighting to put multiple full screen displays on a single
monitor. [Aaron Giles]

Added optimizations to figure out the minimal set of screen areas
to clear, even with complicated views and multiple screens. 
[Aaron Giles]


==========================================================================

0.106u7

MAMETesters bugs fixed (there are probably more)
-----------------------
namcond1_0106u3yel [Aaron Giles]


Source Changes
--------------

Improvements to the Sang Ho driver, making them somewhat playable.
[David Haywood, Tomasz Slanina]

Fixed off-by-one drawing error in the Pasha Pasha 2 driver.
[Pierpaolo Prazzoli]

Fixed some instruction forms in the 6309 diassembler to consume
the correct number of bytes. [Nicola Salmoria]

Added back support for DirectDraw. Unlike the old support, this 
requires DirectX 7 or later. There is now a new option to control
what video system is being used for rendering. Use -video d3d to use
Direct3D. Use -video ddraw to use DirectDraw. And use -video gdi to
force the use of GDI for rendering. Also added back the -hwstretch
option to control whether or not DirectDraw does stretching. Added
support for the -prescale option when using DirectDraw as well. It
should also work ok with multiple screens. [Aaron Giles]

Added a compile-time option to rendersw.c to prevent reads from the
destination. This removes the ability to do a number of blends and
effects, but allows you to point the software renderer at a video
memory target and not kill performance. It also improves performance
of software rendering in general by avoiding expensive alpha blending
operations. [Aaron Giles]

Improved font logic so that small fonts are scaled more appropriately
at low resolutions. It's not perfect, but works well for most games
when running with the new DirectDraw option, which always renders
games at minimum resolution. [Aaron Giles]

Fixed bug that messed up partial updating. Hopefully it all should be
back to normal again. [Aaron Giles]


==========================================================================

0.106u6

MAMETesters bugs fixed (there are probably more)
-----------------------
wboysys2_0106u4gra [Canim]


Source Changes
--------------

Minor fix for x64 compilation support with MSVC. [Malice]

Updated astdelux and omegrace built-in overlays for the new render
system.

Fixed inputs in the mcr68 drivers. [Peale]

Fixed new debugger support for custom register lists.
[Tim Schuerewegen]

Added workaround to make the V60 core work properly on GCC 4.x 
(tested on 4.1.1). [R. Belmont]

Fixed the drc blitters better. [Olivier Galibert]

Improvements to Polygonet Commanders: [R. Belmont]
 * Fixed Z80 IRQ/NMIs to go to the right CPU again
 * Modernized memory map
 * Added network status bit, so the initial test passes well enough 
    to make the DSP56k crash on unimplemented opcodes

Miscellaneous cleanups to the Atari/Max-A-Flex driver, attempting to 
modernize it. [Nathan Woods]

Updated Sega multi-32 driver to support multiple screens. 
[Aaron Giles]

Backed off of the multithreading for the moment in order to focus on
getting the rest of the kinks out of the new renderer. All the
infrastructure is still in place and can be re-enabled by flipping
the ENABLE_THREADS flag in window.c. [Aaron Giles]

Added support for "stretch to fit" when configuring a render target.
Added back the "-keepaspect" option as a result. [Aaron Giles]

Added clamping to the prescale effect so that it doesn't try to 
create excessively large textures. Explicitly reset render states so
that the prescale step is not filtered. Fixed StretchRect usage so
that it doesn't filter on some video cards. [Aaron Giles]

Fixed behavior of pixel aspect ratio when configuring render targets
(was correcting in the wrong direction). [Aaron Giles]

Moved thread priority logic out of ticker.c and into winmain.c where
it really belongs. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Pasha Pasha 2 [Pierpaolo Prazzoli]
Rock Tris [Pierpaolo Prazzoli]
Mahjong X-Tal 7 / Mahjong Diamond 7 [Luca Elia]
Janputer '96 (Japan) [Luca Elia]
Watashiha Suzumechan [Luca Elia]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Space Fury (revision B) [Highwayman]
Double Point (Dong Bang Electron) [David Haywood]

New games marked as GAME_NOT_WORKING
------------------------------------
Red Corsair [David Haywood]
Puzzle Star? (Sang Ho) [David Haywood, Tomasz Slanina]
Sexy Boom [David Haywood, Tomasz Slanina]
Super Free Kick [David Haywood]
High Seas Havoc [David Haywood]
Bombs Away [David Haywood, Andrew Gardner]


==========================================================================

0.106u5

WARNING: Starting with this version, the MAME windows run on a
separate thread. There may be issues relating to this, especially
when running unthrottled. If you see any crashes or odd behavior
under normal operation, be sure to report it to 
http://mametesters.org.


MAMETesters bugs fixed (there are probably more)
-----------------------
cheat_menu0106u3ora [Aaron Giles]
cheat_file_option0106u3ora [Aaron Giles]


Source Changes
--------------

Cleaned up decocass driver: [Juergen Buchmueller]
 - All hardcoded tables are gone now
 - cexplore.pro 32 byte PROM reverse engineered

Fixed windows.mak to support 64-bit builds. [Malice]

Fixed bug where the gamename was reallocated out from under us by
the new config system. [Nathan Woods]

Added the ability to specify a callback when a given option is 
parsed.  This is used on the MESS side to add system-specific
command line options. [Nathan Woods]

More generic 6840 improvements. [El Condor]

Some improvements to the Pasha Pasha 2 driver. [Pierpaolo Prazzoli]

Added experimental OSD locks: [Aaron Giles]
 - osd_lock_alloc() allocates a lock
 - osd_lock_acquire() acquires a lock, blocking until success
 - osd_lock_try() tries to acquire a lock and returns whether or
    not it succeeded
 - osd_lock_release() releases a lock
 - osd_lock_free() frees memory used by a lock
If the OSD layer is not using multiple threads, these can just be
stubbed out (return TRUE for osd_lock_acquire and fake the rest).

Fixed ESC key not cancelling out of initial UI screens. [Aaron Giles]

More rendering changes/fixes: [Aaron Giles]
 - Added new render_view_item_get_state() function to return the
    state of a given item
 - Changed render_target_get_primitives to return a new structure
    render_primitive_list, which contains the list of primitives
    along with an osd_lock which must be held while the list is
    being traversed
 - Added "Rotate View" option to the video menu for dynamic in-game
    rotation
 - Moved window creation and management to a separate thread; this
    means all software rendering and all Direct3D calls are done on
    a separate thread from the main game, and will take advantage of
    multiple CPUs/dual cores
 - Changed throttling behavior to skip rendering if we are already
    pending; this makes for a better "fast forward" effect
 - Added -prescale option to pre-scale the game bitmaps before
    rendering to the screen; this helps get rid of the "fuzzy" look
    when running with -filter enabled, at the expense of some speed.
    Note that only integral values are currently supported (no "auto")


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Hard Times [Pierpaolo Prazzoli]


==========================================================================

0.106u4

MAMETesters bugs fixed (there are probably more)
-----------------------
atarigt0106u3red [Aaron Giles]
bestmatch0106u3ora [Aaron Giles]
midyunit0106u3red [Aaron Giles]


Source Changes
--------------

Added new function mame_debug_is_active() which can be used by
core code to identify when we are paused in the debugger.
[Aaron Giles]

Fixed crash when passing an invalid driver name on the command line.
Centralized the approximate matching logic into driver.c so other
ports can use it as well. [Aaron Giles]

Now properly extracting path from driver name and adding it to the
rompath so that drag & drop of ZIP files works once again.
[Aaron Giles]

More renderer updates: [Aaron Giles]
 - Fixed feature detection bug that led to false-positive warnings
    when starting up
 - Removed extra vertex padding since some graphics cards could not
    cope with it
 - Added shims to support both Direct3D 9 and Direct3D 8; D3D9 is
    the default, with an automatic fallback to d3d8 if not available
 - New option -d3dversion can be used to specify preferred version
    for testing
 - Added 1 pixel black border around all textures to ensure filtering
    on some cards doesn't result in garbage at the edge of the screen
 - Enabled "do not wait" feature when unthrottled and using D3D9; this
    greatly speeds up unthrottled games, but seems to only work in 
    full screen mode
 - Switched from triangle fans to triangle strips
 - Ensured that render states are only being set minimally
 - Added code to reset the device if lost, allowing application 
    switching out of full screen mode and fixing multi-monitor mode
    with resolution switching

Added new function verbose_printf() which is used instead of checking
the verbose global to print information to the screen. Changed all
locations that were checking the global to use this new function.
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Card Line [Tomasz Slanina]


==========================================================================

0.106u3

WARNING: As of this build, the new rendering system is enabled by
default. The primary focus at this point is compatibility, not
performance. Compared to the old -ddraw system, it will appear
slower when fully unthrottled because there is not a good mechanism
to skip the render if the graphics hardware is still busy like we
used to do. If you have any trouble getting a correct display or
if you get warning messages printed out when starting MAME, please
post about them on http://mametesters.org.

SECONDARY WARNING: The command line and INI parsing code was
rewritten. If you notice any problems with handling of parameters
in either case, please report the bugs on http://mametesters.org.


MAMETesters bugs fixed (there are probably more)
-----------------------
colmns970105gra [Mariusz Wojcieszek]


Source Changes
--------------

Added a size parameter to osd_free_executable(). [Olivier Galibert]

Fixed flash rom writes in dgpix games. [Pierpaolo Prazzoli]

More fixes/improvements to jalmah.c DIP switches: [Roberto Fresca]
 Kakumei:
  - Added flip screen DIP switch.
 Daireika, urashima & mjzoomin:
  - Added flip screen DIP switch.
  - Fixed test/service DIP switch.
  - Fixed complete coinage.
 
Added save state support to the 1942, 1943 and 1945kiii drivers. 
[Lee Mitchell]

Fixed blitters to work with 15-bit direct RGB modes. [Nathan Woods]

Refactored resource tracking code, auto_malloc(), auto_strdup() 
etc into a separate module, restrack.c. [Nathan Woods]

Moved large stack buffers into heap buffers to work better on systems
with small stacks. [Lawrence Gold]

Fixed a subtle auditing issue when both parents and clones had
NO_DUMP ROMs in their manifests. [Hobbes@Play]

Tweaks to the MSVC compiler support: [AtariAce]
 - Removed _MSC_VER specific #pragmas in nec.c
 - Removed _MSC_VER specific #include <malloc.h> in winprefix.h
 - Changed makefile to bootstrap vconv.exe with cl instead of gcc
 - Changed calls to lib to use link /lib instead
 - Updated vconv to only use /arch:SSE2 for VC71 and later
 - Cleaned up the profiler code in winmain.c
 - Removed the direct dependency of MAME on shell32 has been 
 - Tweaked a couple of preprocessor definitions so we compile as far
    back as MSVC 5.0

Massive DIP switch update to the following drivers: actfancr,
aliens, angelkds, argus, asuka, bwing, compgolf, cop01, dblewing,
dec8, dogfgt, dooyong, fuukifg2, homedata, jcross, kaneko16, m92, 
mainevt, megasys1, metro, ms32, nmk16, paradise, seta, seta2, 
shisen, snk, ssv, system1, taito_b, taito_f2, taito_l, tecmo,
thedeep, thepit, ultraman. [Brian Troha, Guru, Yasuhiro Ogawa]

Added code in the debug build to put random data in allocated memory.
[Aaron Giles]

Removed remaining chunks of x86 assembly code, as well as references
to NASM in the makefiles. [Aaron Giles]

Rewrote the options parsing code to be more flexible and generic.
A new core source file options.c provides the ability to add and
maintain a database of key/value pairs, which can be queried at
runtime. Reconnected all existing frontend options through this code. 
Bounds checking on options for the old renderer is pretty loose, and 
several more complicated options have been disconnected as a result. 
If you are still running with the old renderer, be careful.
[Aaron Giles]

Reorganized fronthlp.c to be one step closer to universal. One more
layer of abstraction and hopefully it will be able to move up into
the core. [Aaron Giles]

New options to control multiple screens in the new renderer:
[Aaron Giles]
 -numscreens specifies how many windows to create
 -screen0/screen1/... specifies the name of the screen for each window
 -resolution0/resolution1/... specifies resolution for each window
 -aspect0/aspect1/... specifies aspect ratio for each screen
 -view0/view1/... specifies starting view for each screen

Deprecated osd_skip_this_frame() with the new renderer. osd_update()
now returns TRUE if it wants to skip the following frame. [Aaron Giles]

Fixes to the new rendering system: [Aaron Giles]
 - Enabled new renderer by default
 - Fixed crash at startup due to uninitialized memory
 - Fixed crash at shutdown due to incorrect shutdown order
 - Fixed rendering of 15-bit direct RGB games
 - Fixed weird frameskipping issues
 - Fixed off-by-one error on visible area
 - Added proper clipping of quad primitives
 - Optimized the clearing step to avoid redundant drawing
 - Brought software-only case up to support all major blending types
 - Added support for -filter option
 - Reconnected snapshots, though they are unrotated and screen 0 only
 - Fixed several UI problems with new video options menu
 - More strongly defined the blending modes to produce correct effects
 - Added a flag to indicate textures that are of screen bitmaps


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Mario Lemieux Hockey (Mega-Tech) [David Haywood, Guru]
Highway Chase (Cassette) [David Widel, Juergen Buchmueller]
Critter Crusher [Mariusz Wojcieszek, gbluma]
Daikaiju no Gyakushu [Tomasz Slanina, Guru]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Turtle Ship (North America) [Brian Troha]


==========================================================================

0.106u2

IMPORTANT NOTE: The video system in this version has been completely
upended and redesigned. The old video system is still the default;
however, some features may be broken. These are not bug-worthy
reports, as the old system will soon be deprecated. The new system
can be compiled by setting the NEW_RENDER flag on in the makefile.

THE NEW SYSTEM IS STILL WORK-IN-PROGRESS! Apart from video card-
related issues (like it doesn't work on particular hardware or has
an incorrect display), bugs are not being tracked at this time.
There is already a laundry list of things that are broken at the
top of render.c, and there are many other things that still need
to be looked at.

In order to run the new video system with hardware acceleration, 
your machine will require DirectX 8 or later.


MAMETesters bugs fixed (there are probably more)
-----------------------
suchipi0106u1gra [Roberto Fresca]


Source Changes
--------------

Added support for circular buffering in the SHARC core, and fixed
several minor bugs. [Ville Linde]

Added color PROM support for Nintendo's Sheriff driver. 
[Stefan Jokisch]

Discrete sound updates: [Derrick Renaud]
 - Typedef'ed external discrete sound structures to follow current 
     structure use. Statically defined their use in most drivers to 
     stop name pollution.
 - Created new DISCRETE_555_VCO1 module.  This is the 555&Op-amp 
    oscillator circuit used by Borderline.

Added the new video rendering system. A new file render.c contains
the bulk of the logic. Major changes include: [Aaron Giles]
 - The OSD layer is now responsible for allocating one or more 
    render_targets at osd_init time. The old osd_create_display 
    and osd_close_display calls are not used with the new system, 
    so initialization must take place at osd_init time.
 - The old osd_update_video_and_audio call has now been replaced 
    with a simple osd_update call. This update call passes a 
    mame_time to the OSD layer, which is the current emulated time. 
    Throttling and speed calculations should use this time instead
    of the framerate.
 - osd_update is responsible for calling the render system to 
    request a list of primitives to be drawn on each render_target
    for the current frame. The primitives are simple and include
    clipping rectangles, lines, and rectilinear quads only.
 - If it wishes, the OSD layer can call back to a software
    rasterizer in MAME. The rasterizer code is provided as an
    include module so it can be tuned and optimized for platform-
    specific video modes. See windows/rendsoft.c for a usage
    example.
 - There is a new layout file format .lay, which is XML-based and
    which replaces the old .art files. The .lay files describe how
    to render to a render_target. Each layout file can contain
    multiple "views", which describe one of many ways the various
    elements can be drawn. These views can be selected at runtime
    via the new "Video Options" menu.
 - The built-in UI font can be overridden with any .BDF font. Simply
    name the .BDF file "ui.bdf" and place it in the MAME directory.
    If you run at decent resolutions, you should choose a large 
    point size for this font so that the scaled results look nice.
 - The windows implementation uses Direct3D 8 as the preferred
    mechanism for rendering. By default, it will render at the
    current resolution, rather than switching resolutions as before.
    This can be changed by adding -switchres to the command line.
 - There are still a number of imperfect/incomplete features with
    the new renderer, which is why it is not on by default. An
    incomplete list is given in render.c.


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
WWF: Wrestlemania (rev 1.20 08/02/95) [Corrado Tomaselli]
Heavy Smash (Asia version -4) [Corrado Tomaselli]
Mad Alien (Highway Chase) [Stefan Jokisch]

New games marked as GAME_NOT_WORKING
------------------------------------
Pasha Pasha 2 [Pierpaolo Prazzoli]
Trivia Madness [Pierpaolo Prazzoli]


==========================================================================

0.106u1

IMPORTANT NOTE: Major video-related changes are beginning in the
system. Attempts will be made to keep the existing video code
working to a large degree, but some features may be broken or
working improperly until the video changes are complete. Most
notably, in this release, RGB effects are broken for non-Direct3D
blitting. For the moment, do not report anomalies or problems in 
the video system. If you like a nice, stable MAME, please stick 
with the 0.106 release. You have been warned.


MAMETesters bugs fixed (there are probably more)
-----------------------
gladiatr0105u4gra [Don Maeby]


Source Changes
--------------

Updates to the taito_x driver: [AWJ]
 - fixed sound problems in twinhawk
 - fixed a couple of dipswitch mistakes introduced recently
 - added PORT_DIPLOCATIONs for superman and twinhawk

Improved MSVC compiler support: [Nathan Woods]
 - modified vconv to support multiple versions of MSVC based on 
    version info
 - added support for more parameter translations
 - makefile now displays compiling and linking messages when
    building vconv

Converted the Windows blitters to use the DRC engine for 
generation. RGB effects are officially broken with this change.
[Nathan Woods]

Fixed a bug that caused a crash when the -debugscript command line 
option was used with an invalid filename. [Nathan Woods]

Corrected the ordering of the DIP_PORTLOCATION() macros to be
consistent. Multi-bit DIP switches should be specified in LSB-
first order. Added a comment to this effect in inptport.h.
[AWJ, Aaron Giles]

Fixed background color in the Deco cassette games.
[Nicola Salmoria]

Fixed potential crash in the micro3d driver. [MamePlus!]

Improvements to CHD-CD support: [R. Belmont]
 - additional RAW CD sector conversion support, so a game can request 
    e.g. 2048-byte data sectors from a RAW CHD-CD and still get the 
    right data
- reversed CHDMAN error message - now non-RAW CHD-CDs are deprecated
- susume now uses a RAW CHD-CD read directly from an original pressed 
   Konami disc

Some improvements to the Polygonet Commanders driver: [Andrew Gardner]
 - adds change_PC() calls to the dsp56k core
 - removed hacky dsp56k initialization, enabling, and disabling
 - added preliminary implementation of banking hardware tied to the 
    dsp56k in Polygonet Commanders

Fixed MSB accesses and latch reading in the 6840 emulator. [El Condor]

Improved N64 audio output: [R. Belmont]
 - rewrote Audio Interface as a stereo DMADAC (which it actually is), 
    greatly simplifying the code along the way
 - fixed AI interrupt semantics

Changed a number of games that were incorrectly using IPT_LIGHTGUN
to use IPT_AD_STICK instead. [Aaron Giles]

Some preparations for proper multiple screen support. The 
visible_area and refresh_rate values in the Machine structure are
now defined as arrays (1 per screen). The machine_config structure
has been altered as well, removing the following fields:

   frames_per_second
   aspect_x, aspect_y
   screen_width, screen_height
   default_visible_area
   vblank_duration

These are all stored per-screen in a new screen_config structure. 
[Aaron Giles]

Reorganized the user interface code to better support the new render
system. [Aaron Giles]


==========================================================================

0.106

Source Changes
--------------

Fixed vconv.exe so it doesn't use options that have been deprecated
in MSVC 2005. [Aaron Giles]

Fixed crash in the model3 games introduced by cleaning up empty ROM
regions. [Ville Linde]


==========================================================================

0.105u5

MAMETesters bugs fixed (there are probably more)
-----------------------
memory0105u4red [Aaron Giles]


Source Changes
--------------

Cleaned up the freekick.c driver [Sonikos]:
 - added 2nd button in gigas/gias2m/oigas
 - matched the Z80 chip mhz to the "confirmed" mhz of gigas

Extended the gfxlayout structure to support "extended" arrays of
x and y offsets. These are used for layouts that are larger than
32x32. This enables the standard structure to be smaller for the
vast majority of games that don't require huge graphics decodes.
The end result is that the MAME .exe is ~3MB smaller.
[Atari Ace, Aaron Giles]

Added some Amiga enhancements needed for MESS Amiga and CDTV 
drivers. [Dirk Best]

Removed non-existant 3rd & 4th player controls from deadconx.
[Don Maeby]

Improvements to the MACS driver: [Tomasz Slanina]
 - fixed a couple of gfx bugs in st0016 video emulation
 - added hacks to allow MACS games to boot
 - removed REGION_DISPOSE flag from srmp5 and speaglsht (no more 
    crashes)

Fixed/improved DIP switches in the powerbal.c, konamigx.c, and 
gsword.c drivers. [Twisty]

More improvements to the BFM driver and the 6840 timer emulation.
[El Condor]

Improvements to the x86 drc engine and the Windows blitters:
 - Blitter CPUID features now accessed by drc_x86_get_features() call
 - Added win_blit_init(), to initialize the blitter
 - Changes to DRC to support usage for things other than CPU cores
 - Fixed drc_dasm() so it works once again
 - Added macros for a number of MMX/SSE instructions
 - Added a number of MMX/SSE instructions to the i386 disassembler

Actually applied the Marine Date fixes which were mentioned in a
previous u release. [Aaron Giles]

Added experimental support for building using Visual C++ 2003/2005.
To do this, you still need the mingw environment (ironically) because
we rely on the mingw make system to call out to the MSVC compilers.
Set the variable MSVC_BUILD=1 on the command line or by modifying
windows.mak, and it will build using the Microsoft compilers. This
works through the use of a stub program vconv.exe which translates
gcc options into MSVC options. As a bootstrapping measure, vconv.exe
is compiled at the start of a clean build by mingw. Most of the
standard build options just work (SYMBOLS, MAP, DEBUG, etc). If you
have a beefy computer, you can also set MAXOPT=1 and use link-time
code generation for maximum optimization effect. :) [Aaron Giles]

Added preliminary support for 64-bit targets. A new makefile define
PTR64 should be set if you are compiling for a 64-bit target. This
propogates a PTR64 define into the C files as well. Made the makefile
smart enough to auto-disable the drc cores for 64-bit, and removed
most of the roadblocks to a 64-bit build, apart from the assembly
blitters, which are currently undergoing a rewrite. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Hidden Catch 2 [Pierpaolo Prazzoli, Guru]
Fishing Maniac 3 [Pierpaolo Prazzoli, Guru]
Yu-Ka [Tomasz Slanina]
Yu-Jan [Tomasz Slanina]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Greyhound Selection (Version 40.02TMB) set 2 [Brian Troha]
Greyhound Poker (3 new sets) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Master Boy [David Haywood]
Intersecti [David Haywood]


==========================================================================

0.105u4

MAMETesters bugs fixed (there are probably more)
-----------------------
invaders0105u2gre [Giuseppe Gorgoglione]
taitosj0105u3yel [Aaron Giles]
wardner0105u3red [Aaron Giles]


Source Changes
--------------

Nintendo 64 system improvements: [Ville Linde, Ryan Holtz]
 - Fixed a major bug in the RSP core
 - Rewrote the PIF handling
 - Slightly improved triangle rendering

Added a NULL check on memory_set_bankptr(), memory_configure_bank() 
and memory_configure_bank_decrypted(). [Nathan Woods]

Added support in the debugger memory window to change the number
of bytes displayed per row. [Andrew Gardner]

Started simulation of orlegend super / special protection.
[XingXing, ElSemi]

Fixed colors and music tempo in Perfect Billiard. [Sonikos]

Cleaned up 6840 implementation and revised scorpion2 driver's 
handling of unmapped regions. Also updated the MPU4 memory
map. [El Condor]

Major Toaplan 2 driver cleanup: [Quench]
 - Added Knuckle Bash 2 (kbash2)
 - Consolidated the Read/Write memory maps
 - Fixed coin counters on a few games
 - Raised the volumes on a few games
 - Cleaned the inputs by:
    Adding input inheritance and DIPSW locations
    Added conditional dependance to DIPSWs where required
    Fixing a few incorrect inputs here and there

Fixed/improved DIP switches in the m92, afega, tumbleb, and yunsun16 
drivers. [Twisty]

Cleaned up the liberate.c driver. [Sonikos]

Improved ARM7 thumb mode disassembler. [MooglyGuy]

Some improvements to Air Raid/Cross Shooter, but not playable 
due to missing gfx roms. [Tomasz Slanina]

Fixed UI positioning when artwork is enabled. [Giuseppe Gorgoglione]

Big pile of updates/improvements to the ARM7 core thumb mode and
the PGM drivers. [David Haywood, ElSemi]

Improved OKI frequency in sslam and powerbls. [f205v]

More DIP switch improvements to m62.c, m72.c, ddragon.c. [Twisty]

Fixed bug in the debugger that would prevent you from typing a
command line longer than what was visible. [Aaron Giles]

Added a new tool jedutil, which will convert .JED files to binary
form and back again. [Aaron Giles]

Added new ROM region REGION_PLDS, which is designed to hold binary
dumps of PLD fusemaps (produced from .JED files by jedutil). Added
logic to -romident to automatically parse .JED files to identify them
against these binary dumps. Added PLD dumps to the Vindicators,
Batman, Pit Fighter, ThunderJaws, and Relief Pitcher drivers. More to
come shortly. [Aaron Giles]

Converted PLDs for catnmous and lazarian to the new binary format.
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Tetris (D.R. Korea) [David Haywood]
Knuckle Bash 2 (bootleg) [Quench]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Metal Slug 6 (Metal Slug 3 bootleg) [Mame32Plus]
Metal Slug 5 (JAMMA PCB) [Mame32Plus]
SVC Chaos - SNK vs CAPCOM (JAMMA PCB, set 2) [Mame32Plus]
Night Slashers (Over Sea Rev 1.2) [Stefan Lindberg]
Double Dragon (World Set 2) [Stefan Lindberg]


==========================================================================

0.105u3

MAMETesters bugs fixed (there are probably more)
-----------------------
mystston097u3yel [David Haywood]
decocass0105u2yel [Aaron Giles]
taitosj0105u2yel [Aaron Giles]
vicdual0105u2gre [Aaron Giles]
chqflag0105u2red [Aaron Giles]


Source Changes
--------------

Fixed and cleaned up the DIP switches in the dec0 driver.
[Roberto Fresca]

More improvements to the PGM video code. Also added hooks for halting
the sound CPU which allows ddp2 to boot. [David Haywood] 

Fixed incorrect lightgun names. [Derrick Renaud]

Fixed Bonze Adventure levels 2 & 9. [Bryan McPhail]

Refactored the 8530 CIA code from the Amiga into a separate module
and made it support both the 6526 and 8530 variants. [Nathan Woods]

Fixed/improved DIP switches in the megasys1, dietgo, and yunsun16
drivers. [Twisty]

Fixed some DIP switches and added controls for 2nd player in cocktail 
mode in Lost Castle in Darkmist. [Sonikos]

Fixed a number of issues in the Windows rendering code:
[Giuseppe Gorgoglione]
 * fixed blit_vectors so it used the dirty pixel array in D3D mode
 * fixed blit_vectors rotation issue for dirty pixels as well
 * changed -full_screen_brightness to -full_screen_gamma
    (which is a more correct description)
 * changed -d3dfilter to be a boolean, since the other filtering modes
    are either obsolete or not applicable to MAME
 * removed limitations on windowing position so you no longer need to
    be aligned on an 8-pixel boundary
 * cleaned up a number of unused global variables
 * improved multi-monitor support to work in GDI mode as well as in
    non-full-screen modes
 * added missing documentation for the -screen parameter

Fixed some remaining errors and inconsistencies in the content and 
usage of MAME header files by comparing declarations against actual
definitions. Removed many orphaned/duplicate declarations. Added
#includes where appropriate, and moved a few declarations to another
file when they were in the wrong location. [Atari Ace]

Removed a number of unused ROM regions. Most (but not all) of the
empty ROM region warnings are now taken care of. Also uncommented/
added missing undumped ROMs/XORs in the Namco and CPS2 games.
[Aaron Giles]
 
More Amiga cleanups: [Aaron Giles]
 * fixed dual playfield mode
 * rewrote blitter code (fixes glitches in ar_bowl and others)
 * changed Arcadia boot loading to use ROMtags instead of autoconfig
 * swapped Kickstart 1.2 in for Arcadia BIOS (fixes ar_sdwr)


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Puzzle Star [XingXing]
Marine Date [MAME32Plus]
Speed Up [Aaron Giles]
Up Scope [Mariusz Wojcieszek, Tomasz Slanina, Aaron Giles]
Greyhound Poker (Version 50.02) [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
The Pit (Bootleg) [Brian Troha]
Amidar (Bootleg) [Brian Troha]
Moon Cresta (bootleg set 3) [Brian Troha]
Xexex (ver AAA) [Corrado Tomaselli]

New games marked as GAME_NOT_WORKING
------------------------------------
The Gladiator [David Haywood]


==========================================================================

0.105u2

MAMETesters bugs fixed (there are probably more)
-----------------------
raizing0105u1red [Ville Linde]
psbasedgames0105u1red [Nathan Woods]


Source Changes
--------------

Fixed Monster World DIP switches. [Sonikos]

Fixed floating point rounding error in the PowerPC FPU. [Ville Linde]

Some more work on the Killing Blade protection. [El Semi]

Reorganized and cleaned up the PGM sprite drawing code a bit. Added
zooming support. [David Haywood]

Did some cleanup on the 6821 PIA functions, converting to new MAME
struct conventions and enforcing that configuration/initialization
happens only at init time. [Nathan Woods]

Fixed some unknown DIP switches in Galivan and Dangar Ufo Robo.
[Twisty]

Some improvements to Playmark's Roulette, though it still doesn't
quite work properly. [David Haywood]

Fixed Showdown start button. [Don Maeby]

Fixed sound frequency in Shocking. [Brian Troha, Guru]

Fixes to Top Roller: [Tomasz Slanina]
 - correct colors
 - fixed gfx bugs
 - better audio (added rom with samples)
There's still minor problem with fg text layer colors.

Made "This game doesn't work" text more explicit. [Olivier Galibert]

Added PAIR and PAIR64 as valid save state types. [Nathan Woods]

More Amiga/Arcadia system updates: [Aaron Giles]
 - Rewrote autoconfig system to be more generically useful
 - Cleaned up/rewrote the CIA emulation to be more complete
 - Added dual playfield and sprite priority support
 - Added collision detection support
 - Tweaked COPPER timing to fix scores on Fast Break
 - Shuffled the BIOSes so that the newer version is the default


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Mang-Chi [David Haywood, Brian Troha]
New Hidden Catch [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Abscam [David Widel]
Ms. Pac-Man (bootleg, encrypted) [David Widel]
Billiard Academy Real Break (Korea) [Corrado Tomaselli]
Carrier Air Wing (World 901009) [Stefan Lindberg]
Plasma Sword (ASIA 980316) [Chris Hardy]

New games marked as GAME_NOT_WORKING
------------------------------------
Total Vice [Curt Coder]
Sega Ski Super G [R. Belmont]
Over Rev [R. Belmont]
Sliver [David Haywood]
Puck People [David Haywood]


==========================================================================

0.105u1

MAMETesters bugs fixed (there are probably more)
-----------------------
metmqstr0105yel [Aaron Giles]


Source Changes
--------------

Cleaned up the usage of includes/*.h files across the project, by
ensuring that:
 1. All includes/foo.h files are annotated with comments describing 
     the source of the declarations.
 2. Each source file so annotated also explicitly does an
     #include "includes/foo.h" to ensure consistent definitions.
Along the way a number of inconsistent, irrelevant, and incomplete
declarations were removed/cleaned up. [Atari Ace]

Moved calls to ui_set_visible_area() into set_visible_area() to work
around timing problems when they are called at separate times during
a single frame. [Nathan Woods]

Updated CPS driver to more accurately draw tilemaps, based on
evidence from a board with mixed ROMs. [David Haywood]

Fixed crash bug in old debugger introduced in the last release.
[Olivier Galibert]

Added demo sounds DIP switch to Pig Newton. [Derrick Renaud]

Fixed DIP switches in gunmast, batlbubl. [Brian Troha]

Added simulated sound for tumbleb2 and pangpang. [David Haywood]

Added accessors for the CA2, CB2 and IRQ signals on the 6821 PIA.
[Nathan Woods]

Accurate C-Chip emulation in Bonze Adventure to fix protection 
problems (no more missing or made up data, all data extracted from 
working pcb). [Bryan McPhail]

Some cleanups to the Taito F3 naming. [Marco, Bryan McPhail]

Fixed the Z80 PIO code to prevent an interrupt to occur between the 
PIO_OP_MODE byte and mask which follows. According to the datasheet, 
this is not permitted in hardware. [Robert]

Added many FPU opcodes to the M68040 core. [Ville Linde]

Fixed rom loading in all Taito JC games. [Ville Linde]

Added TMS320C51 cpu core. [Ville Linde]

Split out some of the Nintendo 64 core pieces into MESS-shareable
modules. [R. Belmont]

Removed hard linkage of game driver clones. This reduces hard 
inter-driver dependencies and allows for easier usage of tiny.mak.
[Atari Ace, Aaron Giles]

Updates to the PGM driver: [El Semi]
 - Corrected mask on sprite width parameter in sprite list
 - Corrected decryption function for The Killing Blade
 - Fixed GFX Rom loading in The Killing Blade
 - Added set The Killing Blade (Taiwan?)
 - Added some WIP protection simulation for The Killing Blade
    (Taiwan?), game boots but at least one stage is broken

Added $(OBJ)/%.s target to the makefile for easy disassembly
analysis of generated code (you can also use the $(OBJ)/%.pp to
examine preprocessor output). [Nathan Woods]

Moved region and address space names out of the Windows-specific
code and into more common locations. [Olivier Galibert]

Fixed a bug with code comments that led to incorrect display for
long comments. [Andrew Gardner]

Added several missing H8 opcodes to the core and color DAC to 
lastfght.c. [Tomasz Slanina]

Changed -romident option so that it returns errorlevels based on how
many ROMs were identified (0=all files identified, 1=all files except
some non-ROM files identified, 2=some files identified, 3=no files
identified). [Aaron Giles]

Added stricter type checking for save state registrations (only works 
in gcc). [Aaron Giles]

Changed automatic ROM assignment logic in the memory system so that
it doesn't auto-assign out-of-bounds ROM regions. [Aaron Giles]

Changed memory save state registration so it doesn't register for
saving memory areas that overlap memory regions. This means that 
drivers which rely on extra memory regions for RAM will need to fix
that before supporting save. [Aaron Giles]

Modified a number of drivers that were using empty RAM regions for
RAM or which had extraneous memory regions. Most significant changes
were to the arcadia, nss, and stv drivers. [Aaron Giles]

Added a warning during validity checks to point out empty memory
regions. These should either be eliminated, or marked with an 
explicit fill value (ROMREGION_ERASE00 or ROMREGION_ERASEFF) to clear
the warnings. [Aaron Giles]

Rewrote a large chunk of the Amiga emulation to support sound and
additional video modes/effects including extra half-bright mode, 
manual sprites, and mid-scanline changes. This is still a work
in progress. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Pang Pang [David Haywood]
Crazy Fight [Luca Elia]
Puzzle King (Dance & Puzzle) [Pierpaolo Prazzoli]
Fighter's History [Bryan McPhail]
Sex Triv [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Battle Bubble [f205v, Corrado Tomaselli]
Bonze Adventure (World, Older) [Bryan McPhail]
Fantasia II (set 2, less explicit) [HIGHWAYMAN]
The Killing Blade (Taiwan?) [El Semi]


==========================================================================

0.105

NOTICE: The official Windows binaries are no longer compressed with
UPX. This means that when you extract the files, the main MAME .EXE
file will be much larger than you are used to. This is normal. The
code has always been that big. Leaving it uncompressed will allow MAME
to use less memory when run (ironically).

IMPORTANT CHANGES FOR OSD DEVELOPERS: There have been several changes
this cycle that impact you. Please scan this file in detail for the
details.


MAMETesters bugs fixed (there are probably more)
-----------------------
sys24savestate0104u4red [Aaron Giles]


Source Changes
--------------

Added the Dev 1.061 and early Japan bioses for ST-V. [zozo]

Added sound to Jump Kids. [f205v]

Corrected DIP switches for Honey Doll and Cookie & Bipi 3. 
[Brian Troha]

Some progress on Little Robin. [David Haywood]

Fixed crash in System 16 games introduced by last update.
[Aaron Giles]


==========================================================================

0.104u9

MAMETesters Bugs Fixed
----------------------
cerberus0104u7yel [Aaron Giles]
carnevil0104u7gre [Aaron Giles]
raveracw0104u7red [Aaron Giles]
f1en097u1gre1 [Anonymous]


Source Changes
--------------

Added decryption of kof2003 p3 ROM. [iq_132]

Changed comment prefix in debugger command scripts from '#' to '//'.
[Nathan Woods]

Fixed makefile to allow command-line override of MAMEOS and TARGET
variables. [smf, Aaron Giles]

Fixed gsword, which was broken in an earlier update. [Tatsuyuki Satoh]

Cleaned up error logging so that it is callback driven, allowing more
than one potential output source. Fixed the -oslog option in the
Windows build. [Nathan Woods]

Fixed "do" command in the debugger. [Aaron Giles]

Had to undo the use of timers to trigger save/restore of states. This
leads to one less timer in the system, and hence will break the save
states from previous versions. The current save state system is
extremely sensitive to such changes, unfortunately. This will be
addressed in a future version. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Joshi Volleyball [Tatsuyuki Satoh]
Toppy & Rappy [David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Toride II Adauchi Gaiden (German) [Corrado Tomaselli]
River Patrol (Orca) [David Haywood]
Get Star (bootleg, set 2) [David Haywood]
Slap Fight (set 2) [David Haywood]
Puzzle Uo Poko (International) [Corrado Tomaseli]
Final Fight (US 900613) [Murray Melvin]
Ninja Kazan (World) [Stefan Lindberg]
Eyes (Zaccaria) [David Haywood]
Power Drift (World Set 2) [Uncle Tom]

New games marked as GAME_NOT_WORKING
------------------------------------
Stepping Stage [David Haywood]
Tobe! Polystars [Ville Linde]
Battle Tryst [Ville Linde]
Heat of Eleven '98 [Ville Linde]
Evil Night [Ville Linde]
Sega Rally 2 DX [Uncle Tom]


==========================================================================

0.104u8

IMPORTANT CHANGE FOR OSD DEVELOPERS: osd_logerror is no longer
used. Rather, for error logging you provide a handle to a mame_file
in the options.logfile field. If you leave this set to NULL, no
logging will be done.


MAMETesters bugs fixed (there are probably more)
-----------------------
tmnt099u1gre1 [Pierpaolo Prazzoli]
block056yel [David Haywood, Corrado Tomaselli]
block085u2gre [David Haywood]
ddenlovr0104u7ora [Aaron Giles]
toutrun0104u7red [Aaron Giles]
bounty0104u7red [Aaron Giles]
maxaflex0104u7red [Aaron Giles]
cclimber.c0104u7red [Aaron Giles]


Source Changes
--------------

Fixed hyhoo which was broken in the last round of changes.
[Takahiro Nogi]

Added emulation of the Alpha 8201/8301 MCU, and connected it to
champbbj, champbb2, talbot, shougi, shougi2, and exctsccr.
[Tatsuyuki Satoh]

Added cpunum_set_clock_period(), a variation of cpunum_set_clock() 
that takes subseconds_t, providing better granularity. [Nathan Woods]

Fixed most of the remaining issues in Wink, though there is still
some unemulated protection.
[HIGHWAYMAN, Nicola Salmoria, Pierpaolo Prazzoli]

Added save state support to the galaga.c and segaybd.c based games.
Improved the "out of context" error message to indicate the source 
of the problem. [Andre Hufschmidt]

Moved logerror handling into the core. OSD ports should set 
options.logfile to a mame_file handle for the output file. 
[Aaron Giles]

Fixed second SN76496 on Congo Bongo to have the correct frequency.
[Aaron Giles, Chris Law]

Hooked up Sega Universal Sound Board to Pig Newton. [Aaron Giles]

Added -validate command to perform system-wide validation and exit
with a proper errorcode. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Champion Baseball (Japan set 1/2) [Tatsuyuki Satoh]
Champion Baseball II [Tatsuyuki Satoh]
Exciting Soccer II [Tatsuyuki Satoh]
Shougi [Tatsuyuki Satoh]
Shougi 2 [Tatsuyuki Satoh]
Talbot [Tatsuyuki Satoh]
Paradise Deluxe [David Haywood]
Sea Hunter Pengiun [David Haywood]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Star Fighter [Pierpaolo Prazzoli]
News (set 2) [Ryan Ahn]
Rave Racer (Rev. RV1, Japan) [Arzeno Fabrice]
Final Lap R (Rev B) [Arzeno Fabrice]
OutRunners (World) [Arzeno Fabrice]
Wild West C.O.W.-Boys of Moo Mesa (ver AA) [Arzeno Fabrice]
Slap Fight (bootleg) [David Haywood]
Do! Run Run (Do's Castle hardware, set 2) [David Haywood]


New games marked as GAME_NOT_WORKING
------------------------------------
Tappy & Rappy [David Haywood]


==========================================================================

0.104u7

MAMETesters bugs fixed (there are probably more)
-----------------------
upsidedown0103yel [Takahiro Nogi]
mgion0104u6yel [Takahiro Nogi]
hyouban095u2red [Takahiro Nogi]
model1.c_0104u5yel [Aaron Giles]
ohmygod0104u6red [Aaron Giles]
stv.c_0104u5red [Aaron Giles]
ad2083_0104u5red [Aaron Giles]
gauntdl0104u6red [Aaron Giles]
zwackery0104u3red [Aaron Giles]
triviaes0104u6ora [Aaron Giles]


Source Changes
--------------

Added simulation of protection to the Parallel Turn driver.
[Tatsuyuki Satoh]

Added missing demo sounds DIP switch to spelunk2. [Roberto Fresca]

Fixed key input problems in many of the Nichibutsu mahjong drivers.
[Tatsuyuki Satoh]

Updated the Dragonball Z games to use the K056832 chip emulation,
fixing color offsets and priorities. [Pierpaolo Prazzoli]

Updated raw mouse support for Windows XP: [Derrick Renaud]
 * Reversed the RAWMOUSE device list. RAWMOUSE reports the last 
    installed mouse as the first device. I now place new mice at the 
    end.
 * Added clipping to RAWMOUSE support so the cursor does not leave 
    the game area in Windowed mode. Also fixed the non-RAWMOUSE 
    Windowed mode clipping I broke by my last changes.
 * You can now see the names of the mice attached by using -verbose.
 * Changed Lightgun functionality if using XP.  You no longer need 
    to use -lightgun or -dual_lightgun. Use -mouse and multiple (2+) 
    "HID-compliant mouse" lightguns will be detected. Lightgun 
    support in Win98/Me remains unchanged. -offscreen_reload can 
    still be used on Win98/Me/XP. See windows.txt for further info.

Fixed indirect palettes in the System 32 driver. This fixes Sonic
graphics finally. [Anonymous]

Fixed window resizing bug when running in a window. [Wilbert Pol]

Switched MDEC decoding input from CbCrY to CrCbY, and switched MDEC 
15bit output from rgb to bgr. [smf]

Removed unnecessary #includes from a number of files. Added #includes
to files that were defining items that were declared in the header. 
Better documented where items are defined in the header files from 
the includes directory. [Atari Ace]

Fixed some crashes in the debugger if you tried to set breakpoints
while the game was running and there was no active CPU. 
[Nathan Woods]

Fixed crash when calling fatalerror before the system was ready for
it. [Nathan Woods]

More improvements to the Sega universal sound board. Star Trek is
almost identical to the samples. Tac/Scan is not that far off, 
surprisingly. [Aaron Giles]

Added new function input_port_set_changed_callback() which lets you
receive a change notification when certain bits in an input port
have changed. See sega.c for an example. [Nathan Woods, Aaron Giles]

Added new PORT_CUSTOM() macro which allows you to specify a callback
to return the value of bits in an input port. This saves you from
needing to intercept the port read and modify the bits there. See
sega.c for an example. [Aaron Giles]

Added new PORT_DIPLOCATION() macro which allows you to specify the
physical PCB location of a DIP switch and the switches that correspond
to the bits in the DIPSETTING. See sega.c for an example.
[Aaron Giles]

Updated the i8039 disassembler to the new interface. [Aaron Giles]

Moved read/write handlers for input ports, watchdog, and interrupt
enable out of the core and into machine/generic.c. Moved generic
palette hanlders out of the core and into vidhrdw/generic.c. Clarified
the names of many of the palette handlers and simplified the code.
[Aaron Giles]

Added code to the UI to sort the per-game inputs in a standard order.
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Crystal Gal (Japan 860512) [Takahiro Nogi]
Crystal Gal 2 (Japan 860620) [Takahiro Nogi]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Circus Charlie (Selectable level set 2) [Brian Troha]
Mahjong Hana no Momoko gumi (Japan 881125) [Takahiro Nogi]


==========================================================================

0.104u6

MAMETesters bugs fixed (there are probably more)
-----------------------
thunderx0104u1yel [Pierpaolo Prazzoli]
baraduke.c_0104u5red [Aaron Giles]
m62.c_0104u5yel [Aaron Giles]
model1.c_0104u5yel [Aaron Giles]
rthunder0104u5red [Aaron Giles]


Source Changes
--------------

Fixed various problems introduced in the last set of changes.
[Aaron Giles, Nathan Woods, Ville Linde]

Fixed dip-switches in Action Fighter. [Chaneman]

Improved samples support for Congo Bongo. [Chris Law]

Some improvements imported from MAME Plus!
 * added save state support to pd4990a device for neogeo
 * fixed crash in nitrobal/gunball (stage 4, right route) [xvi]

Got Polygonet Warriors back to the POST screen. [Andrew Gardner]

Reduced global namespace pollution by marking many global functions
explicitly static, especially in the CPU cores.
[Atari Ace, Aaron Giles]

Some improvements to Magical Error. Title and attract works. No 
sound. Hangs in game. Problems with shared mem and main-sub cpu 
communciation. [Tomasz Slanina]

Added validity checks to ensure CPU core completeness. [Nathan Woods]

Added DIP switches for Agress. [Roberto Fresca]

Added the missing commands and proper maker/device ids to the flash
memory handlers for Fujitsu MBM29F016A, used by Konami FireBeat.
[Ville Linde]

Added preliminary support for the Jaleco color blending hardware 
found in Psychic 5, Argus, and Valtric. (Some functionality is still 
unknown). [Andrew Gardner]

Major update to the Aleck64 driver. Still not fully working yet.
[Ville Linde]

Fixed comment display for processors which use an ADDRBUS_SHIFT.
[Andrew Gardner]

Added accessors to return output values for the 6821 PIA.
[Nathan Woods]

Added movie recording time to the internal profiler. [Nathan Woods]

Added oversampling support to the Exidy custom sound and to the DAC
sound system. [Aaron Giles]

Sega vector game updates: [Aaron Giles]
 - Rewrote vector generator from schematics. Yes, it is supposed to
    be that jumpy on zooms!
 - Corrected CPU speeds and cleaned up memory maps.
 - Connected AY-8912 to Zektor for missing sound effects.
 - Added emulation of the Universal Sound Board -- not yet perfected,
    but gets rid of the need for samples in Star Trek and Tac/Scan.
    Tac/Scan sounds pretty wretched now, but Star Trek is close.
 - Fixed CPU clock speed on the speech board, but it appears to be a
    bit too slow now.
 - This is still work-in-progress. Don't report bugs yet.


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Canvas Croquis [David Haywood]
Parallel Turn [Tomasz Slanina]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
SDI - Strategic Defense Initiative (System 16B) [Arzeno Fabrice]
Trivial Pursuit (Spanish Edition) [Manuel Abadia]
Multi Champ (World) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Solar Assault [Ville Linde]


==========================================================================

0.104u5

IMPORTANT CHANGE FOR OSD DEVELOPERS: a new function 
osd_create_directory is now required in order to create memcard
subdirectories. This function was previously defined only for the
MESS core, so if there is a MESS port already available, you can
just import that function.


MAMETesters bugs fixed (there are probably more)
-----------------------
exprraid0103u1red [Pierpaolo Prazzoli]
asterix053gre [Pierpaolo Prazzoli]
asterix_2055gre [Pierpaolo Prazzoli]
asterix_3055gre [Pierpaolo Prazzoli]
namcos10104u4red [Aaron Giles]
rthunder0104u3ora [Aaron Giles]
memorycard0104u2ora [Aaron Giles]
pause0104u2ora [Aaron Giles]
undrfire0104u4yel [Aaron Giles]
wwallyj0104u4red [Aaron Giles]
scorpion0104u4red [Aaron Giles]
itech8c0104u4red [Aaron Giles]


Source Changes
--------------

Hooked up missing language jumper in the Psikyo 4 games.
[David Haywood]

Added board notes to the Namco System 12 driver, hooked up the light
gun in Ghouls Panic/Point Blank 2, and emulated Tekken Tag Tournament 
DMA protection (still not playable). [Olivier Galibert, Duddie, smf]

Fixed old debugger compilation on non-Windows platforms. Added
mame_strnicmp along the way. [Lawrence Gold]

Fixed compile errors under GCC 4.1. [Lawrence Gold]

Changed the NES PPU interfaces to follow new struct conventions.
[Nathan Woods]

Updated disassembly comments support: [Andrew Gardner]
 - fixed a 0-length comment bug (no more "// 0, " allowed)
 - added comment output to the new debugger's dasm command
 - changed the comment save path from /mame/comment to /mame/comments

Added new debugger properties: logunmap, logunmapd, logunmapi which
enable/disable logging of unmapped memory accesses. [Nathan Woods]

Added save state support to the Astrocade driver. [Adam Bousley]

Some small improvements to the Polygonet Commanders driver.
[Andrew Gardner]

Preliminary Thumb implementation for the ARM7 core. Many opcodes 
present, but there are definite sign problems. [Ryan Holtz]

Hooked up ARM7 protection CPU in KOV2. Boots but does not run or 
play due to the Thumb sign problems. [R. Belmont]

Fixed incorrect flags emulation in the 8080 CMA instruction.
[Kopromaster]

Added support for zero-length palettes (requires RGB direct mode) and
several validity checks related to display variables. [Nathan Woods]

Updated windows input code: [Derrick Renaud]
 * Now using RAWMOUSE mode if available. This means you can now use 
    multiple mice in Windows XP. Lightgun support has not been 
    changed yet.
 * Added back DX7 support for the windows input system to support 
    multiple mice. It was set to DX5 in 104u2.
 * Removed the system mouse from the list of available mice on 
    non-XP systems. This allows you to now properly select the 
    individual mouse.
 * Modified the Analog Axes selection of the player controls to be 
    more responsive.

Cleaned up video system in Scorpion 2 driver. [El Condor]

Converted asterix to use K056832 emulation. [Pierpaolo Prazzoli]

Reduced encryption in Gaelco games down to equations. These still 
need to be optimized, but the giant encryption tables are no longer 
needed. [Nicola Salmoria]

Cleaned up include files in CPU/sound cores. CPU cores should 
generally only need to include cpuintrf.h. Sound cores should
generally only need to include sndintrf.h. [Atari Ace, Aaron Giles]

Fixed bug that caused a full set of validity checks even on release
builds. [Aaron Giles]

New debugger features: [Aaron Giles]
 * new command "print" is a simple way to display the result of one 
    or more expressions
 * new command "symlist" displays all the symbols registered
 * all save state registered scalar globals are now available as
    symbols (prefixed by a '.')
 * all save state registered global arrays are now available for
    viewing/editing in the memory window
 * all registered memory regions are also available for viewing/
    editing in the memory window

Made it a fatal error to request operations on invalid sound/CPU
indexes. These have been logged to the error.log in the past, but
really need to be cleaned up. Added a new function 
safe_activecpu_get_pc() that can be used when logging PCs to smartly
detect whether or not it is safe to call activecpu_get_pc().
[Aaron Giles]

Changed CPU init/reset callbacks. The init callback now accepts a
number of parameters, including the CPU index, the clock, a generic
configuration parameter, and a pointer to the IRQ callback. The reset
callback no longer takes any parameters (the configuration parameter
has been moved to the init callback). And the IRQ_CALLBACK getter/
setter has been removed since this is now set up once at 
initialization time. [Aaron Giles]

Added mame_get_phase to determine which program phase (init/reset/
running/exit) the system is in. This is intended primarily for
assertions to enforce rules about when certain actions can be taken.
[Aaron Giles]

Rewrote winalloc to be more dynamic, and to ignore memory leaks in
the runtime. [Aaron Giles]

Fixed memcards properly. They are no longer hardcoded for the neogeo.
The implementation has moved to generic/machine.c, and a callback
handler very similar to NVRAM is now supported in the machine driver
definition. Cards are created per-game, so the memcard directory now
has a subfolder per game with each game's cards stored underneath.
[Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Fighters Swords (Korean rel. of Samurai Showdown III) [Haze, Razoola]
Art of Fighting 3 (Korean release) [Haze, Razoola]
The Last Solider (Korean release of The Last Blade) [Haze, Razoola]
Real Bout Fatal Fury 2 (Korean release) [Haze Razoola]
Tekken 3 (TET2/VER.B) [smf]
Soul Calibur (SOC11/VER.C) [smf]
Point Blank 2 (GNB5/VER.A) [smf]
Tekken Tag Tournament (TEG1/VER.B) [smf]
Tekken Tag Tournament (TEG1/VER.A3) [smf]
Golgo 13 Kiseki no Dandou (GLS1/VER.A) [R. Belmont]
Pollux (set 3) [ClawGrip]
Out Zone (set 4) [Tormod Tjaberg]

New games marked as GAME_NOT_WORKING
------------------------------------
Gamshara [smf]
Taisen Hot Gimmick 4 Ever (Japan) [Guru, David Haywood]
Taisen Hot Gimmick Integral (Japan) [Guru, David Haywood]
Mahjong G-Taste [Guru, David Haywood]


==========================================================================

0.104u4

IMPORTANT CHANGES FOR OSD DEVELOPERS: 

1. osd_pause is no longer called directly. Rather, your osd_init 
function should register the osd_pause callback (if necessary) using 
add_pause_callback.

2. osd_die is now handled by the core; you should remove this
function from the OSD layer.

3. logerror is front-ended in the core; it calls to a new OSD
function osd_logerror which handles the OS-specific file and/or 
debugger logging.


MAMETesters bugs fixed (there are probably more)
-----------------------
memwindow0104u3red [Aaron Giles]
i9600104u2ora [Aaron Giles]
dietgo0104u2red [Aaron Giles]
st0016_0104u3red [Aaron Giles]
8751MCUgames0104u3 [Aaron Giles]
warriorb0104u2gre [Pierpaolo Prazzoli]
cheat0104u3ora [Ian Patterson]


Source Changes
--------------

Added comments support to the debugger. You can now dynamically add
comments that are visible next to the disassembly view. Comments are
saved to an XML-based .cmt file in a 'comments' directory by default
upon exiting. [Andrew Gardner]

Added "wb+" disposition to osd_tool_fopen. [Nathan Woods]

Fixed cheat timer to fire at the correct rate. Also fixed 
initialization order to work around dependency on the video/UI
system. [Ian Patterson]

Added save states to 3 more drivers: arkanoid.c, system1.c, and
taitosj.c, and to the SN76496 sound chip for system1. [Adam Bousley]

Fixed a couple of small memory leaks and a crash bug found by 
valgrind. [Lawrence Gold]

Added save state support to the tetrisp2 driver. [Nathan Woods]

Added save state support to Cloak and Dagger, Mario Bros, Crazy 
Baloon, and the SN76477 sound chip. [Adam Bousley]

Hooked up the R4650 properly in the MIPS recompiler. [R. Belmont]

More Namco System 23 progress: [R. Belmont]
 - Further hardware work
 - Hooked up H8/3002 MCU and sound system
 - Many notes added
 - Final Furlong 2 (World and Japan sets) added

Added sanity checking to the set_visible_area() call to ensure it is
not set larger than the screen bitmap. [Nathan Woods]

Added decryption of the BIOS for the Namco System 10 games using MEMN 
ROM boards. [smf]

Changed the ROM banking of the Bellfruit 'Adder' card to the new
standard, as well as tidying up the MPU4 emulation with some new 
information. [El Condor]

A bit more progress on Raiden 2 sprite decryption. [Olivier Galibert]

Added save states to Namco Classics Collection 1 & 2, Taito B System,
and fixed save states in Operation Wolf. [Adam Bousley]

Debugger changes/updates: [Aaron Giles]
 - added new streaming text buffer system
 - rewrote the console window to use the streaming text buffer
 - added new log window (Ctrl+L) which displays live error.log output
 - added disassembly view menu to control comments versus raw or
    encrypted opcodes
 - added disassembly menu to the main console window as well
 - now detect expressions with assignment or ++/-- operators as
    commands, do you can just say "pc=0" to modify registers instead
    of needing to type "do pc=0"
 - fixed bug that would sometimes lock the disassembly view to the
    top line

More global system cleanup: [Aaron Giles, Atari Ace]
 - remapped osd_die to fatalerror, which cleans up behind itself and
    returns to the osd code by returning from run_game
 - removed a number of unnecessary includes from driver.h
 - moved logerror into the core
 - moved 68000-specific build rules to cpu.mak
 - new function skip_this_frame, should be called by drivers instead
    of osd_skip_this_frame
 - removed includes of osdepend.h and osd_cpu.h from drivers; only the
    core should include these

More initialization/reset/pause cleanup: [Aaron Giles]
 - new function add_pause_callback can be called by other modules to
    register a callback for whenever MAME is paused/resumed
 - converted all existing pause hooks to use the new system
 - new function add_reset_callback can be called by other modules to
    register a callback for whenever MAME is reset
 - converted all existing reset hooks to use the new system
 - removed machine_reset; replaced with mame_schedule_soft_reset
 - new function mame_schedule_exit to force an exit cleanly from
    external events
 - removed all the "trying_to_quit" crap from the Windows code
 - moved save/restore system out of cpuexec.c into mame.c
 - moved core game loop out of cpuexec.c into mame.c
 - added hard reset support (complete tear down and re-init)

More core file shuffling: [Aaron Giles]
 - split sndintrf.c into sound.c, sndintrf.c, and sndhrdw/generic.c
 - added #include vidhrdw/generic.h to mamecore.h, and removed all 
    explicit includes elsewhere

Added save state support to the BSMT2000 sound emulator and the
dcheese driver. [Aaron Giles]

Fixed missing save state data in the dkong driver. [Aaron Giles]

Updated the 68000 disassembler to use the new interfaces.
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Fred Flintstone's Memory Match [Aaron Giles]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Dragon Breed (M81 pcb version) [Pierpaolo Prazzoli]

New games marked as GAME_NOT_WORKING
------------------------------------
Crazy Fight [Pierpaolo Prazzoli]
Search for the Magical Error [David Haywood]
Final Furlong 2 [R. Belmont]
Gekitoride-Jong Space [smf]
Mr. Driller G [smf]
Kotoba no Puzzle Mojipittan [smf]
Star Trigon [smf]


==========================================================================

0.104u3

IMPORTANT CHANGE FOR OSD DEVELOPERS: osd_exit is no longer called
directly. Rather, your osd_init function should register the osd_exit 
callback (if necessary) using add_exit_callback. Also, several global
variables have been moved into the Machine structure:

   mame_debug -> Machine->debug_mode
   playback   -> Machine->playback_file
   record     -> Machine->record_file


MAMETesters bugs fixed (there are probably more)
-----------------------
twinhawk0104u1gra [Alex Jackson]
twinhawk0104u1gre [Alex Jackson]
gtmr0100u1gre [Luigi30]
armchmp20104u2gra [Luigi30]
boothill0104gra [Luigi30]
yiear0103u1gra [Luigi30]


Source Changes
--------------

Cleanups to the taito_x driver: [Alex Jackson]
 - Converted input ports to an INCLUDE/MODIFY tree.
 - Fixed Lives DSW in twinhawk and twinhwku
 - Removed Cabinet DSW from twinhawk and twinhwku; they are 2psim 
    and do not support cocktail cabinets (the DSW does nothing).
 - Fixed Coinage DSW in suprmanj
 - removed MDRV_MACHINE_INIT(cchip1) from games that don't have a 
    c-chip (all of them except superman)

Fixed chdman to write the correct number of logical bytes when
extracting something that is not an even number of hunks large.
[Chris Hardy]

Some Raiden 2 documentation and input port updates (still not 
playable). [Olivier Galibert]

Created new osd_tool file which is used by utility tools to do
file access in an OS independent manner. [Nathan Woods]

Fixed typo in Hyperstone core that led to false positive warning
popups. [Pierpaolo Prazzoli]

Added support for IDT-specific MIPS MUL instruction in the MIPS3
core, recompiler, and disassembler. [R. Belmont, Aaron Giles]

Replaced -high_priority with -priority, you can now specify from 
-15 to 1. The default is -15 as this makes Dell laptop keyboards 
work. It still won't raise the priority if running with the debugger,
but it will lower it. Fixed a subtle bug at the same time as 
-high_priority was only working when you used rdtsc. [smf]

Added an optional xml_parse_options parameter to xml_file_read() 
and xml_string_read(), to provide options for preserving whitespace,
error reporting, and parser setup. [Nathan Woods]

Added save states to 2 simple drivers - bombjack.c and blktiger.c. 
[Adam Bousley]

Improved graphics ROM loading order in fredmem. [Luigi30]

New option -mngwrite, which records an MNG movie of the game from
the get-go and allows you to specify a target filename. [Buddabing]

Refactored/renamed/removed/added several core files: [Aaron Giles]
 - renamed driver.c to mamedriv.c
 - created a new driver.c containing functions defined in driver.h
 - split common.c into video.c and machine/generic.c
 - moved a number of mame.c functions to video.c

New file debugger.h contains abstracted debugging interfaces for
both debuggers. Added new call mame_debug_break() and a new macro
DEBUGGER_BREAK to make it easier to hard-code breakpoints into code.
Removed all old code that directly whacked debug_key_pressed or
called debug_halt_on_next_instruction and replaced them with calls
to DEBUGGER_BREAK. [Aaron Giles]

Added #include "state.h" to driver.h. This means most driver files
no longer need to explicitly include it. Went through and removed it
from most drivers. [Aaron Giles]

Reorganized the core initialization/exit sequencing to be "flatter"
and more straightforward to understand. System cleanup is now no
longer explicitly called by the code in mame.c. Rather, each init
function is free to register an exit handler, which will be called
in reverse order of registration upon a system exit. [Aaron Giles]

Removed default registrations from config_init() into the init
functions of the associated modules. Now each system that has config
data can register its own callbacks to process it. [Aaron Giles]

Renamed MACHINE_INIT to MACHINE_RESET to normalize the naming of the
callbacks defined in the MACHINE_DRIVER structure. Added several new
callbacks. The complete list is now:

   DRIVER_INIT -- per-game init called once at startup
   MACHINE_START/SOUND_START/VIDEO_START -- called once at startup
   MACHINE_RESET/SOUND_RESET/VIDEO_RESET -- called each reset

Save state registrations should be performed in DRIVER_INIT or 
(preferably) in the _START callbacks; they should be avoided in the 
_RESET callbacks if possible. [Aaron Giles]

Removed VIDEO_DUAL_MONITOR flag. [Aaron Giles]

Added a number of new properties to the debug views to allow for more
flexibility in the way the views are displayed. Also added an option
to the disassembly window to display encrypted opcode data on the
right. [Aaron Giles]

Save state changes: [Aaron Giles]
 - Audited the use of save state registrations throughout the code,
    switching most cases over to using the state_save_register_global
    or state_save_register_item macros to simplify the code.
 - Deprecated the save_state_register_<type> calls since nearly all 
    cases can be automatically handled by the macros. For odd cases, 
    there is now a save_state_register_memory call which is generic.
 - Simplified the save state logic, allowing for unlimited instances
    and reducing the complexity of the code. This breaks existing save
    states. Sorry, I'll try not to do it again.

Fixed save state support in Missile Command. [Aaron Giles]

Added oversampling support to the CEM3394 emulator. [Aaron Giles]

Added save state support to the CEM3394 and NES APU sound chips.
[Aaron Giles]

Added save state support to the jedi, balsente and dkong drivers. 
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Choko [Guru, Charles MacDonald]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Agress (English bootleg) [Pierpaolo Prazzoli]
Tokio / Scramble Formation [Nicola Salmoria, Arzeno Fabrice]
Bomb Kick [Pierpaolo Prazzoli]


==========================================================================

0.104u2

MAMETesters bugs fixed (there are probably more)
-----------------------
zwackery0104u1gre [Aaron Giles]
typo0104ora [Aaron Giles]
x86compile0104u1ora [Aaron Giles]


Source Changes
--------------

Hooked up MCU ROM properly in the System 23 games. [R. Belmont]

Fixed tilemap sizes in Nitroball. [Bryan McPhail]

Fixed Panic Road color PROMs. [Nicola Salmoria]

Added save state support to Night Driver (still needs save state
support in the discrete core to be 100%). [Oshah]

Miscellaneous cleanups to the 8255 PPI code; changed some 'int' types 
to 'offs_t' and 'UINT8'. Added ppi8255_get_portA/B/C() functions. 
Also fixed some formatting problems. [Nathan Woods]

Updates to the M37710 core: [R. Belmont]
 - Fixed LDM behavior when executing outside of bank 0
 - Fixed various global bugs when executing outside of bank 0
 - Fixed so top 8 bits of X & Y are preserved when in 8-bit index mode
 - Fixed some disassembly errors
 - Added save state support
 - Added M37702 alias for documentation purposes

Updates to the Namco System 22 driver: [R. Belmont]
 - Necessary changes to System 22 games to use the real C74 BIOS for 
    music/sound
 - Added system controller register to boot the C74
 - Speedup cheat for the CPU board C74
 - Promoted Ace Driver from NO_SOUND to IMPERFECT_SOUND

Made declarations and variables in a number of drivers static and 
const to reduce global namespace pollution. Fixed a number of 
multiply-defined global variables. [Atari Ace]

Added state save support to the Jaleco MegaSystem 32 and YMF271
sound core. [Nathan Woods]

Fixed Windows rendering code bug where -waitvsync had no effect when 
using -nohws -nod3d -notb. [Derrick Renaud]

Hooked up preliminary support for the text layer and palette in the
Namco System 23 driver. [R. Belmont]

Deprecated the use of multimon.h in the Windows build, which is only
necessary for producing Windows 95 and NT 4.0 compatible binaries.
Windows 98 is now the minimum version of Windows supported for MAME.
[Aaron Giles]

Made a few minor tweaks to the Windows sources to support the latest
build tools. See http://mamedev.org/tools if your tools are out of
date. [Aaron Giles]

Added assert_always macro which asserts even in a release build, and
requires a friendly message. [Aaron Giles]

Added new function xml_read_string, which allows for parsing of
internal strings into XML trees. [Aaron Giles]

Removed artificial gamma correction in nemesis driver. [Aaron Giles]

Removed scrbitmap and memory_region from the global Machine structure.
There is no need for non-core systems to access these directly.
[Aaron Giles]

Removed a ton of hacks that were checking for Machine->sample_rate==0,
which is now guaranteed to never be true. [Aaron Giles]

Split out ROM management from common.c and moved to a new file
romload.c. [Aaron Giles]

Added save state support to the POKEY emulator. [Aaron Giles]

Cleaned up structs/unions in the debugger and Windows code to match 
the new core conventions. [Aaron Giles]

Added new function state_save_register_bitmap to simplify bitmap
saving. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
The Lost Castle In Darkmist [Tomasz Slanina, Nicola Salmoria]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Super Glob (Pac-Man hardware) German [Chaneman, David Widel]
Burning Force (Japan old version) [Team Japump]


==========================================================================

0.104u1

MAMETesters bugs fixed (there are probably more)
-----------------------
esb0104gre [Mathis Rosenhauer]


Source Changes
--------------

Updated the old debugger recognize ~ prepended registers.
[Juergen Buchmueller]

Fixed new makefiles to be more friendly to non-x86 builds.
[Lawrence Gold]

Improved Star Wars sound synchronization. [Mathis Rosenhauer]

Hooked up 16-segment writes to the bfm_adr2 driver. [El Condor]

More improvements to the darkmist driver. [Tomasz Slanina]

Fixed default gun location for a number of lightgun games. [SilverFox]

Altered the way MESS interacts with the core config system.
[Nathan Woods]

Added save state support to the T-11, Hu6280, and ADSP-21xx CPU 
cores. [Buddabing]

GTI Club updates: [Ville Linde]
 - Improved K001604 tilemap emulation
 - Very preliminary K001005 & K001006 3D graphics emulation
 - Added some more SHARC opcodes

Separated various Z80 peripherals (CTC, PIO) into separate modules.
Added SIO module, hooked it up to NFL Football. Still no visible
progress. [Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Ikari 3 (Normal Joystick) [Tormod Tjaberg]
Thunder Cross (Set 3) [Stefan Lindberg]
Space Harrier (8751 317-0063?) [Zozo]
Fortress 2 Blue Arcade (ver 1.01) [Pierpaolo Prazzoli]

New games marked as GAME_NOT_WORKING
------------------------------------
Hang Pilot [Ville Linde]


==========================================================================

0.104

MAMETesters bugs fixed (there are probably more)
-----------------------
centiped0103u3ora


Source Changes
--------------

Fixed tiny.mak for the changes from 0.103u5. [Derrick Renaud]

Fixed NVRAM handling in Star Wars/ESB (only affects test mode).
[Mathis Rosenhauer]

Decrypted the question ROMs in the coinmstr.c games. [Nicola Salmoria]

Updated djboy driver with more protection information.
[Phil Stroffolino]

More NeoGeo cleanups. [David Haywood]

Phoenix Discrete Sounds - Changed R22 to 470 ohm per real board. This 
should fix the remaining complaints with the discrete sound. The shot 
& explosion noise sounds still need discrete emulation.
[Derrick Renaud]

Added 16-segment drawing code to the vacfdisp module. [El Condor]

Made 8-bit A,B,C,D,E,H and L registers available in the Z80
debugger. [Nicola Salmoria, Aaron Giles]

Ensured that all core and windows files have some indication of
copyright on them. [Aaron Giles]

Shuffled a few more files around in mame.mak; rebuild clean once
again to ensure correctness. [Aaron Giles]

Removed all but the default debugger font from the source
distribution. [Aaron Giles]

Fixed miscomputed registers view size in debugger. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Lord of Gun (USA) [Luca Elia]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Trivia ? Whiz (Vertical versions) [Pierpaolo Prazzoli]
Trivia ? Whiz (Edition 4) [Pierpaolo Prazzoli]
Phraze Craze (Sex Kit) [Pierpaolo Prazzoli]
Police Trainer (Rev 1.0) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Huang Fei Hong [Luca Elia]


==========================================================================

0.103u5

MAMETesters bugs fixed (there are probably more)
-----------------------
esb065gre [Mathis Rosenhauer]


Source Changes
--------------

Undid fix for turbofrc37b1gre since it broke more things that it
fixed. [Pierpaolo Prazzoli]

Fixed minor color issue in Cookie & Bibi. [David Haywood]

Updates to the Hyperstone core: [Pierpaolo Prazzoli]
 - Removed nested delays
 - Added better delay branch support
 - Fixed PC seen by a delay instruction, because a delay instruction
    should use the delayed PC (thus allowing the execution of 
    software opcodes too)

Hooked up watchdog for NeoGeo games and removed a number of hacks.
[David Haywood]

Fixed hanging at the end of level 3 in klondkp. [Pierpaolo Prazzoli]

Fixed inputs in Renju Kizoku, Neratte Chu, Mayjinsen 2 and some dips 
in Neratte Chu, Mayjinsen 2. [Sonikos]

Improved auto_malloc so it uses less memory and doesn't have a hard-
coded limit on the maximum number of allocations. Also audited the
use of auto_malloc in the code and removed unnecessary checks for
NULL (since auto_malloc doesn't return if it fails). [Atari Ace]

Fixed osd_fopen error reporting to return the correct value if you 
hit MAX_OPEN_FILES. [Nathan Woods]

Changed several byte operands in the i386 disassembler to be 
diassembled as unsigned rather than signed. [Nathan Woods]

Discrete sound updates: [Derrick Renaud]
 - Added new DISCRETE_CSVLOG module that lets you log discrete nodes 
    as CSV (comma separated values) data.
 - Modified discrete core to use the clock specified in the 
    MDRV_SOUND_ADD line.  If the clock is specified as 0, then the 
    discrete emulation will default to the audio sample rate clock.
 - Tweaked Phoenix Effect 2 sound to be more accurate matching 
    oscilliscope data.  Changed the Phoenix discrete clock rate to 
    a fixed rate of 120000 allowing the simulation to be more 
    accurate with less alaising noise at the cost of speed. 
 - Fixed the bug in the DISCRETE_NOTE module that produced notes 
    1 count off.

Added support for registers that are not to be displayed in the 
register list. This is useful for registers like AX on i386, so that
AX can be used in expressions but not represented on the register 
list. Simply precede the register name with '~' to prevent display.
[Nathan Woods, Aaron Giles]

Added support for the various x86 8-bit and 16-bit derived 
registers, as hidden registers in the i386 core. [Nathan Woods]

Fixed background music in ESB. Updated IRQ frequency and divider to 
match the schematics. [Mathis Rosenhauer]

Improved dip switches for rocktrv2. [Chaneman]

Separated the allocation of graphics data from the decoding. This 
fixes the crashes that were introduced in u4, and will allow for 
decoding progress to be reported eventually. [Aaron Giles]

Made a clean-up pass over all the makefiles. rules.mak is gone now,
replaced by cpu.mak and sound.mak. mame.mak has been reorganized. All 
the makefiles are now commented and should be easier to follow. 
[Aaron Giles]

Rewrote artwork scaling function to compute accurate sum over all
contributing pixels. This produces better results when scaling high
resolution artwork down to lower resolutions. Kept existing bilinear
filter for scaling low resolution art to higher resolutions. 
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Hidden Catch (World) [Pierpaolo Prazzoli]
Fortress 2 Blue Arcade [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Several more NeoGeo bootlegs [Razoola, David Haywood]
Jumbo Ozaki Super Masters Golf (Japan) [Team Japump]
Miss Puzzle (Nudes) [Brian Troha]


==========================================================================

0.103u4

MAMETesters bugs fixed (there are probably more)
-----------------------
xevious083gre [MASH]


Source Changes
--------------

Intel i386/i486/Pentium update: [Nathan Woods]
 - Fixed A20 mask implementation
 - Added A20 mask to debugger translate callback
 - Implemented Pentium opcode CMPXCHG8B
 - Fixed XADD, and added support for the 8 and 16 bit variants

Fixed Top Shooter sprites. Game still not playable. [Tomasz Slanina]

Changed debug view property code to pass property values as unions 
rather than void pointers, in order to appease compilers that whine 
about strict aliasing. [Nathan Woods]

Fixed resource allocation issue with bitmaps in the Windows code and
MESS. [Nathan Woods]

Removed a number of unnecessary video_stop and machine_stop routines.
[Atari Ace]

Converted a few more exit() calls to osd_die(). [Oliver Stoneberg]

Fixed inputs on Ninja Spirit and the Sega System 16b driver to match 
the JAMMA button ordering. [Corrado Tomaselli]

Fixes to the Hyperstone core: [Pierpaolo Prazzoli]
 - Removed nested delays
 - Don't allow software opcodes to be executed in a delay slot

Added/changed the following discrete modules: [Derrick Renaud]
 - DISCRETE_WAVELOG - easy way to log discrete nodes as a .wav file 
    to compare against scope waveforms.
 - DISCRETE_OUTPUT - added a final gain parameter to get it to 16 bit 
    wav level.  (The old VOL setting was disabled after the last 
    sound re-write.)

Fixed graphics banking in 8751-based Altered Beast sets. 
[David Haywood]

Fixed some bad gfx in kdynastg when levels start. [Pierpaolo Prazzoli]

Decrypted graphics in Darkmist and Panic Road. [Nicola Salmoria]

Added stream_set_sample_rate() call, and converted the TMS5110, 
TMS5220, ES5505/6, BSMT2000, AY8910, POKEY, TIA, Sega PCM/Multi-PCM, 
SN76496, OKIM6295, and YMZ280B sound cores to output at their native 
sample rates, allowing the core sound system to perform over/
re-sampling to the output rate. [Aaron Giles]

Moved CHD file access routines to fileio.c. [Aaron Giles]

Added assert macro to mamecore.h. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Laser Battle/Lazarian [Pierpaolo Prazzoli]
Cat and Mouse [Pierpaolo Prazzoli]
KlonDike+ [Pierpaolo Prazzoli]
Alien Arena
Crowns Golf in Hawaii [Aaron Giles]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Joust (Solid Green Label) [Reznor007]
Space Intruder (Japan) [Tomasz Slanina, Guru]

New games marked as GAME_NOT_WORKING
------------------------------------
Galaxia [David Haywood]


==========================================================================

0.103u3

Source Changes
--------------

H8/Last Fight update: [R. Belmont]
 * (H8) Limited vector reads to 24 bits
 * (H8) Added SHLL.W, EXTU.L, SUBS.L #2, and SUBS.L #4 opcodes
 * Includes Guru's readme
 * Loads all ROMs
 * Maps RAM for the stack

Converted wcvol95 and hvysmash to use the 16-bit deco tilemap 
functions. [David Haywood]

Added BCD multiply to ARM coprocessor to fix wcvol95. [David Haywood]

Cleaned up the Neo Geo mess from 0.103u2. [David Haywood, Razoola]

Added support for >4GB CHD files to chdman for non-Windows systems.
[Lawrence Gold]

Fixed leapyear calculation. [William Krick]

Converted Super Burger Time, Vapor Trail, and Crude Buster to use the 
deco tilemap functions. [David Haywood]

Rewrote Neo-Geo video system, removing distinction between raster and
non-raster games and cleaning up the code significantly. 
[David Haywood]

Improved DIP switches for clowns, clowns1, and bowler. [Bob Seidel]

Added CPUINFO_PTR_DEBUG_SETUP_COMMANDS: a callback that is invoked to 
tell CPU cores to set up commands specific to a CPU core.
[Nathan Woods]

Added SegBase() and SegLimit() functions to the i386 core debugger.
[Nathan Woods]

Improved sound balance in Night Slashers. [MAME Italia]

Improvements to the Deco MLC games (added sprite buffering, fixed 
tile banking, fixed clear colour, added sprite clipping & ARM 
interrupt bug fix). The only thing left for this driver is really 
raster support for the pitch in Stadium Hero. [Bryan McPhail]

Fixed Hang On stereo sound routine. [Mamesick]

Cleaned up PC keyboard code. [Nathan Woods]

Added memory_install_* calls that are not specific to specific bus 
widths (only for static handlers, not for function pointers). 
[Nathan Woods]

Added sound to Ping Pong Masters '93. [Tomasz Slanina]

Converted Crazy Balloon sound to use the discrete system. 
[Derrick Renaud]

Major Namco System 22 update: [Phil Stroffolino]
 * Hooked up the real master DSP BIOS.  Many games are now working or
    displaying graphics that were having problems before; removed many
    hacks as a result.
 * Hooked up the runtime-configurable interrupt handlers, removing 
    more game-specific hacks.
 * Some improvements and additional documentation of video hardware.
 * Emulated Alpine Surfer protection and fixed bogus loading of 
    Point ROMs, though the game still has problems.

Fixed the Wild Western bonus screen, where the horse would not scroll 
into view. [Nicola Salmoria]

Cleaned up inputs in the bfm_sc2 driver. [El Condor]

Fixed in the old debugger the display of opcodes for word-addressed 
CPUs like the TMS32010, which was completely broken before. 
[Alex Jackson]

Separated debugger break key from OSD display. They can now be 
programmed differently. Also fixed behavior in the new debugger when 
using the break so that text doesn't get entered onto the command 
line. [Aaron Giles]

Fixed the handling of address masking and display within the debugger.
[Aaron Giles, Nathan Woods]

Fixed order of operations in the expression engine if functions were 
used. [Aaron Giles]

Added timer support to the ADSP cores and hooked it up for the DCS 
games. [Aaron Giles]

Many Voodoo updates to add Voodoo Banshee and Voodoo 3 support. 
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Backfire! [David Haywood]
Skull Fang [Bryan McPhail]
Thunder Hoop [Pierpaolo Prazzoli, Mike Coates, Brian Troha]
X-Files [Pierpaolo Prazzoli]
King of Dynast Gear [Pierpaolo Prazzoli, Guru]
Meijinsen [Tomasz Slanina]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Demon's World / Horror Story (first edition) [Corrado Tomaselli]
The Couples (Set 3) [f205v]
Dragon World (World, V0300) [f205v]

New games marked as GAME_NOT_WORKING
------------------------------------
Poizone [Chris Hardy, David Haywood]


==========================================================================

0.103u2

MAMETesters bugs fixed (there are probably more)
-----------------------
midres056gre [Bryan McPhail]
ddragon077u3red [Bryan McPhail]
airbustr37b9gre [Pierpaolo Prazzoli]
turbofrc0103gre [Pierpaolo Prazzoli]
turbofrc37b1gre [Pierpaolo Prazzoli]


Source Changes
--------------

Fixed sound bug in Phoenix sound effect #2 [Hans Andersson]

NeoGeo updates [http://neosource.1emulation.com/forums/]
 * Fatal Fury 2 - Emulated Protection
 * King of Fighters 10th Anniversary - Added code to update SRAM 
    tiles on the fly
 * CCTHD2k3 - Fixed GFX / Colours
 * Added code to support remaining NeoGeo sets

Fixed Mat Mania dipswitches [Roberto Fresca]

Fixed some Leap Year calculates [William Krick, smf]

Sync Refresh / Waitvsync / Triplebuffer changes [Alan Kamrowski II]
 * Changed the waitvsync code to wait for the beginning of the 
    vertical blank (the previous code simply checked if it was in the 
    vblank and only waited if it wasn't).
 * Removed the waitvsync only if game speed is above 95% restriction.
    This restriction would only cause waitvsync to vacillate between 
    on and off depending on game speed.
 * When syncrefresh and triplebuffer are used, MAME would run the 
    waitvsync code anyway. The triplebuffer code takes care of this 
    already.

Fixed typo in monzagp.c [Brad Oliver]

Documentation cleanups in ddenlovr.c [Brian Troha]

SS Mission and Air Attack dipswitch fixes [Brian Troha]

Improvements to the Data East 156 (ARM) based games [Various]
 * Added Sound to Night Slashers [Tomasz Slanina]
 * Added Sound to World Cup Volleyball '95 and BackFire!
    [Pierpaolo Prazzoli]
 * Fixed sprite flipping in the Data East MLC driver, this fixes the
   graphics in Avengers in Galactic Storm [Tomasz Slanina]
 * Modified ARM CPU core to allow World Cup Volleyball '95 to
   start [Tomasz Slanina]
 * Added BCD opcodes to 156 / ARM co-processor, needed by the above 
    [David Haywood]
 * Fixed Sound in Data East MLC games [David Haywood]
 * Split BackFire! into a separate driver and improved the graphics, 
    and added dual screen support [David Haywood]
 * Corrected sound decoding in BackFire! [David Haywood] 
 * Cleanups to the ARM core [Bryan McPhail]

Fixed fileio.c buffer overrun [Lawrence Gold]

i486 CPU patch [Nathan Woods]
 - Implemented the XADD, INVLPG and CMPXCHG instructions
 - Made the opcode table const correct

H6280 updates [Rob Bohms]
 - Added T-flag emulation
 - Fixed read calls

Debugger Improvements [Nathan Woods]
 - Added a 'gtime' command; like the "go" command, but breaks after 
    a specified delay 

Corrected Frequencies in WWF Superstars [Phil Bennett]

Added sample banking to spec2k [Pierpaolo Prazzoli]

Various improvements in Airbuster driver [Pierpaolo Prazzoli]

Updated Namco NA-1 to use the real bios [R.Belmont, Charles MacDonald]

M37710 fixes [R.Belmont]
 * Added another addressing mode for SBCB
 * Fixed MPY to clear the carry flag
 
Fixed some Endian issues in the Namco drivers [R.Belmont]

Merged Lovely Cards / Lovely Poker drivers [El Condor]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
World Cup Volley '95 [Bryan McPhail, David Haywood]
Hoops '96 / Hoops / Dunk Dream '95 [Bryan McPhail]
Quintoon [ReAnimator / AGEMame]
Pokio [ReAnimator / AGEMame]
Slots [ReAnimator / AGEMame]
Paradice [ReAnimator / AGEMame]
Pyramid [ReAnimator / AGEMame]
Golden Crown [ReAnimator / AGEMame]
Rock'n Tread 1 (bootleg) [Justin Lee Turner]
Rock'n Tread 2 (bootleg) [Justin Lee Turner]
Rock'n Tread 3 (bootleg) [Justin Lee Turner]
Rock'n Tread 4 (bootleg) [Justin Lee Turner]
Twin Action [Luca Elia, David Haywood]
Arm Champs II [Luca Elia, The Guru]
Mahjong The Mysterious World [Luca Elia]
Air Attack [Pierpaolo Prazzoli]
SVC Chaos [http://neosource.1emulation.com/forums/]
King of Fighter 2003 [http://neosource.1emulation.com/forums/]
Samurai Shodown 5 [http://neosource.1emulation.com/forums/]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Alien 3: The Gun (US) [Arzeno Fabrice]
Magic Crystals (World, newer) [Uncle Tom]

New games marked as GAME_NOT_WORKING
------------------------------------
Last Fighting [R.Belmont]
The Crystal Maze [AGEMame]
Turnover [AGEMame]
Skill Trek [AGEMame]
The Mating Game [AGEMame]


==========================================================================

0.103u1

MAMETesters bugs fixed (there are probably more)
-----------------------
upsidedown0103yel [Mamesick]


Source Changes
--------------

Major cleanup/rewrite of the Berzerk driver: [smf]
 * merged memory & io read/write maps.
 * video ram & magic ram share the same memory.
 * hooked up nvram in frenzy memory map.
 * emulates magic ram shifter/flopper with 9 74LS153's as per the 
    schematics.
 * emulates magic ram alu with 2 74LS181's hardwired to logic mode as 
    per the schematics.
 * 74LS181 emulation based on the logic diagram from the datasheet, 
    supporting logic mode & arithmetic mode

Fixed Thunderstrike interrupts, visible area, and raster updates. 
[Bryan McPhail]

Updates for the ARM core: [Bryan McPhail]
 * Fixed software interrupts.
 * Fixed several mode change bugs.
 * Preliminary coprocessor support.

Deco fixes: [Bryan McPhail, Pierpaolo Prazzoli] 
 * Deco MLC video hardware near perfect for the most part, however 
    no game works properly because of an unemulated math coprocessor 
    attached to the DE156 chip.
 * Deco 32: Night Slashers pretty much perfect apart from lack of 
    sound.  
 * Deco 32: Some graphics fixes for Tattoo Assassins.
 * Deco 156: Heavy Smash pretty much perfect.

Tagged a number of constant arrays in the source as static. 
[Atari Ace]

Many H6280/PCE fixes: [Rob Bohms, Charles MacDonald]
 - fixed cases where sprites could render outside of the buffer
 - added VRAM to VRAM DMA (Charles)
 - multiple h6280 fixes (Charles)
 - provided functions to correctly handle VRAM accesses for the 
    entire 128K range (Charles)
 - added some of the I/O buffer bits from the hardware page
 - fixed h6280 IRQ ranges to support proper mirroring
 - hooked up h6280 IRQs to the PC Engine
 - corrected sprite-to-sprite rendering priorities.
 - partially enforce 16 sprite limit

Added new debugger command traceflush. [Nathan Woods]

Fixed out-of-bounds array writes in the v810 core. [Atari Ace]

Moved several BCD and date-related functions into mamecore.h. 
[Nathan woods]

Hooked up sound effects in Triple Hunt.
[Derrick Renaud, Stefan Jokisch]

Fixed OKI frequency in Super Model. [Sonikos]

Added PowerPC MMU code, but enabled only for MESS due to breakage of 
the Model 3 games. [Nathan Woods]

Fixed graphics layer priority in Grand Tour. [Tomasz Slanina, Guru]

Rewrote the Star Wars mathbox multiplier from the schematics.
[Mathis Rosenhauer]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Night Slashers [Bryan McPhail]
Heavy Smash [Bryan McPhail]
Avengers In Galactic Storm [Bryan McPhail]
Power Instinct Legends [Brian Troha, Pierpaolo Prazzoli, Guru]
Shuttle Invader [Tomasz Slanina]
Mahjong The Dai Chuuka Ken [Luca Elia, Guru, bnathan]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Pasha Pasha Champ Mini Game Festival [Pierpaolo Prazzoli]
Thunder Strike (Newer) [Bryan McPhail]
Super Star Battle [Pierpaolo Prazzoli]
Quiz (Revision 2.1) [Pierpaolo Prazzoli]

New games marked as GAME_NOT_WORKING
------------------------------------
Mirax [Tomasz Slanina]


==========================================================================

0.103

MAMETesters bugs fixed (there are probably more)
-----------------------
astrob0102u5gre [Nicola Salmoria]


Source Changes
--------------

Completely rewrote machine/stvcd.c and .h. There's a lot less there now, 
but what's there is more understandable and works much better. [R. Belmont]

Some RF5C400 improvements. [hoot development team]

Cleaned up/reorganized some of the messy Neo Geo code. Separated out bootleg-
specific hacks into additional files. [David Haywood]

Replaced a few stray exit() calls with osd_die(). [Oliver Stoneberg]

Fixed layer 1 colors in Blandia. [Pierpaolo Prazzoli]

Corrected interrupt timing in wwfstar driver. [David Haywood]

Fixed chdman to support 64-bit file sizes on some *nix platforms.
[Lawrence Gold]

More ST-V updates: [Mariusz Wojcieszek]
 * added idle loop skipping for rsgun
 * added RBG caching
 * added RBG "two screens" mode
 * added Critter Crusher (not working due to missing inputs)
 * fixed several bugs introduced recently with all the other changes

Changed i286 core to use the same INPUT_LINE_A20 that the i386 core uses.
[Nathan Woods]

Added partial updates and boosted the interleave in the ddragon driver.
[David Haywood]

Added cdrom_get_track_length() to cdrom.c. [R. Belmont]

Added an atexit handler to ensure trace files are closed in the debugger
in the event of an early exit. [Nathan Woods]

Merged the Sprint 4/Ultra Tank drivers and made the following fixes:
[Stefan Jokisch]

 * Ultra Tank:
    - hardware collision detection (computer is now able to manoeuvre 
         around barriers)
    - sprite fixes (invisble tank option works, tank explosion sequence)
    - playfield fixes (text colors are different)
    - watchdog and coin lockout added
    - sync and color proms added
    - motor sound fix (previously this was hooked up to the wrong address)
    - misc internal fixes like cpu speed, RAM size etc

 * Sprint 4:
   - sound support (inherited from Ultra Tank)
   - watchdog added

Fixed bug in the Grand Champion fog effect. [Hans Andersson]

Fixed Triple Hunt and several older Atari games to use RAM mirroring for
zero page memory. [Stefan Jokisch]

Fixed several endian issues with the SE3208 core and the Crystal System
driver. [Brad Oliver]

Got the DCS-3 sound system working for Road Burners. [Aaron Giles]

Did some cleanup in the ADSP-21xx core to support program memory more 
correctly and support execution from multiple banks. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Mad Ball [David Haywood, Brian Troha]
Super Model [David Haywood]
Garogun Seroyang (Korea) [David Haywood, Pierpaolo Prazzoli]
MuHanSeungBu (SemiCom Baseball) [David Haywood, Brian Troha]
Games V18.2 [Pierpaolo Prazzoli, Guru]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Puzzle Bang Bang [Brian Troha, Pierpaolo Prazzoli]
Super World Court (World) [Stefan Lindberg]
Out Zone (set 3) [David Haywood]
Mini Vegas 4in1 [Tomasz Slanina]
Crazy Rally (set 2) [David Haywood, Guru]
Gouketsuji Ichizoku (Japan) [Pierpaolo Prazzoli, Guru]
Dynamite Duke (Japan) [Pierpaolo Prazzoli, Guru]
The Double Dynamites (Japan) [Pierpaolo Prazzoli, Bryan McPhail, Guru]
Passing Shot (World, 4 Players, FD1094 317-0074) [Mame Italia]

New games marked as GAME_NOT_WORKING
------------------------------------
Martial Masters [David Haywood]
Demon Front [David Haywood]
Canvas Croquis [David Haywood]
Go 2000 [David Haywood, Brian Troha]
Gekisou (Japan) [David Haywood]
Critter Crusher [Mariusz Wojcieszek, Guru]
Card Line [Tomasz Slanina]
Shuttle Invader [Tomasz Slanina, Guru]


==========================================================================

0.102u5

MAMETesters bugs fixed (there are probably more)
-----------------------
dspirit099u2yel [BUT]
mjkjidai097u2gre [Mamesick]
suprnova0102u4red [Aaron Giles]
nbmj8991c095u2yel [Mamesick]
grchamp055yel [Hans Andersson]
grchamp137b12gre [Hans Andersson]
grchamp237b12gre [Hans Andersson]
vulcan137b1gre (part 2, and maybe parts 4 and 5) [Pierpaolo Prazzoli]
gunlock097u2yel [Nicola Salmoria]
gekirido096u3gre [Nicola Salmora]
ssi061gre [Nicola Salmoria]
ssi137b2gre [Nicola Salmoria]
ctribe088u4gra [Mamesick]
groundfx068gra [Mamesick]
tengai062gre [AWJ]


Source Changes
--------------

Fixed bug in discrete filtering code. [Frank Palazzolo]

Fixed speedup for znpwfv so that it boots once again. [Mariusz Wojcieszek]

Improvements to cuoreuno and elephfam: [Roberto Fresca]
 * Corrected videoram and colorram (now can see the nvram initialization).
 * Corrected the CPU frequency to 2 MHz.
Still not working...

Fixed Playchoice/VSNES drivers. [Rob Bohms]

Hooked up the same NES APU implementation in both MAME and MESS. Also
correctd the memory mapping of the APU in the Playchoice 10 driver. 
[R. Belmont]

Hooked up Psikyo 4 PCM banking. [Anonymous]

Significant improvements to the Grand Champion driver: [Hans Andersson]
 * Tunnel headlights
 * Corrected rain effect
 * Corrected colors
 * Added speech
 * Improved collision detection (removed false collision when lightning)
 * Improved fog effect
 * Added skeleton code for motor noise
 * Fixed graphic glitch in bottom row
 * Corrected CPU speed for Cpu board / Game board

Added simulated version of the N64 PIF boot rom to the Aleck64 driver, so 
the cartridges now boot properly, though the cartridge CRC check fails on 
both games. [Ville Linde]

Fixed instruction alignment in the old debugger. Also added support for
64-bit qword display. [AWJ]

Fixed timing between CPU and MCU in chaknpop. In previous driver, you will 
notice problems in stages with water and coffee break (not always). New 
driver fixes it but it is not perfect about timing. [BUT]

Added sound to Honey Doll. [David Haywood]

Changed activecpu_dasm() and activecpu_dasm_new() so that they "function" 
even if the getinfo handler does not specify CPUINFO_PTR_DISASSEMBLE nor 
CPUINFO_PTR_DISASSEMBLE_NEW. [Nathan Woods]

Completed the X-Multiply DIP switches. [Roberto Fresca]

Moved m6809, hd6309 and z80 disassemblers to the new interface, and did 
some cleanups. [Nathan Woods]

Fixed the SUBW H flag in the SPC700 core. [Rob Bohms]

Added missing functionality needed to get rsgun working. [Olivier Galibert]

SP0250 update: [Nicola Salmoria]
 * Added SP0250 speech chip to 3 Stooges.
 * Streamlined the SP0250 emulation to avoid timing issues which were 
    preventing 3 stooges from working.
 * Fixed glitches in the speech that were caused by not resetting the 
    filter stages when a speech frame is loaded.
 * Made the SP0250 support the external clock rate
 * Changed the playback rate to match the real board by making the clock 
    divider a reasonable number.

Added new debugger command 'map', which tells logical -> physical mappings
as well as what read/write handlers are connected to an address. Also added
'mapd' and 'mapi' for performing the same operation on data and I/O space.
[Aaron Giles]

More Voodoo updates: [Aaron Giles]
 * fixed overflow in 1/W calculation that messed up some textures
 * added missing color combine mode used by Gauntlet Dark Legacy

Fixed subtle bug in the MIPS3 recompiler that prevented Tenth Degree from
working. [Aaron Giles]

Implemented some more functionality of the ADSP-2181 needed for Road Burners.
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Mosaic (F2 System) [Pierpaolo Prazzoli]
Vs. Hot Smash [Nicola Salmoria]
Noah's Ark [David Widel]
Top Roller [Tomasz Slanina]
Squash (Ver. 1.0) [David Haywood, Mike Coates, Nicola Salmoria]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
California Speed (Version 2.1a) [Reznor007]
Gauntlet Dark Legacy (version DL 2.52) [Reznor007]
Tenkomori Shooting (Japan) [Guru]
Soul Calibur (SOC11/VER.B) [smf]
Tekken Tag Tournament (TEG3/VER.C1) [smf]
Quiz [Pierpaolo Prazzoli]
King of Gladiator (The King of Fighters '97 bootleg)
Crouching Tiger Hidden Dragon 2003 (The King of Fighters 2001 bootleg)
King Of Fighters 10th Anniversary (The King of Fighters 2002 bootleg)
The King of Fighters Special Edition 2004 (The King of Fighters 2002 bootleg)
Lansquenet 2004 (Shock Troopers - 2nd Squad bootleg)

New games marked as GAME_NOT_WORKING
------------------------------------
Real Battle Mahjong King [Tomasz Slanina, David Haywood]
Little Robin [David Haywood, Pierpaolo Prazzoli]
Ghoul Panic (OB2/VER.A) [Guru]
Knights of Valour 2


==========================================================================

0.102u4

Source Changes
--------------

Corrected some YM2151 frequencies in the dooyong.c driver. [Mamesick]

Major update to the STV driver: [Mariusz Wojcieszek]
 * sh2: introduced cpu_readop16() for opcode fetching
 * stv: added idle skip to various games
 * stv: optimized master/slave sh2 syncing
 * vdp1: fixed sprite transparency for RGB sprites
 * vdp2: added linescroll
 * vdp2: added 16x16 15bit tiles (fixes missing gfx in znpwfv)
 * vdp2: optimized tilemap scrolling, bitmaps and framebuffer drawing
 * vdp2: fixed page and map calculation
 * dsp: fixed some bugs making vfremix run up to the end of second match

Fixed sprite-tilemap collision detection in Taito SJ driver when the screen
is flipped. [Nicola Salmoria]

Fixed some logical errors in sprite handling and palette reads, DMA timing, 
and one invalid opcode in the NES drivers. [Rob Bohms]

Cleaned up and standardized usage of M_PI constants in the code.
[William Krick]

Added external ram read and write handlers and data read port to YMZ280B.
[Ville Linde]

Fixed sprite priorities in Tang Tang. [Pierpaolo Prazzoli]

Fixed bug in Chack'n Pop that was introduced in the recent memory system
changes. [Nicola Salmoria]

Fixes branch target address disassembly in the PSX disassembler. [smf]

More Voodoo updates: [Aaron Giles]
 * fixed bug that trashed fbzMode when the fogMode was changed
 * added preliminary Voodoo 2 support; Gauntlet Legends works again
 * changed float-to-int conversion to be done manually


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Flame Gunner [Guru, smf]
Paca Paca Passion Special [Guru, smf]
Paca Paca Passion 2 [Guru, smf]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
WWF Superstars (US, Newer) [Philip Bennett]
Time Pilot '84 (set 3) [chaneman]
Multi Champ Deluxe (ver. 0106) [David Haywood]
Columns (US, cocktail) [Arzeno Fabrice]
Mace: The Dark Age (boot ROM 1.0ce) [Brian Troha]
Arabian Fight (World) [Arzeno Fabrice]

New games marked as GAME_NOT_WORKING
------------------------------------
Emergency Call Ambulance [Ville Linde]


==========================================================================

0.102u3

MAMETesters bugs fixed (there are probably more)
-----------------------
taotaida088u4gra [RansAckeR]
tempest095u5gre [RansAckeR]


Source Changes
--------------

Aquarium update: [Pierpaolo Prazzoli]
 * Fixed tilemaps - sprites priority
 * Added sprites wrap around y
 * Added tiles flipx and flipy

Fixed several bugs in the SPC700 core: [R. Belmont]
 * Fixed carry usage in ADC/SBC
 * Fixed overflow flag in ADDW/SUBW (I think)
 * BRK now modifies the status register properly
 * Fixed DAA/DAS edge case

Updated driver.c with more consistent and updated info. [Brian Troha]

NSS/SNES updates from latest MESS: [R. Belmont]
 * Improved memory mapping
 * Improved raster timing
 * Added HIRQ support and better VIRQ support
 * Improved joypad support
 * DSP-1 support (including all subtypes)
 * Counter latching support
 * Fixed OAM read/write
 * Fixed stereo sound

Added a MESS specific ROM entry type, and changed ROM entry processing code 
to ignore any unrecognized ROM entry types. [Nathan Woods]

Merged in recent changes to the PC share code from MESS. [Nathan Woods]

Removed several obsolete files: machine\s16math.h, vidhrdw\medlanes.h,
windows\dirty.h, windows\snprintf.c. [Giuseppe Gorgoglione]

Fixed a couple of minor compatibility exposed by VC2005.
[Giuseppe Gorgoglione]

Fixed the ADC and SBC opcodes in G65816 (for BCD math). [Rob Bohms]

Fixed $4014 sprite DMA in NES PPU. [Rob Bohms]

Updated the H8/3002 emulation: [R. Belmont]
 * Added more bXXX.b #imm, (@)Rn instructions
 * Added subtract with carry instructions

Implemented some N2A03 undocumented opcodes. [Rob Bohms]

Major update to Namco System 22: [Phil Stroffolino]
 * depth cueing support (fog); some open issues remain
 * depth bias improvements
 * zbuffer has been replaced with back-to-front rendering
 * sprite and text translucency
 * direct access to rendering device (used by video tests)
 * preliminary support for spotlight feature
 * support for sprite bottom-alignment
 * support for sprite, polygon priority over text

More Voodoo updates: [Aaron Giles]
 * Added support for CLUT/gamma ramps; enables fade in/out effects
 * Changed stall callback to notify both start and end of stalling
 * Decreased bilinear resolution to 4 bits for Voodoo 1
 * Fixed statistics and added some new ones
 * Now properly masking off unsupported bits for earlier chipsets
 * Fixed NOP command so it doesn't always reset statistics
 * Fixed bug that caused the refresh rate to never be updated
 * Fixed 16-bit writes to the frame buffer
 * Fixed crashing bug after resetting the chip
 * Added support for Voodoo 2's new fog, colorpath, and chromaRange modes
 * Added correct wrapping for ARGB, W and Z values
 * Fixed bug where depth was written to the Z buffer without bias
 * Now aggregates shorter commands to reduce the number of context switches


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Magic Stick [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Progressive Music Trivia (Question set 3) [Pierpaolo Prazzoli]
Super Puzzle Fighter II Turbo (Asia 960529) [Razoola]
Funky Jet (Japan) [Guru]
Kid Niki - Radical Ninja (World) [Stefan Lindberg]

New games marked as GAME_NOT_WORKING
------------------------------------
Fortress 2 Blue Arcade [Guru]


==========================================================================

0.102u2

MAMETesters bugs fixed (there are probably more)
-----------------------
f1en097u1gre2 [Anonymous]
ozmawars055gre [RansAckeR]


Source Changes
--------------

Some minor cleanups to the System 32 driver. Air Rescue and F1 Exhaust Note
now share common multi-PCB faking logic. [Anonymous]

Properly hooked up tape samples in Thief, NATO Defense, and Shark Attack now
that sample pausing is available. [Bart Tobalske]

Fixed several uninitialized variables, incorrect string compares, and
inconsistent variable declarations found by the VC compiler. [Oshah]

Fixed 16-bit i386 disassembly so it stays within the current segment.
[Nathan Woods]

Some minor Turbo Sub changes: [Philip Bennett]
 * Added some more notes.
 * Corrected some hardware functions in accordance with the schematics.

Tweaked the 68000 disassembler to display F-line traps in a more obvious
fashion. Also changed to decorate jump targets for relative branches.
[Alex Jackson]

Rewrote the Voodoo emulation code to be more accurate to the original.
 * Support for multiple simultaneous boards (hello Silent Scope)
 * Pixel-pipelined framebuffer accesses now work
 * Alpha buffer operations now supported
 * Triple buffering now supported
 * Proper memory allocation and handling based on configuration
 * Proper FIFO handling, including low/high water marks and stalling
 * Approximate timing calculations based on quoted fill rate specs
 * Detail textures implemented
 * All math is done in fixed point
 * Proper edges calculated for polygons (stars appear in Gradius 4 now)
 * Much easier to add specific rasterizers now
This is a work in progress; some stuff is not quite right yet. Voodoo 2
emulation is completely broken. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Lovely Pop Mahjong Jan Jan Shimasyo 2 [Guru]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Trivia Master (set 2) [Pierpaolo Prazzoli]
Tech Romancer (EURO 980914) [Arzeno Fabrice]
Splatter House (World) [Arzeno Fabrice]
Strider 2 (USA 991213) [Brian Troha]
Touch & Go (World) [Stefan Lindberg]
Wonder Boy (system 2) [David Widel]
Kageki (World?, hack) [David Haywood]

New games marked as GAME_NOT_WORKING
------------------------------------
Fighting Vipers 2 [Ville Linde]
Tang Tang [David Haywood]
Spectrum 2000 [David Haywood]
Spikeout [Ville Linde]
Spikeout Final Edition [Ville Linde]


==========================================================================

0.102u1

Source Changes
--------------

Several fixes for the kaneko16 drivers: [Pierpaolo Prazzoli]
 - fixed tilemap priorities
 - fixed some sprites priorities
 - added some missing coin counters
 - added right palette filling for games using sprite type 1
 - swapped berlwall and berlwalt sets as per SebV notes in the source code

Fixed compilation issue for MSVC when using the winalloc code. [Nathan Woods]

Replaced the 68705 MCU from the bootleg Knight Boy with simulation. Added 
Knight Boy to keep using the MCU code. [Nicola Salmoria]

Added redump of bad ROMs for Cruis'n World (rev L1.3). [Guru]

Changed some i386 disassembly parameters to be unsigned. [Nathan Woods]

Fixed output of mame.ini options that have spaces in them. [Nathan Woods]

Improvements to Wheels and Fire, partial understanding of the blitter.
[David Haywood, Tomasz Slanina]

Added very, very preliminary emulation of the Ricoh RF5C400. [Ville Linde]

Added new inline math functions to mamecore.h, along with mechanisms for the
OSD layer to override them with platform-specific variants: 
count_leading_zeros, count_leading_ones, and fixed_mul_shift. Updated the
TMS32031 core to make use of the first two. [Aaron Giles]

Changed the Windows blitters to use an array allocated by 
osd_alloc_executable() to prevent potential access violations on systems
with no-execute support. [Aaron Giles]

Fixed some minor problems with the LOD calculations in the Voodoo driver.
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Dark Horse [Luca Elia]
Virtua Bowling (Japan) [Luca Elia]
Honey Dolls [David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Red Clash (set 2) [chaneman]
Stack Columns (World) [Arzeno Fabrice]
Puzzle & Action: Ichidant-R (Korea) [David Haywood]
Knight Boy [Nicola Salmoria]
Dragon World [Luca Elia]
Billiard Academy Real Break (Europe) [Corrado Tomaselli]

New games marked as GAME_NOT_WORKING
------------------------------------
Fred Flintstones' Memory Match [Brian Troha]


==========================================================================

0.102

MAMETesters bugs fixed (there are probably more)
-----------------------
bbmanw0101u4red [Pierpaolo Prazzoli]
dirtfoxj063gra [Mamesick, Pierpaolo Prazzoli]
starblad0101u5yel [Aaron Giles]
mouja0101u5gre [Hau]


Source Changes
--------------

Fixed a few more remaining issues from the 0.101u1 update. 
[Aaron Giles, Pierpaolo Prazzoli]

Fixed some bad tiles in naname. [Pierpaolo Prazzoli]

Fixed music tempo in T.N.K.3/T.A.N.K. [R. Belmont, Kold666]

Began adding support for SCRIPTS programs to the 53C810 emulation.
[Nathan Woods, R. Belmont]

Fixed inputs in Passing Shot (Japan). [Ange Albertini, Barry Rodewald]

Added some missing sounds to Wonder Stick and Search Eye. 
[Pierpaolo Prazzoli]

Fixed status flag from MCU in Taito SJ games, fixing the last digit of the
score in Front Line. [Nicola Salmoria]

Many fixes to the SHARC core and Konami PPC drivers. [Ville Linde]

Updated the discrete thump sound in Asteroids to use component values
instead of derived equations. [Hans Andersson, Derrick Renaud]

Added Tilemap0 color banking to esd16. [Pierpaolo Prazzoli]

Fixed save/restore of 8253 PIT. Also several updates to Top Gunner:
[Mathis Rosenhauer]
 * Removed shift register since it just seems to be needed to
    compensate for different DAC speeds
 * Added 8254 PIT from PC emulation
 * Added state saving

Fixed bug in PSX GTE flag settings. [Olivier Galibert]

Fixed 6502 initialization so that all internal states are reset properly.
[Nathan Woods]

Changed the makefile so that debug objects are not compiled on non-debug
builds. [Aaron Giles]

Marked most gfx_layout and gfx_decode structures in the code as const.
[Aaron Giles]

Fixed handling of the FR bit in the Status register on MIPS3. This fixes a
few problems in CarnEvil, and probably affects a few other games as well.
Also fixed bug where TLB exceptions were not filling in the Context and
EntryHi registers correctly. [Aaron Giles]

Removed ROMREGION_SOUNDONLY. Since -nosound no longer disables sound CPUs or
sound cores (and hasn't for a while), failing to load sound ROMs was only
leading to crashes. [Aaron Giles]

Implemented pixel-accurate dithering in the Voodoo emulation. [Aaron Giles]

Renamed my_stricmp to mame_stricmp, converted all uses of stricmp in the
code to call mame_stricmp, and #defined stricmp to something invalid to
prevent code from using it in the future. [Aaron Giles]

Fixed implementation of mame_stricmp. [William Krick]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Jockey Grand Prix [Mamesick]
Gradius 4: Fukkatsu [Ville Linde]
See See Find Out [Tomasz Slanina]
Pang Pang Car [Tomasz Slanina]
D-Day (Jaleco) [Tomasz Slanina]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Touch & Go (newer revision) [Corrado Tomaselli]
Avengers In Galactic Storm (World) [Corrado Tomaselli]
Metamorphic Force (ver EAA) [Stefan Lindberg]
Rohga v5.0 Asia/Europe [Stefan Lindberg]
Rohga v3.0 Asia/Europe (Alt) [Stefan Lindberg]
Tricky Doc (Alt) [Stefan Lindberg]
Vandyke (Jaleco lic. Alt set) [Stefan Lindberg]
Varth - Operation Thunderstorm (World 920714) [Stefan Lindberg]
Super Monaco GP (US, Rev B) [Arzeno Fabrice]
DownTown (Set 2) [Stefan Lindberg]
NFL Blitz (boot ROM 1.1) [Brian Troha]
Martial Champion (ver EAB) [Stefan Lindberg]
NBA Play By Play [Ville Linde]


==========================================================================

0.101u5

MAMETesters bugs fixed (there are probably more)
-----------------------
vf097u2gre [R. Belmont]
daytona099u4gre [R. Belmont]
memoryupdate0101u1red [Aaron Giles]


Source Changes
--------------

Added a FIFO for the sound commands in Sega Model 1 driver so they no longer
get lost at startup. Fixed the CPU speed of the 68000. [R. Belmont]

Several fixes and improvements to the C352 sound emulator.
[hoot development team]

Implemented several missing features in the Namco NA sound emulator. [cync]

Added conditional dip switches and a missing dip switch to excelsr.
[Pierpaolo Prazzoli]

Fixed J. League protection workarounds so they work for 2 player games as
well. Also fixed sonic so it works as well as the prototype version (still
major graphics issues). [Anonymous]

Marked several large arrays properly as const. [Atari Ace]

Fixed 6805 core so that CLRA does not modify the carry flag. [Ernesto Corvi]

Fixed sprites wrap around in st0016 (needed in nratechu). 
[Pierpaolo Prazzoli]

Model 3 update: [Ville Linde]
 * Added Daytona USA 2 Power Edition
 * Huge update to the video hardware, including:
    - Transparency support (polygons and textures)
    - Nearly perfect rendering order (something we never got right in 
      Supermodel :-)
    - Parallel lighting
    - Texture coordinate mirroring

Added very experimental rasterizer generator for the Voodoo emulator, which
generates X86 assembly blitters optimized for each case. Unfortunately, it
doesn't help performance much and they are still too buggy so they are
disabled for now. Enable them in the makefile. [Aaron Giles]

Made some of the hack optimizations runtime enableable in the Voodoo
emulator, and added a frameskipper. Use Ctrl+1-6 to control frameskipping,
Ctrl+F/H/Q to run at full/half/quarter resolution. [Aaron Giles]

Rewrote most of the validity checks so the full set now completes in well
under 1 second, minus I/O time from paging in data. Also added region
size checking versus memory maps to the validity checks. Moved all validity
checks to a new file validity.c. [Aaron Giles]

Changed the AM_REGION() macro to store region/offset information instead of
a pointer to simplify some of the region valdation code. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Wonder Stick [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Atomic Robo-kid (Japan, Set 2) [Brian Troha]
Raimais (Japan) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Ping Pong Car [David Haywood, Guru]
Daytona USA 2 Power Edition [Ville Linde]


==========================================================================

0.101u4

MAMETesters bugs fixed (there are probably more)
-----------------------
flstory0101u3red [Aaron Giles]
gottlieb0101u2yel [HobbesAtPlay]
lelandsound0101u3yel [Aaron Giles]
kamikcab101u2yel [Aaron Giles]
segac0101u3red [Mathis Rosenhauer]
spiders0101u3yel [Aaron Giles]
drgnmst067gre1 [Pierpaolo Prazzoli]
memoryupdate0101u1red  [Aaron Giles & others]
missile0101u3red [Aaron Giles]


Source Changes
--------------

Fixed more games broken by the u1 changes. There are only a very small number
of games that are still known to have issues. [Aaron Giles with contributions
from Mathis Rosenhauer]

Improved video rendering and fixed graphics corruption on the final level of
Fairyland Story. [Nicola Salmoria]

Updated the h6280 CPU to use the new address translation system. [Aaron Giles]

Added MAME build information to the listxml output, and updated xml2info to
handle the save state tag. [cutebutwrong]

Updated PSX core to new save state and disassembler interfaces. Updated 
dismips to handle the new disassemblers. [smf]

Removed code that reset the timer when reading/writing on the mk48t08
timekeeper chip. Updated the save state interfaces. Added new macro
state_save_register_item_pointer() for dynamically allocated arrays. [smf]

Updated R3000 core to the new disassembler interfaces. [Aaron Giles]

Added coin counter/lockout and rowscroll banking to the drgnmst driver.
[Pierpaolo Prazzoli]

Added missing SC/LL opcodes to the MIPS3 interpreter. [R. Belmont]

Updated Konami and R3000 disassemblers to new format. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
The J. League [Anonymous]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Kosmo Killer [David Haywood]
Splash 1.0 [Corrado Tomaselli]
Glass 1.1 [Corrado Tomaselli]
Match It II [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Dwarfs Den [David Haywood]
Trivia Quest [Pierpaolo Prazzoli]
Wheels & Fire [David Haywood]


==========================================================================

0.101u3

MAMETesters bugs fixed (there are probably more)
-----------------------
bigkarnk0101u2gre [Pierpaolo Prazzoli]


Source Changes
--------------

Fixed a number of games that were broken with the u1 update. Just a few
more cases remain. Most games are working at this point. [Aaron Giles, with
contributions from El Condor, R. Belmont, Ville Linde]

Added preliminary save state support to Missile Command and Battlezone.
[Buddabing]

Fixed some dips in Pop's Pop's. [Sonikos]

Fixed inputs in Woodpecker. [Pierpaolo Prazzoli]

Updated PowerPC core to use new disassembler style. [Nathan Woods]

Merged in recent updates from MESS PC emulation code. [Nathan Woods]

Fixed DTD in the -listxml output. [Oliver Stoneberg] 

Added sprites banking, tile banking, sound banking, and a couple of
DIP switches to Egg Hunt. [Pierpaolo Prazzoli]

Updated 6502 family of disassemblers to the new disassembler style. Added
internal memory maps for the m6510 and m4510 CPU cores. Updated m4510 to
use address translation hooks. [Nathan Woods]

Reduced how often the debugger display is refreshed if stepping and
steps_until_stop is a high number.  This makes commands like 'step 
#10000' a bit more usable. [Nathan Woods]

Fixed MESS UI code that prevented P and Esc from being intercepted properly.
[Lawrence Gold]

Added check and failure for 0-sized mallocs. [Nathan Woods]

Updated i86 and i286 cores to hook into the new i386 disassembler.
[Nathan Woods]

Added MMU support to the MIPS3 dynamic recompiler. Re-enabled it by default.
Added direct fast RAM access to the dynamic recompiler, as well as optional
hotspot optimizations. Most games should show a net speedup over the pre-MMU
compiler. [Aaron Giles]

Fixed FPU decoding and a few other minor issues in the i386 disassembler.
[Aaron Giles]

Added rudimentary hotspot detection to the debugger. Type "help hotspot" for
details on how it works. [Aaron Giles]

Cleaned up the way the debugger hooks into the memory subsystem. Now, on each
CPU switch, the debugger queries the memory system for callbacks to be called
on every read/write. This allows more efficient watchpoint tracking and allows
for non-watchpoint debugging behaviors like the hotspot detection.
[Aaron Giles]

Changed the way encrypted CPU memory is allocated and managed. Previously,
memory_set_opcode_base() was used to set a single pointer to the decrypted
opcodes; however this presented a number of limitations. Now that all RAM and
ROM-like regions are assigned banks, the memory system now tracks decrypted
opcodes per bank. For implicit banks (marked RAM or ROM in the memory map),
a new function memory_set_decrypted_region() configures which areas of the
address space contain decrypted opcodes and where the decrypted opcodes live.
For explicit banks, there is a new function memory_configure_bank_decrypted()
which operates identically to memory_configure_bank() but specifies a pointer
to the decrypted opcodes on a per-bank basis. Updated all drivers using the
old mechanism to the new mechanism and removed the old system. [Aaron Giles]

Thanks to the new opcode handling, removed "RAMROM" support from the memory
subsystem altogether, and updated all drivers to simply limit their decryption
to areas that the CPU decrypted. [Aaron Giles]

Fixed activecpu_dasm() and cpunum_dasm() to detect the presence of an updated
disassembler and wraps the calls to that rather than crashing. [Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Street Fighter EX 2 (ASIA 980312) [Corrado Tomaselli]
Batsugun (set 2) [Parodier]
Glass (Ver 1.0 set 2) [Corrado Tomaselli]
Golden Tee Royal Edition Tournament (v4.02) [Brian Troha]


==========================================================================

0.101u2

MAMETesters bugs fixed (there are probably more)
-----------------------
mgcrystl093u3gre [Pierpaolo Prazzoli]
lastmisn096u3gre, part 1 [Pierpaolo Prazzoli]


Source Changes
--------------

Fixed time stamp counter in the Pentium core. [Ville Linde]

Fixed Z80 behavior on cold versus warm reset. [Frank Palazzolo]

Fixed a number of games that were broken due to the recent memory system
changes. There are still more problems to fix; continue reporting them.
[Aaron Giles]

Added support for logical mapping to the CPU interfaces and debugger. CPUs
that have an MMU now need to support several new interface bits, including
a logical address mask and page size for each address space, as well as a
new translate function. There is also a new disassembler interface that
should be used going forward, which will make it much simpler to keep the
disassemblers standalone and not dependent on MAME functions for opcode
accesses. Converted the i386 core to use the new interfaces. [Aaron Giles]

Added MMU support to the non-drc MIPS3 emulator. Converted the Killer
Instinct, Seattle, Vegas, and Hyper Neo-Geo 64 drivers to a proper physical 
memory layout. Disabled the drc MIPS3 core until MMU support is added there 
as well. [Aaron Giles]

Added save state support to the S2650 CPU. [Aaron Giles]

Got rid of gross banking hack in the T11 core. Updated Atari System 2 drivers
to accommodate the lack of the hack. [Aaron Giles]

Imported a number of memory handler conversion helpers from MESS, placed 
them in memconv.h. [Aaron Giles]

Cleaned up i386 disassembler to produce Intel-standard output. [Aaron Giles]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Gouketsuji Ichizoku (Japan, bootleg) [David Haywood]

New games marked as GAME_NOT_WORKING
------------------------------------
Alpine Surfer [R. Belmont]
Area 51: Site 4 [Ville Linde]
Psychic Force 2012 [Ville Linde]


==========================================================================

0.101u1

WARNING: There is a significant change to the memory system in this version.
It is likely that a number of games are broken. Please report these games
to http://www.mametesters.org.


MAMETesters bugs fixed (there are probably more)
-----------------------
galpanic0100u4yel [Pierpaolo Prazzoli]


Source Changes
--------------

Integrated 53C810 into the SCSI framework. [Tomas Karlsson]

Balanced the sound in Final Tetris, Boogie Wings, B.C. Story, Metal Saver.
[sonikos]

Fixed Q*Bert knocker connection. [Kevin Jonas]

Some improvements to M37710, C352 and NamcoNA sound. [cync]

Corrected CPS1 frequencies based on measurements from a real PCB.
[Philip Bennett]

Significant change to the memory system. RAM areas are now no longer 
allocated out of the memory_region for a given CPU. This means that drivers
which assume that RAM is located at some offset to the base of the memory
region will be broken. [Aaron Giles]

Added save state information for streams so that dynamic volume changes
get properly restored. Unfortunately this breaks all existing save states.
[Aaron Giles]

Added save state support to the HC55516 sound chip. Added save state support
to the Williams sound boards. Added save state support to games in the
mcr3.c and mcr68.c drivers, marking them as GAME_SUPPORTS_SAVE. [Aaron Giles]

Changed timer_alloc_ptr-style timers so that the pointer parameter is
supplied at allocation time and is not changeable. This makes these timers
more easily supported in save states. [Aaron Giles]

Fixed missing save state registrations in the m6809 CPU core. [Aaron Giles]

Deferred state loading until all anonymous timers have cleared. This fixes
issues where the timers would fire after the load and would clobber data 
that was just loaded. [Aaron Giles]

Cleaned up and fully mapped the Williams sound boards. Also added save state
support to them. [Aaron Giles]

Added save state support to the classic Williams drivers, marking them as
GAME_SUPPORTS_SAVE. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Chewing Gum [f205v]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Puzz Loop (Korea) [Corrado Tomaselli]

New games marked as GAME_NOT_WORKING
------------------------------------
Get Bass [Ville Linde, Guru]
Scud Race Plus [Ville Linde, Guru]


==========================================================================

0.101

Source Changes
--------------

Wired up save state support for all the games in pacman.c, jrpacman.c, and
pengo.c. Marked all games as GAME_SUPPORTS_SAVE. [Aaron Giles]

Added new generic macros to state.h to make it simpler to do save states.
Use state_save_register_global(var) to register a driver-related global
variable. Use state_save_register_item(module, instance, var) to register
other variables with specific module and instance names. Converted the MCR
and Cinematronics vector saves over to this. As a result, save states for
games will be incompatible with prior versions of MAME. [Aaron Giles]

Added save state support to the 8255 PPI, 7474 TTL, and the TMS5110 sound 
chip. Added save state support to the galaxian.c driver and all the 
associated drivers. Marked all games in galaxian.c, scramble.c, scobra.c,
frogger.c, and amidar.c as GAME_SUPPORTS_SAVE. [Aaron Giles]

Changed the timing of save state bank registration so that dynamically
installed banks will work properly. [Aaron Giles]

Added validity check to ensure driver names are 8 characters or less.
[Aaron Giles]


==========================================================================

0.100u4

MAMETesters bugs fixed (there are probably more)
-----------------------
acrobatm0100u3gra [Mamesick]


Source Changes
--------------

More NSS updates. This is mostly for MESS's benefit but nss_ncaa improves 
from it too. [R. Belmont]
 * SPC700: Fixed operand order for SBC to memory
 * SNESHW: Implemented unknown DMA & HDMA modes
 * SNESHW: Fixed SRAM sizing (used as protection in some games)
 * SNESHW: Boosted interleave
 * Fixed scroll registers to work like real hardware
 * Fixed timing of OAM address reset and range/time over reset to better 
    match real hardware
 * Fixed missing "break" for HDMA mode 5
 * Fixed behavior of OLDJOYx registers when auto-read is enabled

Added filters back into the Scramble driver. [Hans Andersson]

Changed break/watchpoints in the new debugger to display in hex.
[Anonymous]

Updated usrintrf.c to work better with MESS. [Nathan Woods]

Merged ctribe machine driver with ddragon3. [Mamesick]

Improved Zip & Zap DIP switches. [Brian Troha]

Improved Egg Hunt DIP switches. [Brian Troha]

Fixed flipscreen in TC0100, which improves Liquid Kids. [Bryan McPhail]

Improved Metal Saver DIP switches. [Brian Troha]

Cleaned up merging of Jolly Card sets. [Roberta Fresca]

Updated 65816 and 37710 cores: [R. Belmont]
 * Fixed both CPUs to set the data bank register to the destination on 
    an MVN/MVP
 * Some minor tweeks so the debugger works properly when the 65816 is 
    executing out of a read handler (as it always is for the SNES)

Filled in missing asteroids DIP switches. [Kevin Jonas]

Updates to the I386 core: [Ville Linde]
 * Added i486, Pentium and Cyrix MediaGX CPUs
 * Replaced the opcode tables with a dynamically built one
 * Rewrote the cycle counting to support different CPUs
 * Added page translation
 * Tons of bugfixes
Also updated the SPI driver to work with these changes.

Cleaned up the taito_f2 driver: [Brian Troha]
 * Converted what I could to port_include and port_modify
 * Fixed a few rom names and standardized names add a PCB layout.
 * Changed the sound CPU to 240000/6 and the YM2610 to 240000/3 as there 
    is no 16MHz OSC on the PCB.  Only a 26.686 & 24.000 MHz chips.

Fixed inputs in vliner: [Mamesick]

Added some basic zooming support to the gstriker/twcup94 driver.
[David Haywood]

Improved accuracy of joystick types reported in -listxml. [Buddabing]

Added "Uptime" to the bookkeeping info displayed in the UI. [Aaron Giles]

Added new driver flag: GAME_SUPPORTS_SAVE, to indicate drivers which have
save state support that is supposed to work. Attempting to save state on
a game without this flag will give a warning. Save state-related bugs may be 
filed against drivers with this flag set. [Aaron Giles]

Removed the GAMEX and GAMEBX macros. The flags parameter has been moved into
the GAME and GAMEB macros and these are used for all games. [Aaron Giles]

Converted a few more drivers over to using the new memory_configure_bank
calls. [Aaron Giles]

Added save state support to the Cinematronics vector sound hardware and to
the Z80 CTC system. Also fixed QB3 banking when used with save states.
Marked all the games in cinemat.c with GAME_SUPPORTS_SAVE.
[Aaron Giles]

Added save state support to the TMS5220 chip. Added missing registers to
the 6800 core's save state. Cleaned up 6821 PIA initialization and save
state registration. Marked all the games in mcr.c with GAME_SUPPORTS_SAVE.
[Aaron Giles]

Changed ui_popup to display longer by default for longer messages.
[Aaron Giles]

Added new option -autosave which automatically loads a game at startup and
saves it at exit time for any game which is explicitly marked with
GAME_SUPPORTS_SAVE. For other games, this option has no effect. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Magic's 10 [Pierpaolo Prazzoli]
Alpine Racer 2 (Ver. 97/01/10 17:10:59) [R. Belmont]
Dark Edge [Anonymous]
Metal Saver [David Haywood, Corrado Tomaselli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Bonanza Bros (Japan, Floppy) [David Haywood, Team Japump]
Scramble Spirits (Japan, Floppy) [David Haywood, Team Japump]
Ninja Kids (US) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
Magic's 10 2 [Pierpaolo Prazzoli]


==========================================================================

0.100u3

Source Changes
--------------

More Sega C2/Genesis-based games cleanup: [Aaron Giles]
 * fixed crashes introduced in last version
 * centralized interrupt generation for all Genesis-based games
 * implemented protection correctly for Puyo Puyo 2

Changed validity checks to use hashes for speed. Also changed them to only
run on the drivers in the source file of the current game, rather than on all
games, in non-debug builds. And fixed the coinage sorting check so that it
doesn't depend on the linker to order the strings in a particular way.
[Paul Priest]

Removed -skip_validitychecks option now that the time to execute the checks
is not as bad. [Aaron Giles]

Improved speed in Top Gunner by pre-decoding the vector processor microcode.
Also added a shift register to produce the LCD-like look of the score and
other numbers. [Mathis Rosenhauer]

Nintendo Super System sound update: [R. Belmont]
 * Fixed bugs in SPC700 ADC, SBC, ADDW, SUBW, MUL, DIV, & CLRV opcodes
 * Fixed several APU hardware/timer issues
 * Added accurate sound DSP emulation from the latest OpenSPC
 * Fixed some timing issues that prevented ActRaiser from syncing up
Result: generally accurate sound in the working NSS games, and in many 
SNES games over in MESS as well.

Added missing vertical movement to Gatsbee. [Pierpaolo Prazzoli]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Laser Battle [Pierpaolo Prazzoli]
Water Balls [David Haywood]
Pop's Pop's [David Haywood]
Egg Hunt [David Haywood]
Zip & Zip [David Haywood]
Power Balls [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Escape Kids (Asia, 4 Players) [David Haywood]
Gigandes (Japan) [Chack'n]

New games marked as GAME_NOT_WORKING
------------------------------------
NFL Football [Aaron Giles]
Cat'N Mouse [Pierpaolo Prazzoli]
Metal Saver [David Haywood]


==========================================================================

0.100u2

MAMETesters bugs fixed (there are probably more)
-----------------------
pepper20100u1red [Aaron Giles]
exidy440c0100u1red [Aaron Giles]
ldrun0100u1gre [Pierpaolo Prazzoli]
orld105k079yel [Mamesick]
fromanc4099u2gre [Mamesick]


Source Changes
--------------

Fixed bug that caused VIDEO_EOF routines to be called while paused. This led
to weird graphics and out of timers messages in some games. [Aaron Giles]

Improved redhawkb DIP switches. [Roberto Fresca]

Separated Sega C2 driver into several other pieces. [David Haywood]

Changed m72 video updating to use partial updates. [Aaron Giles]

Replaced old Prop Cycle input hacks with proper analog control.  For best 
results, delete your propcycl.nv file and calibrate (same procedure as 
Cyber Cycles and Final Lap R) before playing. [R. Belmont]

Fixed error message when auditing optional files. [smf]

Bumped interleave in the elecyoyo driver to avoid attract mode hang. [MASH]

Flipped solarq overlay. [MASH]

Updates to the Sega C2 driver: [Aaron Giles]
 * got Twin Squash working
 * fixed column scroll with a line scroll of 8
 * cleaned up input ports
 * cleaned up Ribbit protection implementation
 * fixed protection for Print Club games
 * filled out memory map according to cgfm's documentation
 * hooked up protection for Print Club v.2, 4, 5

Implemented raster split interrupt in System FL games, making Final Lap R
work fully. [El Semi]

Cleaned up driver flags and parent/child relationships in the funworld
driver. [Roberto Fresca]

Small NSS update: [R. Belmont]
 * Fixed disassembly of 2 SPC700 instructions
 * Fixed behavior of the APU port clear flag to not clobber the output 
    ports - games now can boot and run without the "APU skipper"
 * Fixed SPC700 CMP instruction flags

Some under-the-hood debugger changes: [Olivier Galibert]
 * Added an osd-private void * to debug_views
 * Made view sizing more dynamic


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Lup Lup Puzzle [Pierpaolo Prazzoli]
Twin Squash [Aaron Giles]
Cool Minigame Collection [Pierpaolo Prazzoli]
Golden Axe - The Duel [Mariusz Wojcieszek]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Moon Light [Roberto Fresca]
Final Crash (World, bootleg) [David Haywood]
Golden Tee Supreme Edition Tournament (v5.10) [Brian Troha]

New games marked as GAME_NOT_WORKING
------------------------------------
NBA Play By Play [Ville Linde]
Top Shooter [David Haywood]


==========================================================================

0.100u1

Source Changes
--------------

Fixed incorrect voices in the NB-1 games. [R. Belmont]

Namco FL system updates: [R. Belmont, El Semi]
 * complete MCU simulation including controls and coinage (see important note 
    about calibrating the steering at the top of the driver)
 * hooked up sprite banking
 * added sound/music
 * fixed palette bank selection
 * fixed road in both games
 * fixed rotation sign

Namco System 22 improvements: [R. Belmont]
 * added real MCU-managed controls and coinage for Time Crisis
 * fixed reversed stereo channels for Super System 22
 * Fixed RAM test failure in Ridge Racer 2, but it still won't start up
 * Fixed analog controls for Cyber Cycles and Ace Driver
 * MCU now reads the controls for Air Combat 22
 * Added coinage for all (non-Super) System 22 games - don't use '9' to 
   coin up Ridge Racer anymore :)

Fixed Truco Clemente colors [David Haywood, Pierpaolo Prazzoli]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Quiz Syukudai wo Wasuremashita [Brian Troha, Guru]
Cookie & Bibi 3 [David Haywood, Corrado Tomaselli]
Rough Racer [David Haywood, Team Japump]
Final Lap R [R. Belmont, El Semi]
Speed Racer [R. Belmont, El Semi]
Dragonball Z V.R.V.S. [Anonymous]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Crack Down (Japan) [David Haywood, Team Japump]

New games marked as GAME_NOT_WORKING
------------------------------------
Thunder Hurricane (ver UAA) [R. Belmont, Guru]
Quizmaster [Pierpaolo Prazzoli]
Trail Blazer [Pierpaolo Prazzoli]
Super Nudger II [Pierpaolo Prazzoli]


==========================================================================

0.100

Source Changes
--------------

Fixed crash in some games when using a low sample rate or -nosound.
[Aaron Giles]

Fixes crashes in the following drivers: [Aaron Giles]
 * Beat Head (video update)
 * Hit Me (graphics decode)
 * Imago (palette setup)
 * Legend of Kage bootlegs (accessing invalid CPU)
 * Rock Climber
 * Speed Attack (palette out of range)

TumblePop driver updates: [David Haywood]
 * split driver into tumblep.c and tumbleb.c
 * tumblep.c runs the original tumble pop sets and use now using 
    deco16ic.c for the gfx.
 * tumbleb.c runs the bootlegs and games which use hardware which works 
    in a similar way to tumble pop (semicom titles etc.)

Kludged around glitches in Monster World. [David Haywood]

Cross Pang is now using the sprite draw copied from tumbleb.c instead as 
the game also seems to be based around Tumble Pop designs, as a result the 
'Alpha Blend' bit has been removed and replaced with a flicker sprite bit 
like Tumble Pop which looks more correct to me.  Also changed some default 
settings. [David Haywood]

Corrected Indian Battle DIP switches. [ShimaPong]

Updated D-Day DIP switches to use conditionals. [James Wallace]

More Namco sound/MCU updates: [R. Belmont]
 * Fixed analog controls for Ridge Racer and Rage Racer
 * Fixed sound/music to play in System 22 games
 * Fully share the sound part of the MCU RAM for System 11. This allows 
    games to read back the song names and fixes the sound test menu in 
    Tekken and Tekken 2.


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
G-LOC R360 [Craig Walker]

New games marked as GAME_NOT_WORKING
------------------------------------
Rebus [David Haywood]


==========================================================================

0.99u10

Source Changes
--------------

Fixed bug in INP recording that crashed MAME. [Aaron Giles]

Added some small optimizations to the Namco System 22 3D renderer.
[Aaron Giles]

Fixed interrupt problem in the M37710 core that caused problems with the
recent Namco update. [Aaron Giles]

Fixes to the recent Namco sound update: [R. Belmont]
 * Fixed incorrect voices in System 11/12 games
 * Fixed swapped stereo in System 11/12 games
 * Fixed missing sound in Namco Classics games

Added conditional DIP switches to 10 Yard Fight driver. [Curt Coder]

Added and wired up color PROM for Truco Clemente, but still missing a
transform. [Roberto Fresca]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Monsters World [David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Surprise Attack (World Ver. K) [Corrado Tomaselli]
Power Instinct 2 (Japan) [EGCG]
Chuugokuryuu II (ver. 100J, Japan) [EGCG]


==========================================================================

0.99u9

Source Changes
--------------

Removed tilemap_dispose call and fixed the two drivers that were using it.
This fixes improper save state registrations in megasys1 and ygv608 games.
[Aaron Giles]

Fixed bug that caused the sound cores to keep running while paused. 
[Aaron Giles]

Added discrete emulation of the background music for Indian Battle.
[Derrick Renaud]

Fixed tilemap priorities in Magic Bubble. [Pierpaolo Prazzoli]

Cleaned up MESS hooks into the input port system. [Nathan Woods]

Major Namco sound improvements: [R. Belmont]
 * C352 now sets output pitch correctly by input clock
 * Added emulated sound and music to all NB-1, NB-2,
    and System 11 games, using Prop Cycle's BIOS as a
    substitute until the original can be trojaned or
    otherwise obtained
 * Hooked it up for plain System 22 games as well, but
    they're not interested in passing down proper commands
    for some reason
 * Speed-cheated all instances of the M37710/C352 sound
    system so CPU requirements don't go up much.  This
    also helped back off the requirements a hair for Prop
    Cycle and Time Crisis


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Magic Bubble (Adult version) [David Haywood]
Dynamite Dux (set 1, 8751 317-0095) [Arzeno Fabrice, David Haywood]


==========================================================================

0.99u8

MAMETesters bugs fixed (there are probably more)
-----------------------
demonwld37b5gre [Pierpaolo Prazzoli]
batrider099u1gra [Mamesick]


Source Changes
--------------

Added save/restore of tilemap parameters. [Aaron Giles]

Improvements to the ST-V driver: [Mariusz Wojcieszek]
 * dma:  added another checking for dma parameters
 * stv:  changed v-blank timing
 * vdp1: implemented two framebuffers and flipping
 * vdp1: added manual changing and erasing of framebuffers
 * vdp1: added manual trigger for drawing
 * vdp1: mapped framebuffer into memory (for 16bpp only)
 * vdp1: added shadow and half luminance for RGB sprites
 * vdp2: fixed bitmaps scrolling (fixes bad gfx in batmanfr and
    bakubaku intro)
 * vdp2: added preliminary window effect for tilemaps and sprite layer
    (for batmanfr)
 * vdp2: added scaling for 8bpp and 15bpp bitmaps (fixes vmahjong and
    myfairld backgrounds)

Fixed sprite-sprite priorities in toaplan1 games. [Pierpaolo Prazzoli]

Fixed background color in Jolly Jogger. [Pierpaolo Prazzoli]

Made input port conditionals work more generically. This necessitated a bit
of a minor reorg in the input port code. Please verify that controls work as
before. This change has also required a modification to how analog ports are
recorded, so existing INPs may not work. [Aaron Giles]

Minor tweak to fix Time Crisis crash. [Phil Stroffolino]

Fixed spurious vectors in Top Gunner. [Mathis Rosenhauer]

Added new functions memory_configure_bank() and memory_set_bank() which
abstract bankswitching better. This allows current memory banking states to
automatically be saved for drivers that use this feature. m62.c games have
been updated to use this new feature as an example. [Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
World Trophy Soccer (Arcadia) [Mariusz Wojcieszek]
Funky Head Boxers [Mariusz Wojcieszek]
Pebble Beach - The Great Shot [Mariusz Wojcieszek]
Air Rescue [Anonymous]
Cuore Uno (Italia) [Roberto Fresca]
Elephant Family (Italia) [Roberto Fresca]
Royal Card (Austria) [Roberto Fresca]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
1000 Miglia: Great 1000 Miles Rally (94/06/13) [Corrado Tomaselli]
Frogger (Falcon bootleg) [Pierpaolo Prazzoli]

New games marked as GAME_NOT_WORKING
------------------------------------
Cookie and Bibi 3 [David Haywood]
Soccer Superstar ver EAA [Corrado Tomaselli]


==========================================================================

0.99u7

MAMETesters bugs fixed (there are probably more)
-----------------------
uccops062gre [Pierpaolo Prazzoli]
dynduke055gre [Curt Coder]
countryc087u4gra [Roberto Fresca]
analogconfig099u6 [Aaron Giles]
konami099u6red [Aaron Giles]
m92099u6red [Aaron Giles]
midvunit099u6red [Aaron Giles]
policetrc099u6red [Aaron Giles]
popupinfo099u6ora [Aaron Giles]
keyhold099u6gra [Aaron Giles]
ymsound099u6yel [Aaron Giles]


Source Changes
--------------

Removed gross cur_chip hack from the OPN emulator. [Aaron Giles]

Fixed crash when running games whose CPU core did not support save states.
[Aaron Giles]

Fixed interrupt timing in the F3 games. [Nicola Salmoria]

Fixed MNG recording size. [Mathis Rosenhauer]

Fixed colors in 8-Ball (Pac-Man hardware) [Steve Rice]

Improved emulation of the IC13 ROM loading in ST-V driver. Find Love, 
Decathlete, Sokyugurentai / Terra Diver can boot without hacks or debug 
tricks. Also Suikoenbu has improved gameplay. [Angelo Salese]

Added missing opcode 0 in leagueman_decryption_table (used in nbbatman).
[Pierpaolo Prazzoli]

Fixed Space Cruiser from resetting on the asteroids level when you die.
[Pierpaolo Prazzoli]

Fixed DIP switches in Space Position (Japan). [Roberto Fresca]

Fixed tilemap-tilemap drawing order in m92 driver. [Pierpaolo Prazzoli]

Fixed colors in Scooter Shooter. [Pierpaolo Prazzoli]

Fixed several bugs in the Namco System 22 sound system. [Cync]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Jolly Jogger [Pierpaolo Prazzoli]
Indian Battle [Tomasz Slanina]
Long Hu Bang [Luca Elia]
Chuugokuryuu [Luca Elia]
Champion List II [Luca Elia]
Xing Yen Man Guan (V638C) [Luca Elia]
Maru-Chan de Goo! [Angelo Salese]
Super Major League [Angelo Salese]
Sando-R [Angelo Salese]
Soukyugurentai / Terra Driver [Angelo Salese]
Suikoenbu [Angelo Salese]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Eliminator (2 Players, cocktail) [Mathis Rosenhauer]
Eliminator (4 Players, prototype) [Mathis Rosenhauer]
World Beach Volley (set 2) [Corrado Tomaselli]


==========================================================================

0.99u6

Source Changes
--------------

Fixed crash that was introduced with the state saving updates last time.
[Aaron Giles]

Finished renaming. Major changes this time: [Aaron Giles]
  struct mame_bitmap -> mame_bitmap
  struct rectangle   -> rectangle
  data8_t            -> UINT8
  data16_t           -> UINT16
  data32_t           -> UINT32
  data64_t           -> UINT64

Renamed pbchmp95.c driver to witch.c. [David Haywood]

Fixed some bad colors in spelunkr background. [Pierpaolo Prazzoli]

Fixed background position in hharry. [Pierpaolo Prazzoli]

Added discrete sound effects to Spiders. [Hans Andersson, Don Maeby]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Sharpshooter v1.1 [Brian Troha]
Shuffleshot (v1.40) [Brian Troha]


==========================================================================

0.99u5

MAMETesters bugs fixed (there are probably more)
-----------------------
docastle093u2ora [Corrado Tomaselli]
sindbadm37b2gre [Pierpaolo Prazzoli]
mgakuen094u1gra [Roberto Fresca]
tdfeverj087u4gra [Roberto Fresca]


Source Changes
--------------

Completed renaming of core structures. Most pervasive change was "struct
tilemap" is now just "tilemap". [Aaron Giles]

Added save state support to the Cinematronics vector games. [Buddabing]

Added blending to the alt tilemap code in psikyosh.c, fixing the final
boss in Sol Divide. [David Haywood]

Improvements to the Witch/Pinball Champ '95 driver: [Sebasten Hegon]
 * The games now show some graphics (the palette seems OK) and play some 
    music and sounds.
 * Since the controls are not yet figured out completely, they are still 
    mapped as dipswitches.
 * An NVRAM reset is required the first time you launch Witch (via the 
    associated dipswitch). Pinball Champ seems to automatically do this.
 * The sound part required some patching in sound/es8712.c. I disabled 
    the hardcoded inconditional looping, and made the sound start when 
    writing at offset 0x06 (cf patch). vmetal does not seem to be affected.
 * As far as gameplay is concerned, the ball will freeze (in game and 
    demo mode), and I don't know why. The video hardware is not completely 
    figured out and may be the culprit.
 * The coin in/out mecanism needs some work too.

Some improvements to Jolly Card: [Roberto Fresca]
 * Added extra hardware info (pinouts and dips).
 * Added the correct dipswitch to Jolly Card. Hopper and Points/pulse not 
    tested due to preliminary driver state. The rest are working properly.
    Remember to delete the nvram and reinitialize to see some changes.
 * Added almost the same dipswitch to Magic Card II (Bulgaria).

Significant changes to the save state system: [Aaron Giles]
 * Added alternate save state pre-/post-load function types that take
    integer or pointer parameters. Updated several sound cores and other 
    files to take advantage of this.
 * Made state handler registrations track like other scoped resources
    (timers, memory) so that registrations can occur as late as 
    MACHINE_INIT time.
 * Added logic to detect registrations after MACHINE_INIT time and prevent
    saves in that case.
 * Added logic to detect when CPUs or sound chips haven't registered 
    anything to save/load. When this happens, info is logged to error.log
    and saves/loads are disallowed.
 * Allocated timers are now automatically saved and restored as part of
    the save state. The global time is now restored as well as a bunch of
    CPU execution state. This should produce more reliable restores.
 * Added logic to defer saves until all anonymous timers have cleared. If 
    a driver uses many anonymous timers it may not be possible to ever 
    successfully save, so the operation will time out after one second.
 * Before restoring, the machine is now reset. This gives a more
    consistent environment for the load to occur.
 * Re-enabled save state support for YM2151.
 * Added save state support to the classic Namco sound system.
 * Added save state support to the samples sound system.
 * Removed anonymous timer usage in machine/scramble.c.


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Muroge Monaco [David Haywood]
The First Funky Fighter [Luca Elia]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
SAR - Search And Rescue (Japan) [Pierpaolo Prazzoli]
American Poker II (set 4) [Roberto Fresca]


==========================================================================

0.99u4

MAMETesters bugs fixed (there are probably more)
-----------------------
quarth37b1gre [Pierpaolo Prazzoli]
devilw36b10yel [Pierpaolo Prazzoli]
vulcan137b1gre, part 7 [Pierpaolo Prazzoli]


Source Changes
--------------

Added memory card and cheat menus back into the system. [Aaron Giles]

Fixed MNG recording problem that was introduced in u3. [Aaron Giles]

Fixed crash when running vector games that was introduced in u3.
[Aaron Giles]

Cleaned up/normalized the naming of several core structures in an
attempt to impose some order on coding conventions in the core code:
  struct InputPortDefinition   -> input_port_default_entry
  struct InputPort             -> input_port_entry
  struct RegionInfo            -> region_info
  struct RunningMachine        -> running_machine
  struct GameOptions           -> global_options
  struct GameDriver            -> game_driver
  struct InternalMachineDriver -> machine_config
  struct MachineCPU            -> cpu_config
  struct MachineSoundRoute     -> sound_route
  struct MachineSound          -> sound_config
  struct MachineSpeaker        -> speaker_config
  struct RomModule             -> rom_entry
  struct SystemBios            -> bios_entry
  struct GfxLayout             -> gfx_layout
  struct GfxElement            -> gfx_element
  struct GfxDecodeInfo         -> gfx_decode
Plus many others along the same lines (follow the pattern). Note that this
work is not yet complete. In addition, a few of the more pervasive structs 
(mame_bitmap, rectangle) will be left until a non-diff release (0.100).
[Aaron Giles]

Removed -skip_disclaimer since it automatically goes away after the first
time execution. [Aaron Giles]

Created new NMK112 ROM banking module and connected it up to a number of
drivers that made use of it. Affected games are in cave.c, nmk16.c, 
powerins.c, quizpani.c, toaplan2.c. [Alex W. Jackson]

Added missing buttons to Showdown. [David Widel]

Fixed the PULUW instruction on the 6309 disassembler. [Nathan Woods]

Fixed the state save facility play better on multisession ports if 
initialization fails. [Tim Lindner]


New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Plotting (US) [David Haywood]


==========================================================================

0.99u3

MAMETesters bugs fixed (there are probably more)
-----------------------
hanagumi082red [Mariusz Wojcieszek]
rtypeleo062gre [Pierpaolo Prazzoli]
labyrunr080u1gre [Pierpaolo Prazzoli]
tricktrp061gre [Pierpaolo Prazzoli]
gng37b4gre [Pierpaolo Prazzoli]
battlane076u2gre [Pierpaolo Prazzoli]


Source Changes
--------------

Updates to the ST-V driver: [Mariusz Wojcieszek]
 - vdp2: added rotation in RBG0 layer (improves diehard, vfkids,
         vfremix, thunt, sassisu backgrounds)
 - vdp2: added 15bit RGB tilemaps (used by thunt)
 - vdp2: added opaque alpha blended bitmaps (fixes missing gfx in
         shienryu intro)
 - vdp2: added enable bit for RGB sprites (fixes some bad sprites in
         vfremix)
 - vdp2: added alpha blending for RGB sprites
 - vdp1: fixed polygon drawing
 - vdp1: added line drawing
 - sh2:  fixed bug in division unit
 - sh2:  added callback called when cpu reads FTCSR register (intended
         for idle loop skipping for slave sh2 in stv)
 - stv:  added idle loop skipping for several games
 - dsp:  fixed dma (fixes some bad gfx in thunt)

Added dsp56k CPU core and hooked it up to the Polygonet Commanders
driver. [Andrew Gardner]

SCSI hard disk updates: [R. Belmont]
 - Added FORMAT UNIT, READ (6 byte), WRITE (6 byte), READ (12 byte), 
    MODE SENSE, and READ CAPACITY commands.
 - Changed INQUIRY to ID as a real Seagate model, which makes MacOS 
    much happier than a manufacturer code of "MAME".
 - Some MESS-specific tweeks to initialization.

Fixed all the volume table calculations in the YMF271 core. [Ville Linde]

SPI Improvements: [Ville Linde, Pierpaolo Prazzoli]
 - Added real coin inputs. The previously used coin input was service coin
 - Hooked up eeprom in rdft2us, rfjetus and rdft22kc

Fixed recent LSI53C810 update which caused the Model 3 games to crash.
[Ville Linde]

Fixed PowerPC recompiler so that Scud Race works again. [Ville Linde]

Significant overhaul of the user interface infrastructure: [Aaron Giles]
 - All user interface rendering is now cached until the end and rendered 
    in one pass.
 - A large number of extraneous and redundant functions have been removed 
    and replaced with a smaller set of more flexible APIs.
 - Global access to the UI fonts and colortables is now gone, they are 
    private to the user interface code.
 - All global user interface function names have been normalized. Most
    importantly, usrintf_showmessage is now ui_popup.
 - Pause behavior has been redefined; instead of sitting in a tight loop,
    the code proceeds normally, but the CPU execution system does not
    advance time.
 - Code for the menus has been reworked; some menus are temporarily not
    available (cheats, memory cards).

Removed the internal display of history.dat. Cramming this kind of data
into MAME's limited UI is not really useful, and viewing the history.dat
information is supported by many frontends and websites. [Aaron Giles]

Removed the following obsolete and/or redundant command line options from 
the Windows build: [Aaron Giles]
 -wrongorientation
 -wrongfps
 -gamelist
 -list
 -listgames
 -listdetails
 -listwrongmerge
 -listcpu
 -listcpuclass
 -listgamespersourcefile
 -listnosound
 -listnvram
 -listpalettesize
 -listromdistribution
 -listromnumber
 -listsound
 -listdupcrc
 -listsamdir
 -listmd5
 -listsha1
 -verifysets
 -vset
 -vsam
 -sortname
 -sortdriver
 -[no]clones
 -crconly
 -maxlogsize
 -resamplefilter
 -debug_resolution
 -history_file
 -mameinfo_file

Removed the "Press any key" prompts when displaying ROM warnings. Instead,
a warning about bad/missing ROMs is now displayed on the warnings screen.
Details of the bad/missing ROMs are still printed to the console.
[Aaron Giles]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Taisen Tanto-R Sashissu!! (J 980216 V1.000) [Mariusz Wojcieszek]
Tetris (Japan, System E) [David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
GTI Club (ver JAA) [Arzeno Fabrice]
Master of Weapon (US) [Arzeno Fabrice]
Sunset Riders (4 Players ver EAA) [Johan Samuelsson]

New games marked as GAME_NOT_WORKING
------------------------------------
Forte Card [David Haywood]
Jackpot Pool (Italy, bootleg) [David Haywood]


==========================================================================

0.99u2

Prior versions of MAME have excluded some drivers (primarily gambling-
related) for philosophical reasons. Since these games are legitimately at
risk of being lost to the ages, and many of them have strong similarities
to the other sorts of games MAME emulates, it has been decided to allow their
inclusion going forward. The criteria for inclusion in MAME is now simply
"any primarily video based arcade machine, driven by one of more CPUs," and
should relieve any confusion surrounding this issue going forward.


MAMETesters bugs fixed (there are probably more)
-----------------------
namcos1099u1red [Aaron Giles]
mcr3099u1yel [Aaron Giles]
zaxxon088u2gre [Derrick Renaud]
sprint1097gre [Derrick Renaud]
sdgndmps058gre [Pierpaolo Prazzoli]
gunforc2058gre [Pierpaolo Prazzoli]


Source Changes
--------------

More input port cleanup: [Aaron Giles]
 - Fixed input port handlers that used the port_tag_to_handler calls.
 - Simplified the reading/writing of input ports so they work more reliably.
 - Only write changed settings to the .cfg files.
 - Fixed saving of analog port configurations.

Updated to the latest zlib. [Atari Ace]

Added flipscreen to Pop Bingo. Added some disable registers for tilemaps/
sprites (fixing the bug in lastday demo). [Pierpaolo Prazzoli]

Fixed some video bugs in Party Time. [David Haywood]

Adjusted Namco CUS30 noise frequency. [BUT]

Fixed input ports in djmain. [BUT]

Several Konami improvements: [R. Belmont]
 - Added support for "external memory address" registers on the YMZ280B, 
    which can be used to read the contents of attached ROM or RAM.
 - Hooked up the mask ROM tests in the service menu - both the tile 
    character ROMS and the sound ROMs now can be tested.
 - Added secondary control register.
 - Hooked up IRQ control.
 - Renamed ROMs for both games to include PCB location information.

Some improvements to the DECO cassette games: [Juergen Buchmueller]
 - Treasure Island graphics ROMs (overlay board) mapped according to
    findings by debugging the game code.
 - Swapped image names for ctislnd2 and ctislnd3 to match the driver names;
    ctislnd3 is the not yet working set; removed IMPERFECT_GRAPHICS flag.
 - Found bitswap for Zeroize type #3 dongle; found hack to get it running w/o
    the dongle ROM by debugging the game code; changed year to 1983; removed
    NOT_WORKING flag.

SHARC/Model 2 updates: [Ville Linde]
 - Reworked the SHARC internal ram implementation so that multiple instances 
    of the core work.
 - Added data address space
 - Added coprocessor input and output FIFO's to Model 2.
 - Updated Konami zr107, gticlub, nwk-tr, hornet to work with the SHARC 
    changes

Seibu SPI improvements: [Ville Linde]
 - Fixed sprite priority issues
 - Added support for pen-based alpha to sprites and tilemaps. It's currently 
    using fixed alpha table for all games, but this seems to break some 
    games, so it probably isn't correct.

Fixed the discrete sound 555 timer modules when using actual DC mode. 
[Derrick Renaud]

Added low-frequency oscillator (LFO) to YMF271 emulator. [Ville Linde]

Improvements to the dcon driver: [Pierpaolo Prazzoli]
 - Fixed sprites - sprites priorities
 - Fixed sprites - tilemaps priorities
 - Added wrap around and flipy in sprites

Added MNG recording support (shift+F12 by default). [Mathis Rosenhauer]

Fixed 6309 division instructions overflow behavior on the HD6309.
[Tim Lindner]

Fixed more YMF271 issues: [Ville Linde]
 - The mix buffer pointer was not being reset between two 2-operator FM 
    sounds, causing missing sounds.
 - Fixed some bugs in the phase modulation of FM sounds


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Super Derby [David Haywood]
Champion Skill [Mirko Buffoni]
Pontoon (Tehkan) [Zsolt Vasvari]
Lovely Poker [Uki/El Condor]
Golden Star [Mirko Buffoni]
Jolly Card/Jolly Poker [Curt Coder, PeT]
Inter Game Poker [Curt Coder, PeT]
Magic Card II [Curt Coder, PeT]
Zeroize (casette) [Juergen Buchmueller]
Lucky Today [Curt Coder]
Chewing Gum [Curt Coder]
Royal Casino [Curt Coder]
Vegas Roulette [Curt Coder]
Jin [David Haywood]
Attack Ufo [Tomasz Slanina]

New games marked as GAME_NOT_WORKING
------------------------------------
Roulette (Playmark) [David Haywood]
Bubble Trouble [David Haywood]
American Poker II [Curt Coder]
Cherry Master [Curt Coder]
Cherry Master II v8.41 [Curt Coder]
Lucky 8 Lines [Curt Coder]
Starspinner [Curt Coder]
906III Video Poker [Curt Coder]


==========================================================================

0.99u1

MAMETesters bugs fixed (there are probably more)
-----------------------
medlanes061gre [MASH]


Source Changes
--------------

Undid a hack that was accidentally left in the MCR games in the last 
release. [Aaron Giles]

Fixed bug in spiders that caused bad video in cocktail mode.
[Hans Andersson]

Fixed several problems in the H8/3002 core. Improves sound in Namco System 
12 and ND-1. [cync]

Fixed sound banking in Go Go! Mile Smile. [Pierpaolo Prazzoli]

Major improvement to the YMF271 sound core: [Ville Linde]
 - Fixed timer A calculation
 - Fixed note pitch calculation
 - Added envelope generator
 - Added stereo panning and fixed other volume calculations
 - Added FM sound generation

Fixed crash in mystwarr games. [R. Belmont]

Figured out encryption key for Graplop (set 2). [MASH]

Rewrote the configuration reader/writer code to be more generic and easier
for other subsystems to plug into. This necessitated a rewrite of the way
the existing code reads config data. As a result, your game.cfg files will
be invalid after this update. Your default.cfg and existing controller-
specific .cfg files should work fine. [Aaron Giles]

Fixed all the mystwarr.c games so they pass their service mode mask ROM 
tests, with the exception of Metamorphic Force (it gets hung up on the road
generator ("LVC") test for some reason). [R. Belmont]

Fixed Monster Bash (2-board version) so it works now, though the graphics
are still not perfect. [David Haywood, MASH]

Turned off -fomit-frame-pointer in optimized builds. It was leading to 
crashes when used with setjmp/longjmp on Windows builds. [Aaron Giles]

Fixed tilemap priorities and sprites in Flying Tiger. [Pierpaolo Prazzoli]

Added green overlay to Meadows Lanes. [MASH]

Various improvements to the simple Deco 156 games: [David Haywood]
 - Modified video code to use the functions in deco16ic.c
 - Changed Osman to default to 3 buttons as per Guru's eeprom dump.

Namco System 22 update: [R. Belmont]
 - Hooked up MCU/CPU communications properly
 - The MCU now reads the controls in Prop Cycle, Alpine Racer, and 
    Cyber Cycles
 - Sound effects and music are now present in all Super System 22 games


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Lotto Fun 2 [Aaron Giles]
Pit Boss [Tomasz Slanina, Pierpaolo Prazzoli, Nicola Salmoria]
Trivia ? Whiz [Tomasz Slanina, Pierpaolo Prazzoli, Nicola Salmoria]
Tic Tac Trivia [Tomasz Slanina, Pierpaolo Prazzoli, Nicola Salmoria]
Phraze Craze [Tomasz Slanina, Pierpaolo Prazzoli, Nicola Salmoria]
Top Gunner [Mathis Rosenhauer]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Omni [Pierpaolo Prazzoli]


==========================================================================

0.99

Note that the next version of MAME will be 0.100. If you have code that
depends on there being only two digits after the decimal, you had better fix
it before then!


Source Changes
--------------

Fixed 1-bit errors in decryption keys for Crackdown and one of the D.D. Crew
sets. [Nicola Salmoria, Chris Hardy]

Hooked up NVRAM for World Class Bowling 1.40. [Brian Troha]

Backed out some of the Arm core changes which broke several games.

Fixed the f1superb sound rom loading in ms32.c so that it doesn't crash.
[David Haywood]

Fixed a graphics glitch in Osman. [David Haywood]

Updated the Taito Z driver: [Nicola Salmoria]
 - fixed road/sprite priority (cars no longer disappear when they go over a 
   hill in Continental Circus)
 - removed bogus contcirc ROM containing 1989 copyright year
 - added PROMs
 - other minor changes


==========================================================================

0.98u4

MAMETesters bugs fixed (there are probably more)
-----------------------
absoluteanalog098u2gra [Anssi]


Source Changes
--------------

Improvements to the MCR games: [Aaron Giles]
 - Hooked up cassette sample in Journey
 - Fixed sprite colors in Journey
 - Consolidated the MCR 1/2/3 drivers and documented all the PCBs

Added pause/resume support for sample playback. [Aaron Giles]

Bunch of changes/fixes to the deco156 drivers: [David Haywood]
 - hooked up EEPROM correctly
 - fixed sound ROM decoding and banking
 - fixed tile banking
 - fixed video priorities

Fixed unaligned 32-bit reads in the ARM core. [Tomasz Slanina]

Fixed several bugs in the ARM core which break Captain America but fix some
other issues. [Bryan McPhail]

Fixed sprite rendering in Double Wings. [David Haywood]

Fixed the question roms reading for Phraze Craze and fixed some loading based 
on new info discovered. [Pierpaolo Prazzoli]

Fixed sound effects in The Next Space. [MASH]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Double Cheese [Aaron Giles]
Chain Reaction [David Haywood]
Magical Drop [David Haywood]
Osman [David Haywood]
Super Triv [Pierpaolo Prazzoli]
Charlie Ninja [David Haywood]
Romar Triv [Pierpaolo Prazzoli]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Cannon Dancer (Japan) [David Haywood]
Cannonball set 2 [David Widel]

New games marked as GAME_NOT_WORKING
------------------------------------
Pit Boss [Pierpaolo Prazzoli]


==========================================================================

0.98u3

MAMETesters bugs fixed (there are probably more)
-----------------------
spidman098gre [Mamesick]
astormj098u1gra [Mamesick]
ehrgeiz097u4red [smf]
rdft2us098u2red [Ville Linde]
pc_bstar079u1yel [Mamesick]
playch10c080u1gre [Mamesick]
espial096u3gra [Mamesick]


Source Changes
--------------

Added step in/out support to the Z80 disassembler. [Aaron Giles]

Fixed subtle bug in ES5505/6 interpolation code. [Jarek Burczynski]

Some more minor fixes to System 32 sprites. [Aaron Giles]

Changed memory display in the debugger so that it doesn't lock to where the
cursor is. Also fixed it so that it can align against odd addresses.
[Aaron Giles]

Some minor cleanup to the Police Trainer driver. [Aaron Giles]

Some progress on Double Cheese, still not playable. [Aaron Giles]

Fixed some problems in Power Spikes bootleg. [Weisse Eins]

Fixed wrap around issue with sprites in the aerofgt driver. 
[Pierpaolo Prazzoli]

Fixed the sound banking in Raiden Fighters 2 - 2000. [Pierpaolo Prazzoli]

Fixed unknown DIP switch in SAR. [Corrado Tomaselli]

Fixed 4th player inputs and added 1 frame delay for sprites in goal92.
[Pierpaolo Prazzoli]

Added coin counter and fixed sound adding the 2 sample chips in Tecmo Bowl.
[Pierpaolo Prazzoli]

Cleaned up and fixed input ports for all games in the suprnova driver.
[Mamesick]

Fixed crash in MAME if 0-length data block was found in a WAV file.
[Roman Scherzer]

Changed the windows code so the map file isn't loaded unless the 
profiler is enabled. This stops you running out of memory when the memory 
tracking is enabled. [smf]

Fixed unknown DIP switches in Merlin's Money Maze. [James Wallace]

Corrected visible area in esckids. [Mamesick]

Improvements to the S2650 core: [Manfred Schneider]
 - Fixed LPSU opcode
 - Changed cycle counts to match technical documentation

Fully emulated deco 156 encryption. [David Haywood, Nicola Salmoria, 
Olivier Galibert, Bryan McPhail]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Joe & Mac Returns [David Haywood, R. Belmont]
Party Time: Gonta the Diver II [David Haywood]
Ganbare! Gonta!! 2 [David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
Enduro Racer (YM2203, FD1089B 317-0013A) [Aaron Giles]
E.D.F. : Earth Defense Force (North America) [Aaron Giles]


==========================================================================

0.98u2

MAMETesters bugs fixed (there are probably more)
-----------------------
pleiads061gre [MASH]
47pie2077gra [Mamesick]


Source Changes
--------------

Added new 'screen' parameter to the VIDEO_UPDATE callbacks. It is not
currently used but is a placeholder for the future. [Aaron Giles]

Replaced direct access to Machine->scrbitmap in the following drivers with
the use of force_partial_update(): m92.c, m107.c, astrocde.c, battlera.c,
snes.c. [Aaron Giles]

Rewrote the Z80/Z180 daisy chaining logic to work a little closer to the
hardware. Updated the Z80 CTC and PIO modules to support the new model.
Changed the CTC module to not generate interrupts if there is an outstanding
request on the same timer is currently in service; this allows Journey to 
(finally) run with the correct CPU speed. [Aaron Giles]

Partial rewrite of the MCR video system. Should still work roughly the same,
just a little different under the covers. This is still very much a work in
progress. [Aaron Giles]

Fixed clipping in nemesis.c. [Fujix]

Normalized names in Konami drivers according R. Belmont's wishes. [Mamesick]

More PowerPC updates: [Nathan Woods]
 - Moved update_counters() to be executed after the DRC epilogue code 
    is appended; now behaves more like the non-DRC core
 - Fixed some bugs in DRC exeception handling (SRR1 was not being set 
    up properly, and not all MSR flags were being cleared)
 - Refactored DRC core to call MMU hooks
 - ISI exceptions will now be thrown if the MMU hooks report an 
    unexecutable address in the DRC core
 - Fixed a rounding error in the decrementer
 - Added support for decrementer exceptions when the DEC register is 
    written to in both cores
 - Added support for ISI/DSI exceptions with setjmp()/longjmp() in 
    the non-DRC core

Significant rewrite of the Legend of Kage driver: [Phil Stroffolino]
 - correct/added dipswitches
 - converted to use pdrawgfx; affects stage#4
 - a priority effect on the title screen has been mapped - this gives the 
    foreground layer priority over all sprites, and screenshots now match 
    those from arcade flyers.
 - the "virtual palette" hack has been removed; it was an optimization from 
    back when we used 8 bit color and hardware palettes.

Cleaned up the Soungoku Mahjong driver, fixed colors, improved sound and 
fixed the hang before the match started. Also I found the output for the 
coins used to play the match. It's still missing something to enable / 
disable the tilemaps. [Pierpaolo Prazzoli]

Fixed the i386->z80 communication in the Seibu SPI driver. This fixes the 
flash rom update and should also fix any remaining hangs/pauses. The flash 
rom update should take around 5 minutes. Now all games should have proper 
sample data. [Ville Linda, David Haywood]

Some progress on the Deco 156 encryption. [David Haywood]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Mahjong Chuukanejyo [Luca Elia]
PK Scramble [David Haywood]

New clones supported or promoted from GAME_NOT_WORKING status
-------------------------------------------------------------
AmeriDarts (set 2) [Aaron Giles]
Flash Point (set 2) [Aaron Giles]
Line of Fire (US) [Aaron Giles]
Street Fighter Zero (Asia 950627) [Razoola]


==========================================================================

0.98u1

MAMETesters bugs fixed (there are probably more)
-----------------------
slither094u1red [Aaron Giles, with a hint from MASH]
sf2accp2070u5red [Aaron Giles]
nemesis097u1gre1 [Mamesick]
nemesis097u1gre2 [Mamesick]
karatblz137b4gre [Pierpaolo Prazzoli]
mystwarr098gre [Mamesick]
esckids076yel [David Haywood]
spyhunt097gre1 [Aaron Giles]
spyhunt097gre2 [Aaron Giles]
turbotag097u3gra [Aaron Giles]


Source Changes
--------------

Changed how perodic timers are defined. Previously, you would specify a
number which was interpreted either as Hz (if less than 50000) or as
nanoseconds (if greater than 50000). Now, the time is specified as a period
and you use the standard TIME_IN_HZ or TIME_IN_NS macros. [Aaron Giles]

Turned on address error checking in the 68000 core. This slows things down a
bit but is more accurate and allows correct behavior of a couple of badly-
programmed games. [Aaron Giles]

Fixed several issues with address error checking in the 68000 core.
[Aaron Giles]

Fixed 68000 bug that treated 8-bit branches with $FF offsets as illegal,
rather than allowing them and generating an address error. [Aaron Giles]

Created a new header file mamecore.h, which contains the core common useful
macros and typedefs that were scattered throughout the header files. Also
added endian swapping macros from MESS. [Aaron Giles]

Fully deprecated the use of cpu_setbank(), which was long ago replaced with
memory_set_bankptr(). [Aaron Giles]

Did some major cleanup on the MCR drivers [Aaron Giles]
- Implemented Super Sound I/O interrupts properly.
- Filled out all memory maps according to schematics.
- Fixed sound sync with various sound boards, allowing for kludges to be
  removed from Power Drive and Star Guards.
- Re-verified all connections from wiring diagrams.
- Documented various lamp and driver boards from the games.

Some makefile tweaks to hopefully catch variable declaration problems that
kept creeping into builds. Switched gcc compiler standard to gnu89.
[Atari Ace]

Removed usage of dirent.h APIs on Windows builds. [Atari Ace]

Corrected resolution to 256x256 in Stagger I, Red Hawk, Sen Jin - Guardian 
Storm. All other games still have old visible area that is correct for them.
[Mamesick]

Fixed crash in Volfied and Operation Wolf due to improper timer usage.
[Nicola Salmoria]

Fixed one of the TC360 sprite blending modes (used in Pulirula round 2 and 
Liquids Kids attract mode). [Bryan McPhail]

Fixed sprite/tilemap placement in Legend of Kage. [Phil Stroffolino]

PowerPC core update: [Nathan Woods]
- Added infrastructure to generate DSI and ISI exceptions
- Made the lbz/lbzu/lbzux/lbzx instructions properly clear out the 
  high 24 bits in the results
- Added SRR0 and SRR1 to the debug view

Did some cleanups in the vamphalf.c driver. [Pierpaolo Prazzoli]

Fixed speedbal again, after breaking it in the last update. 
[Pierpaolo Prazzoli]

Changed Nitro Ball to use the new deco16_tilemap_34_combine_draw function 
Bryan added some time ago. [Pierpaolo Prazzoli]

Added a sprite wrap around needed in Riot level 2. [Pierpaolo Prazzoli]

Added sound to Dragon Bowl. [Pierpaolo Prazzoli]


New games supported or promoted from NOT_WORKING status
-------------------------------------------------------
Born To Fight [Luca Elia]
Lethal Enforcers [David Haywood]
Koro Koro Quest (Japan) [Luca Elia]

